2017-12-06 Meghana R <meraghav@cisco.com>
Snort 2.9.11.1

	* sfeng/ims/sfsnort/snort/src/build.h : updating build number to 268

	* sfeng/ims/sfsnort/snort/: src/encode.c, src/reload.h,
	  src/sfdaq.c, src/dynamic-preprocessors/dcerpc2/dce2_co.c,
	  src/dynamic-preprocessors/dcerpc2/dce2_config.c,
	  src/dynamic-preprocessors/dcerpc2/dce2_smb.c,
	  src/dynamic-preprocessors/dcerpc2/dce2_smb2.c,
	  src/dynamic-preprocessors/dcerpc2/spp_dce2.c,
	  src/dynamic-preprocessors/sdf/spp_sdf.c,
	  src/preprocessors/spp_frag3.c, src/preprocessors/spp_session.c,
	  src/preprocessors/spp_sfportscan.c,
	  src/preprocessors/Stream6/snort_stream_ip.c,
	  src/preprocessors/Stream6/snort_stream_tcp.c, src/sfutil/acsmx.c,
	  src/sfutil/sfksearch.c, src/sfutil/sfportobject.c,
	  tools/u2spewfoo/u2spewfoo.c :
	  Fixed warnings when snort is compiled in OpenBSD with clang/llvm. Thanks to Markus Lude for noting the issue.

	* sfeng/ims/sfsnort/snort/src/dynamic-preprocessors/file/spp_file.c :
	  Fixed issue of applying new configuration in file inspection after snort reload.

	* sfeng/ims/sfsnort/snort/src/preprocessors/spp_session.c :
	  Added null check before accessing session cache.

	* sfeng/ims/sfsnort/snort/src/: appIdApi.h,
	  dynamic-preprocessors/appid/appIdApi.c :
	  Fixed issue where AppId was not setting HA flags correctly for unmonitored sessions.

	* sfeng/ims/sfsnort/snort/src/: snort.c,
	  dynamic-plugins/sf_dynamic_preprocessor.h, preprocessors/perf.c,
	  preprocessors/Stream6/snort_stream_icmp.c,
	  preprocessors/Stream6/snort_stream_ip.c,
	  preprocessors/Stream6/snort_stream_tcp.c,
	  preprocessors/Stream6/snort_stream_udp.c :
	  Fixed issue in compilation of snort with --disable-reload option. Thanks to BlueSky for noting the issue.

	* sfeng/ims/sfsnort/snort/src/dynamic-preprocessors/Makefile.am :
	  Fixed AppID compilation failure in OpenBSD platform.

	* sfeng/ims/sfsnort/snort/src/dynamic-preprocessors/appid/fw_appid.c :
	  Fixed issue to set correct flags when there is a need to ignore thirdparty detection for an SSL session.

	* sfeng/ims/sfsnort/snort/src/: event_wrapper.c, event_wrapper.h,
	  preprocessors/portscan.c :
	  Added support to block portscan. In addition to tracking the scanning packets, action(drop/sdrop/reject) will be taken for all the packets, which means snort will block the packet and generate logs.

	* sfeng/ims/sfsnort/snort/src/: obfuscation.c,
	  dynamic-preprocessors/appid/detector_plugins/detector_http.c,
	  dynamic-preprocessors/file/file_agent.c,
	  dynamic-preprocessors/file/file_inspect_config.c,
	  dynamic-preprocessors/sdf/sdf_us_ssn.c,
	  file-process/file_capture.c :
	  Fixed incorrect usage of bitwise-operator and removed dead code. Thanks to David Binderman for noting the issue and proposing the fix.

	* sfeng/ims/sfsnort/snort/: doc/snort_manual.pdf, src/snort.c,
	  src/dynamic-plugins/sf_dynamic_plugins.c,
	  src/dynamic-plugins/sf_dynamic_preprocessor.h,
	  src/dynamic-preprocessors/reputation/spp_reputation.c,
	  src/preprocessors/session_api.h, src/preprocessors/spp_session.c,
	  src/preprocessors/Session/session_common.h,
	  src/sfutil/sfPolicyData.h :
	  Added support to re-evaluate reputation after reputation update for all flows except those that have already been blacklisted.

	* sfeng/ims/sfsnort/snort/src/dynamic-preprocessors/appid/:
	  client_plugins/client_app_rtp.c, client_plugins/client_app_rtp.h :
	  Fixed issue to detect RTP upto two SSRC switches in each traffic direction.

	* sfeng/ims/sfsnort/snort/src/snort.c :
	  Added changes to reduce the number of session pruning when snort is idle.

	* sfeng/ims/sfsnort/snort/src/dynamic-preprocessors/ftptelnet/pp_ftp.c :
	  Fixed an issue related to setting of directory path when handling FTP sessions.

	* sfeng/ims/sfsnort/snort/src/snort_bounds.h :
	  Fixed an issue with the incorrect return in SafeSnprintf function.

	* sfeng/ims/sfsnort/snort/src/preprocessors/: snort_httpinspect.c,
	  HttpInspect/client/hi_client.c, HttpInspect/include/hi_client.h,
	  Stream6/snort_stream_tcp.c, Stream6/stream_paf.c :
	  Fixed issues related to HTTP POST header flushing, calling file processing directly if it is not a multipart header and changes to avoid expensive copy of segment data by not splitting them when flushing headers.

	* sfeng/ims/sfsnort/snort/src/dynamic-preprocessors/appid/detector_plugins/detector_sip.c :
	  Added changes to show missing session log message only when debugging mode is enabled.

	* sfeng/ims/sfsnort/snort/: doc/snort_manual.pdf,
	  src/preprocessors/portscan.c :
	  Fixed issue of triggering protocol sweep alert when there are multiple destinations from single source ip protocol scan.

	* sfeng/ims/sfsnort/snort/src/preprocessors/Stream6/snort_stream_tcp.c :
	  Fixed issue of correct session matching for TCP SYN packets without window scale option so that FTP data channels match the same rule as FTP control channels.

	* sfeng/ims/sfsnort/snort/src/: decode.c, preprocessors/portscan.c,
	  preprocessors/spp_frag3.c : 
	  Added changes to fix IP portscan for protocol other than ICMP and fixed issue of bad fragment size event not being generated for oversized packets.

	* sfeng/ims/sfsnort/snort/src/preprocessors/snort_httpinspect.c:
	  Added changes to use raw data in case of PDF and SWF files during file processing for SHA calculation and Malware Cloud Lookup.


2017-09-05 Meghana R <meraghav@cisco.com>
Snort 2.9.11

	* src/build.h : updating build number to 125.

	* src/preprocessors/: spp_session.c, Stream6/snort_stream_tcp.c :
	  Fixed issue with updation of global IPS id before packet processing.

	* src/output-plugins/spo_unified2.c : 
	  Added changes to display AppId for IPv6 unified events.

	* src/: dynamic-preprocessors/Makefile.am,
	  reload-adjust/appdata_adjuster.c,
	  sfutil/sfmemcap.c, sfutil/sfmemcap.h : 
	  Fixed dynamic preprocessor compilation failure in OpenBSD platform.

	* src/: parser.c, snort.h, detection-plugins/sp_replace.c : 
	  Fixed issues while parsing rules in snort reload path.

	* src/: appIdApi.h, dynamic-preprocessors/appid/appId.h,
	  dynamic-preprocessors/appid/appIdApi.c,
	  dynamic-preprocessors/appid/appIdConfig.h,
	  dynamic-preprocessors/appid/appInfoTable.c,
	  dynamic-preprocessors/appid/flow.h,
	  dynamic-preprocessors/appid/fw_appid.c,
	  dynamic-preprocessors/appid/hostPortAppCache.c,
	  dynamic-preprocessors/appid/hostPortAppCache.h :
	  Added implementation of hostPortCache versioning for unknown flows in AppID to detect and block BitTorrent.

	* src/preprocessors/spp_normalize.c :
	  Fixed incorrect usage of snort configuration in snort reload path.

	* src/dynamic-preprocessors/appid/: flow.c, flow.h, fw_appid.c : 
	  Fixed issues with printing of messages for out-of-order packets.

	* src/: mempool.c, mempool.h, reg_test.h, reload.c,
	  control/sfcontrol.c, control/sfcontrol.h,
	  preprocessors/spp_session.c,
	  preprocessors/Stream6/snort_stream_tcp.c : 
	  Added support for forced allocation of TCP protocol memory pool after maximum limit is reached.

	* src/reload.c :
	  Fixed synchronisation issue during snort reload.  

	* src/sfutil/: sf_ip.h, sf_ipvar.c, sf_ipvar.h :
	  Added changes to improve performance of ipvar list comparison.

	* src/: dynamic-output/plugins/output_lib.h,
	  dynamic-output/plugins/output_plugin.c,
	  dynamic-preprocessors/dcerpc2/dce2_smb.c,
	  dynamic-preprocessors/dcerpc2/dce2_smb.h,
	  dynamic-preprocessors/dcerpc2/dce2_smb2.c,
	  dynamic-preprocessors/dcerpc2/spp_dce2.c,
	  dynamic-preprocessors/file/file_event_log.c,
	  file-process/file_api.h, file-process/file_service.c,
	  file-process/file_stats.c, file-process/file_stats.h,
	  sfutil/sf_textlog.c, sfutil/sf_textlog.h : 
	  Added support for storing filenames in unicode format for SMB protocol.

	* src/dynamic-preprocessors/appid/detector_plugins/detector_smtp.c : 
	  Enhanced SMTP client detection by allowing line folding and all authentication methods.

	* src/: fpcreate.c, sfutil/sfthd.c, sfutil/sfxhash.c :
	  Fixed issue in detection filter counter when rule is used in multiple configurations.


2017-06-19 Meghana R <meraghav@cisco.com>
Snort 2.9.11 Beta

	*src/build.h : updating build number to 101

	* configure.in : 
	  Control-socket and side-channel support for FreeBSD platform.

	* src/snort.c :
	  Fixed an issue where snort did not exit gracefully on SIGHUP during the initialisation.
	  
	* src/detect.c : 
	  Added a data length check before copying into memory during application detection.
	 
	* doc/snort_manual.pdf,
	  src/dynamic-preprocessors/appid/appIdConfig.h,
	  src/dynamic-preprocessors/appid/appInfoTable.c,
	  src/dynamic-preprocessors/appid/commonAppMatcher.c,
	  src/dynamic-preprocessors/appid/fw_appid.c,
	  src/dynamic-preprocessors/appid/fw_appid.h,
	  src/dynamic-preprocessors/appid/hostPortAppCache.c,
	  src/dynamic-preprocessors/appid/hostPortAppCache.h,
	  src/dynamic-preprocessors/appid/luaDetectorApi.c :
	  Added new hostPortCache which can maintain runtime AppId entries.

	* src/preprocessors/perf-flow.c :
	  Added null check for individual sfFlow structure members.  

	* doc/snort_manual.tex : 
	  Fixed syntax error in snort_maual.tex

	* src/dynamic-preprocessors/appid/test/Makefile.am,
	  dynamic-preprocessors/dcerpc2/test/Makefile.am,
	  sfutil/test/Makefile.am : 
	  Linked librt library in appidd and dcerpc2 modules.

	* doc/snort_manual.pdf, doc/snort_manual.tex, src/decode.c,
          src/decode.h, src/detect.c, src/encode.c, src/reg_test.h,
          src/snort.c, src/snort.h, src/util.c, src/reload.c
          src/detection-plugins/sp_byte_math.c,
          src/dynamic-plugins/sf_engine/sf_snort_plugin_byte.c,
          src/dynamic-preprocessors/appid/appIdConfig.h,
          src/dynamic-preprocessors/appid/appInfoTable.c,
          src/dynamic-preprocessors/appid/commonAppMatcher.c,
          src/dynamic-preprocessors/appid/fw_appid.c,
          src/dynamic-preprocessors/appid/fw_appid.h,
          src/dynamic-preprocessors/appid/hostPortAppCache.c,
          src/dynamic-preprocessors/appid/hostPortAppCache.h,
          src/dynamic-preprocessors/appid/luaDetectorApi.c,
          src/dynamic-preprocessors/appid/detector_plugins/detector_sip.c,
          src/dynamic-preprocessors/appid/test/Makefile.am,
          src/dynamic-preprocessors/dcerpc2/dce2_smb2.c,
          src/dynamic-preprocessors/dcerpc2/dce2_smb2.h,
          src/dynamic-preprocessors/dcerpc2/spp_dce2.c,
          src/dynamic-preprocessors/dcerpc2/test/Makefile.am,
          src/dynamic-preprocessors/ftptelnet/pp_ftp.c,
          src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.c,
          src/dynamic-preprocessors/reputation/spp_reputation.c,
          src/dynamic-preprocessors/imap/spp_imap.c,
	  src/dynamic-preprocessors/pop/spp_pop.c,
	  src/dynamic-preprocessors/smtp/spp_smtp.c,
          src/file-process/file_api.h,
          src/file-process/file_segment_process.c,
          src/file-process/file_segment_process.h,
          src/file-process/file_service.c, src/preprocessors/perf-base.c,
          src/preprocessors/perf-flow.c,
          src/preprocessors/perf_indicators.c,
          src/preprocessors/snort_httpinspect.c,
          src/preprocessors/spp_session.c, src/preprocessors/spp_stream6.c,
          src/preprocessors/HttpInspect/server/hi_server.c,
          src/preprocessors/HttpInspect/utils/hi_cmd_lookup.c,
	  src/preprocessors/Session/session_expect.c,
          src/preprocessors/Stream6/snort_stream_tcp.c,
          src/reload-adjust/appdata_adjuster.c, src/sfutil/sfrf.c,
          src/sfutil/sfrf.h, src/sfutil/test/Makefile.am,
          src/sfutil/test/unit_hacks.c, src/target-based/sftarget_reader.c,
	  src/target-based/sftarget_reader.h :
	  Changes to eliminate Snort restart when there are changes to the memory 
	  allocated for preprocessors, by releasing unused or least recently used memory
	  when needed.

	* src/encode.c, dynamic-plugins/sf_engine/sf_snort_plugin_byte.c,
	  dynamic-preprocessors/ftptelnet/pp_ftp.c,
	  dynamic-preprocessors/ftptelnet/snort_ftptelnet.c,
	  preprocessors/perf-base.c, preprocessors/perf_indicators.c,
	  preprocessors/snort_httpinspect.c,
	  preprocessors/HttpInspect/utils/hi_cmd_lookup.c :
	  Fixed multiple issues reported by Coverity.

	* src/preprocessors/Stream6/: snort_stream_tcp.c : 
	  Added a null check before retrieving tcpssn for getting re-built packets.

	* src/dynamic-preprocessors/reputation/spp_reputation.c :
	  Fixed double free issue in reputation module.

	* src/detection-plugins/sp_byte_math.c,
	  file-process/file_service.c : 
	  Fixed Coverity Issue - added null check before usage.

	* src/dynamic-preprocessors/appid/fw_appid.c : 
	  Enhanced RTSP metadata parsing to match the user-agent field to detect RTSP traffic over Windows Media.

	* src/dynamic-preprocessors/appid/fw_appid.c :
	  Added a null check to prevent copy unless debugHostIp is configured in AppId.

	* src/decode.c, decode.h, detect.c, snort.h, util.c,
	  preprocessors/spp_session.c,
	  preprocessors/Stream6/snort_stream_tcp.c, sfutil/sfrf.c,
	  sfutil/sfrf.h : 
	  Performance improvement when SYN rate limit has reached and drop
	  is configured as next action.

	* src/preprocessors/HttpInspect/server/hi_server.c :
	  Fixed issue of uninitialised value before usage.

	* src/file-process/file_service.c : 
	  Fixed issue with SHA value display in File Events.

	* src/dynamic-preprocessors/appid/detector_plugins/detector_sip.c :
 	  Enhanced the processing of SIP/RTP future flows without ignoring them.
	  
	* src/preprocessors/snort_httpinspect.c : 
	  Changes made in PDF/SWF decompression by adding boundary to the size of the decompressed data.

	* src/preprocessors/Stream6/snort_stream_tcp.c : 
	  Fixed stream5 to flush out ACK'ed segments using PAF when session is terminating.

	* src/preprocessors/spp_session.c :
	  Fixed issue with associating router solicit/reply packets to a single session.

	* src/preprocessors/HttpInspect/server/hi_server_norm.c,
	  sfutil/util_utf.c : 
	  Fixed issues with normalisation of unicode HTML pages that do not have unicode encoding specifiers. 

	* src/appIdApi.h, dynamic-plugins/sf_dynamic_plugins.c,
	  dynamic-preprocessors/appid/appIdApi.c,
	  dynamic-preprocessors/appid/appIdConfig.h,
	  dynamic-preprocessors/appid/commonAppMatcher.c,
	  dynamic-preprocessors/appid/fw_appid.c,
	  dynamic-preprocessors/appid/fw_appid.h,
	  dynamic-preprocessors/appid/detector_plugins/detector_sip.c,
	  dynamic-preprocessors/appid/service_plugins/service_base.h,
	  dynamic-preprocessors/appid/service_plugins/service_ftp.c,
	  dynamic-preprocessors/appid/service_plugins/service_rexec.c,
	  dynamic-preprocessors/appid/service_plugins/service_rshell.c,
	  dynamic-preprocessors/appid/service_plugins/service_snmp.c,
	  dynamic-preprocessors/appid/service_plugins/service_tftp.c,
	  dynamic-preprocessors/appid/test/appIdTests.c : 
	  Fixed the issue in FTP active traffic by copying the flags as is when expected flow is in the same direction as current flow, reversing the flags when expected flow is in opposite direction and not copying the flags when expected flow's direction is unknown.

	* src/dynamic-plugins/sf_dynamic_plugins.c,
	  dynamic-preprocessors/dcerpc2/spp_dce2.c
	  Fixed issue of multiple allocation of ada cache in dcerpc2 module.

	* src/preprocessors/spp_httpinspect.c : 
	  Made changes to take care of boundary conditions after mempool allocation.

	* src/dynamic-preprocessors/appid/luaDetectorModule.c :
	  Fixed Coverity Issues - Removed logically dead duplicate code that does NULL check after creating a new luaState.

	* src/file-process/file_service.c,
	  preprocessors/Stream6/snort_stream_tcp.c : 
	  Fixed issue in file signature lookup for retransmitted FTP packet.

	* src/output-plugins/spo_log_buffer_dump.c :
	  Changes to free HTTP buffers not used during processing.

	* src/dynamic-plugins/sf_dynamic_plugins.c,
	  dynamic-preprocessors/dcerpc2/spp_dce2.c,
	  dynamic-preprocessors/dnp3/spp_dnp3.c,
	  dynamic-preprocessors/sip/sip_config.c,
	  dynamic-preprocessors/sip/spp_sip.c,
	  reload-adjust/appdata_adjuster.c,
	  reload-adjust/appdata_adjuster.h :
	  Fixed issues in SIP related to reallocation of the same data structure multiple times and accessing numSessions which is asynchronously written by packet processing thread.
	
	* src/dynamic-preprocessors/dcerpc2/spp_dce2.c :
	  Added multiple null checks in dcerpc2 module.

	* src/dynamic-preprocessors/dnp3/spp_dnp3.c,
	  reload-adjust/appdata_adjuster.c,
	  reload-adjust/appdata_adjuster.h :
	  Added null pointer checks in DNP3CheckConfig.
	  
	* src/preprocessors/spp_session.c :  
	  Fixed Coverity issue - added null check before usage.
	  
        * src/build.h : updating build number to 42

        * src/snort.c :
          Trigger Snort restart when `config disable-attribute-reload-thread` is
	  turned on/off.

        * src/preprocessors/Stream6/snort_stream_tcp.c :
          Fixed detection issue where wrong file signature calculation
          was done for secure-ftp.
     
        * src/dynamic-preprocessors/ftptelnet/: ftpp_si.c, ftpp_si.h,
          pp_ftp.c :
          Fixed incorrect referencing of ftp_data_session after its pruned.

        * src/dynamic-preprocessors/appid/fw_appid.c : 
          Stability improvement by resolving valgrind reported issues in AppId.

        * src/dynamic-preprocessors/ftptelnet/pp_ftp.c,
          file-process/file_api.h, file-process/file_resume_block.h,
          file-process/file_service.c, preprocessors/Session/session_common.h,
          Session/session_expect.c, Stream6/snort_stream_tcp.c,
          Stream6/snort_stream_tcp.h, Stream6/stream_common.h, parser.c,
          parser.h, snort.c, snort.h, dynamic-preprocessors/dcerpc2/dce2_smb.c,
          dynamic-preprocessors/ftptelnet/ftpp_si.h,
          dynamic-preprocessors/ftptelnet/snort_ftptelnet.c,
          dynamic-preprocessors/ftptelnet/snort_ftptelnet.h,
          file-process/file_mime_process.c, file-process/libs/file_lib.c,
          preprocessors/snort_httpinspect.c, preprocessors/spp_normalize.c,
          preprocessors/spp_normalize.h, preprocessors/spp_stream6.c,
          preprocessors/stream_api.h, preprocessors/HttpInspect/client/hi_client.c : 
          Fixed issue where FTP file type block doesn't work on retried download.

        * src/appIdApi.h, dynamic-plugins/sf_dynamic_plugins.c,
          dynamic-preprocessors/appid/appIdApi.c,
          dynamic-preprocessors/appid/flow.c,
          dynamic-preprocessors/appid/flow.h,
          dynamic-preprocessors/appid/fw_appid.c,
          dynamic-preprocessors/appid/fw_appid.h,
          dynamic-preprocessors/appid/detector_plugins/detector_sip.c :
          Fixed issue where Snort is inappropriately handling traffic for which AppId
          was creating future flow.

        * src/file-process/file_segment_process.c :
          Fixed issue of updating the file session information for SMB2 file transfer
	  spanning multiple TCP sessions.
        
        * src/dynamic-preprocessors/appid/: flow.h, fw_appid.c,
          luaDetectorApi.c, service_state.c, service_state.h,
          detector_plugins/detector_dns.c,
          detector_plugins/detector_http.c,
          detector_plugins/detector_imap.c,
          detector_plugins/detector_kerberos.c,
          detector_plugins/detector_pattern.c,
          detector_plugins/detector_pop3.c,
          detector_plugins/detector_sip.c,
          detector_plugins/detector_smtp.c, service_plugins/service_MDNS.c,
          service_plugins/service_api.h, service_plugins/service_base.c,
          service_plugins/service_base.h,
          service_plugins/service_battle_field.c,
          service_plugins/service_bgp.c, service_plugins/service_bit.c,
          service_plugins/service_bootp.c,
          service_plugins/service_dcerpc.c,
          service_plugins/service_direct_connect.c,
          service_plugins/service_flap.c, service_plugins/service_ftp.c,
          service_plugins/service_irc.c, service_plugins/service_lpr.c,
          service_plugins/service_mysql.c,
          service_plugins/service_netbios.c,
          service_plugins/service_nntp.c, service_plugins/service_ntp.c,
          service_plugins/service_radius.c,
          service_plugins/service_rexec.c, service_plugins/service_rfb.c,
          service_plugins/service_rlogin.c, service_plugins/service_rpc.c,
          service_plugins/service_rshell.c,
          service_plugins/service_rsync.c, service_plugins/service_rtmp.c,
          service_plugins/service_snmp.c, service_plugins/service_ssh.c,
          service_plugins/service_ssl.c, service_plugins/service_telnet.c,
          service_plugins/service_tftp.c,
          service_plugins/service_timbuktu.c,
          service_plugins/service_tns.c, test/appIdTests.c,
          test/sessionFile.c :
          Changes in AppId discovery to address session and services related issues.

        * src/dynamic-preprocessors/appid/: appId.h, fw_appid.c :
          Performance improvements for SIP/RTP audio and video data flow in AppId .

        * src/dynamic-preprocessors/appid/: fw_appid.c,
          thirdparty_appid_utils.c, test/appIdTests.c, test/externalApis.c :
          Fixed an issue related to incorrect processing of XFF addresses during 
          Snort reload.

        * src/dynamic-preprocessors/appid/luaDetectorModule.c :
          Improved error handling in luadetector when lua_State object is NULL.

        * src/preprocessors/snort_httpinspect.c :
          Improved flushing mechanism for HTTP POST header. 

        * src/output-plugins/spo_log_buffer_dump.c :
          Fixed an issue where HTTP buffers were incorrectly dumped as 
          DNS payload buffers.

        * src/preprocessors/Stream6/snort_stream_tcp.c : 
          Prevent application preprocessors from processing packets having end_sequence
          numbers less than current TCP window base.


2016-11-07 Gagan Sachdeva <gagsachd@cisco.com>
Snort 2.9.9.0

        * src/build.h : updating build number to 56.

        * tools/u2spewfoo/u2spewfoo.c :
          src/snort.c, win32/WIN32-Includes/config.h :
          Fixed Issue related to DLL-Load in Snort on Windows platforms For CVE-2016-1417, thanks to Secureworks for 
          reporting this issue.

        * src/: detection_filter.c, detection_filter.h, fpdetect.c,
          detection-plugins/detection_options.c,
          detection-plugins/detection_options.h, sfutil/sfthd.c,
          sfutil/sfthd.h, sfutil/test/sfthd_test.c : 
          Incrementing detection_filter count on either raw packets or re-assembled packets but not on both.

        * src/detection-plugins/sp_byte_jump.c : 
          Fixed an issue where value present in the zero index of byte_extract array was incorrectly used when 
          byte_extract rule option is not present.


2016-09-08 Seshaiah Erugu <serugu@cisco.com>
Snort 2.9.9

        * src/build.h : Updated build number to 82.

        * src/dynamic-preprocessors/appid/: appId.h, fw_appid.c, spp_appid.c:
          Improved handling of HTTP tunneling in AppId.

        * src/detection-plugins/sp_byte_jump.c:
          Fixed a bug where byte_jump postoffset was incorrectly initialized leading
          to failure in rule matching in some scenarios.

        * src/detection-plugins/sp_rpc_check.c:
          Fixed RPC decode plugin issue where rule context was missing and RPC
          values were not read correctly.

        * sfeng/ims/sfsnort/snort/src/dynamic-preprocessors/smtp/snort_smtp.c :
          Fixed an issue in mime data processing in case of stateless inspection.

        * sfeng/ims/sfsnort/snort/src/preprocessors/: spp_session.c,
          Stream6/stream_paf.c :
          Addressed incorrect flushing of packets whose size is greater than MAXIMUM_PAF_MAX.

        * sfeng/ims/sfsnort/snort/src/output-plugins/spo_log_buffer_dump.c :
          Added banner message with packet timestamp for every buffer dump.

        * sfeng/ims/sfsnort/snort/src/: snort.h,
          dynamic-preprocessors/dcerpc2/dce2_paf.c,
          dynamic-preprocessors/dnp3/dnp3_paf.c,
          dynamic-preprocessors/ftptelnet/snort_ftptelnet.c,
          dynamic-preprocessors/imap/imap_paf.c,
          dynamic-preprocessors/modbus/modbus_paf.c,
          dynamic-preprocessors/modbus/modbus_paf.h,
          dynamic-preprocessors/pop/pop_paf.c,
          dynamic-preprocessors/sip/sip_paf.c,
          dynamic-preprocessors/smtp/smtp_paf.c,
          preprocessors/snort_httpinspect.c, preprocessors/spp_stream6.c,
          preprocessors/stream_api.h,
          preprocessors/HttpInspect/client/hi_client.c,
          preprocessors/HttpInspect/utils/hi_paf.c,
          preprocessors/Stream6/snort_stream_tcp.c,
          preprocessors/Stream6/stream_paf.c,
          preprocessors/Stream6/stream_paf.h :
          Generating an event when content-length in a POST request is greater than Payload.

        * sfeng/ims/sfsnort/snort/src/decode.c :
          Decoding support for packets that contain VLAN and SGT.

        * sfeng/ims/sfsnort/snort/src/preprocessors/HttpInspect/client/hi_client.c :
          Fixed Coverity issue - added null check before usage.

        * sfeng/ims/sfsnort/snort/src/preprocessors/snort_httpinspect.c :
          Fixed Coverity issue - added null check for Field_Name.

        * sfeng/ims/sfsnort/snort/src/preprocessors/Stream6/snort_stream_tcp.c :
          Fixed an issue where out-of-bounds memory access (is possible) due to incorrect length argument in memcpy.

        * sfeng/ims/sfsnort/snort/src/preprocessors/spp_stream6.c :
          Resolved an issue where stream_config is not set (to) correct value in some cases after reload.

        * sfeng/ims/sfsnort/snort/src/file-process/:
          file_segment_process.c, file_service.c :
          Changes done to avoid memory allocation for each signature callback and handle
          segments properly when file session has not been created yet.

        * sfeng/ims/sfsnort/snort/preproc_rules/preprocessor.rules :
          Added new http prepreocessor alert for multiple content encoding.
          alert ( msg: "HI_SERVER_MULTIPLE_CONTENT_ENCODING"; sid:20; gid: 120; rev: 1; metadata: rule-type preproc ; classtype:unknown; ).

        * sfeng/ims/sfsnort/snort/src/dynamic-preprocessors/appid/fw_appid.c :
          Changes done to handle empty HTTP XFF field.

        * sfeng/ims/sfsnort/snort/src/dynamic-preprocessors/appid/service_plugins/service_base.c :
          Changed initiator_ip to be in sync with other ip's.

        * sfeng/ims/sfsnort/snort/src/dynamic-preprocessors/appid/fw_appid.c :
          Fixed an issue where AppId was skipping inspection of some HTTP requests.

        * sfeng/ims/sfsnort/snort/src/dynamic-plugins/sf_dynamic_plugins.c :
          Fixed compiler warning by changing the definition of dummyConsumeHAState() function.

        * sfeng/ims/sfsnort/snort/src/dynamic-preprocessors/appid/:
          fw_appid.c, detector_plugins/detector_smtp.c :
          Fixed AppId compilation warnings.

        * sfeng/ims/sfsnort/snort/src/: parser.c, parser.h, snort.c,
          snort.h, preprocessors/spp_normalize.c,
          preprocessors/spp_normalize.h, preprocessors/spp_stream6.c,
          preprocessors/stream_api.h,
          preprocessors/Session/session_common.h,
          preprocessors/Session/session_expect.c,
          preprocessors/Stream6/snort_stream_tcp.c :
          Fixed an issue where Malware files not getting dropped over FTP protocol.

        * sfeng/ims/sfsnort/snort/src/dynamic-preprocessors/appid/appInfoTable.c :
          Fixed issue with using dynamic app ID names (not in appMapping.data) in Snort rules.

        * sfeng/ims/sfsnort/snort/src/preprocessors/HttpInspect/utils/hi_paf.c :
          Handling HTTP header line containing \r or \r\r.

        * sfeng/ims/sfsnort/snort/src/dynamic-preprocessors/appid/: flow.h,
          fw_appid.c, thirdparty_appid_types.h :
          Performance improvement in Appid.

        * sfeng/ims/sfsnort/snort/src/: file-process/file_service.c,
          preprocessors/snort_httpinspect.c,
          preprocessors/snort_httpinspect.h :
          Added support to detect partial content when it starts in second reassembled packet.

        * sfeng/ims/sfsnort/snort/src/preprocessors/: snort_httpinspect.c,
          snort_httpinspect.h, HttpInspect/client/hi_client.c
          HTTP preprocessor enhanced to handle the split of chunk length itself across different packets.

        * sfeng/ims/sfsnort/snort/src/decode.c :
          Fixed an issue where single packet can cause a segmentation fault if there is a specific
          snort rule is in place. Thanks to Marcel da Silva for reporting this issue.

        * sfeng/ims/sfsnort/snort/src/decode.c :
          Fixed an issue where incorrect byte order was been used for comparision with hard coded value.
          Thanks to Al Lewis who reported this issue on open source.

        * sfeng/ims/sfsnort/snort/src/preprocessors/: spp_session.c,
          spp_stream6.c, Session/session_common.h,
          Stream6/snort_stream_tcp.c :
          This patch changes the logic in session to set a flag in the SCB
          for a flow on the first packet after a reload to indicate the
          stream config pointer is stale.  Previously the pointer was set
          to NULL. Stream was changed to check this stale flag and, if true,
          the stream config pointer in the SCB is reinitialized.
          With this change the stream configuration pointer continues to
          point to the old configuration which will still be valid until
          the stream preproc runs.  This ensures that the part of the SSL
          preproc that runs before Session/Stream have run will have a
          valid stream config pointer after a reload.
          In addition the StreamActivatePafTcp function, which is called by
          the SSL preproc and requires a valid stream configuration, was
          changed to check for the pointer being NULL and if it is it will
          reinitialize the pointer to valid value and log a warning
          message.

        * sfeng/ims/sfsnort/snort/doc/snort_manual.tex :
          Snort manual updated with Buffer dump feature.

        * sfeng/ims/sfsnort/snort/doc/snort_manual.tex :
          Snort manual changed with Rule Options Enhancement.

        * sfeng/ims/sfsnort/snort/src/sfutil/sfghash.c :
          Added NULL check for SFGHASH.

        * sfeng/ims/sfsnort/snort/etc/sf_rule_options :
          Error message is updated for byte_extract options.
          When creating a rule with byte_extract option an error message is sent
          when the rule doesn't include a variable name, which is mandatory.

        * sfeng/ims/sfsnort/snort/src/: encode.c, preprocids.h,
          detection-plugins/sp_byte_math.c,
          dynamic-output/plugins/output_lib.h,
          dynamic-preprocessors/ftptelnet/pp_ftp.c,
          preprocessors/perf-base.c, preprocessors/snort_httpinspect.c,
          preprocessors/spp_stream6.c,
          preprocessors/HttpInspect/server/hi_server.c, sfutil/sf_ip.h,
          win32/WIN32-Prj/snort.dsp :
          Addressed issues in Snort Windows build.

        * sfeng/ims/sfsnort/snort/src/detection-plugins/: sp_byte_check.c,
          sp_byte_jump.c, sp_byte_math.c :
          An error message is sent if string rule option is not present
          when bytes to grab are greater than 4 bytes in byte_math rule.

        * sfeng/ims/sfsnort/snort/src/preprocessors/Stream6/snort_stream_tcp.c :
          Resolved an incorrect logging of source and destination ip when TCP stream queue is full.

        * sfeng/ims/sfsnort/snort/src/detection-plugins/sp_byte_math.c :
          Error message is updated for byte_math options.
          When creating a rule with byte_math option an error message is sent
          when the rule doesn't include offset and rvalue.

        * sfeng/ims/sfsnort/snort/src/dynamic-preprocessors/appid/:
          Makefile_defs, fw_appid.c, client_plugins/client_app_base.c,
          client_plugins/client_app_smtp.c,
          client_plugins/client_app_smtp.h,
          detector_plugins/detector_base.c,
          detector_plugins/detector_smtp.c, service_plugins/service_base.c,
          service_plugins/service_smtp.c, service_plugins/service_smtp.h :
          Added SMTP detection to AppID, added detector_smtp.c file as part of this enhancement.

2016-05-12 Seshaiah Erugu <serugu@cisco.com>
Snort 2.9.9 Beta

        * src/build.h : Updated build number to 4065.

        * src/dynamic-preprocessors/appid/fw_appid.c :
          Fix for handling bogus client AppIds for AppleCoreMedia.

        * src/preprocessors/spp_arpspoof.c :
          Added 802.11/wifi header support in ARP Preprocessor.

        * src/: detect.c, dynamic-plugins/sf_engine/sf_snort_packet.h,
          preprocessors/session_api.h,
          preprocessors/Stream6/snort_stream_tcp.c :
          Changed RST handling on closed tcp connection.

        * src/dynamic-preprocessors/appid/appInfoTable.c :
          Fixed a compilation issue in AppId.

        * src/: appIdApi.h, dynamic-preprocessors/appid/appIdApi.c,
          dynamic-preprocessors/appid/flow.h,
          dynamic-preprocessors/appid/fw_appid.c,
          dynamic-preprocessors/appid/httpCommon.h,
          dynamic-preprocessors/appid/luaDetectorApi.c,
          dynamic-preprocessors/appid/thirdparty_appid_types.h,
          dynamic-preprocessors/appid/detector_plugins/detector_http.c,
          dynamic-preprocessors/appid/detector_plugins/detector_http.h :
          Added support for Host, User-Agent, and Referer fields to be rewritten.

         * src/dynamic-preprocessors/appid/: appIdApi.c, appInfoTable.h,
          fw_appid.c, luaDetectorApi.c, detector_plugins/detector_http.c,
          service_plugins/service_ftp.c, service_plugins/service_tftp.c :
          Fixed AppId compilation warnings.

        * src/preprocessors/Session/stream5_ha.c :
          Fix updates HA sf_base counters during failover.
        
        * src/dynamic-preprocessors/appid/fw_appid.c,
          src/dynamic-preprocessors/appid/: appId.h :
          Fix Reconstructed the call to port-service detection.

        * src/dynamic-preprocessors/appid/test/appIdTests.c :
          Fixed an AppId compilation issue.

         * src/dynamic-preprocessors/appid/appId.h :
          Revised appid.h to have APP_ID_ICMP and APP_ID_ICMPV6.

        * src/dynamic-preprocessors/appid/: httpCommon.h, luaDetectorApi.c,
          detector_plugins/detector_http.c :
          Added DEFER_TO_SIMPLE_DETECT action to CHPAddAction.

        * src/preprocessors/HttpInspect/: event_output/hi_eo_log.c,
          New HTTP prepocessor alert added for Multiple content encodings.

        * src/preprocessors/Stream6/snort_stream_tcp.c :
          Fix populates DAQ_PktHdr_t of the packet generated while flushing queued
          segments with src and dst IP's.

        * src/preprocessors/HttpInspect/: client/hi_client.c,
          event_output/hi_eo_log.c, include/hi_eo_events.h,
          server/hi_server.c :
          New HTTP preprocessor alert added for multiple content lengths.

        * src/dynamic-preprocessors/appid/: fw_appid.c,
          service_plugins/service_rshell.c :
          Fix reduces extra service discovery to improve performance.

        * src/preprocessors/HttpInspect/client/hi_client.c :
          Fix to handle chunk encoding followed by \r\r\r\n and \n\n\n\r\r\n.
          This issue was reported by Steffen Ullrich.

        * src/: detection_filter.c, detection_filter.h, fpdetect.c,
          detection-plugins/detection_options.c,
          detection-plugins/detection_options.h, sfutil/sfthd.c,
          sfutil/sfthd.h, sfutil/test/sfthd_test.c :
          Fix related to detection_options.
          Added a new variable detection_filter_count to detection_option_eval_data_t
          data structure and set it when detection_filter_test is called for first time.

        * src/dynamic-preprocessors/appid/: fw_appid.c, test/appIdTests.c :
          Fix picks last IP address in XFF address list.
        * src/decode.c :
          Added an additional check for divisibility of the length of the PGM header by 4.
          If it's not, then an error is returned instead of calculating the checksum.

        * src/dynamic-preprocessors/appid/fw_appid.c :
          Changed ignore tp appid logic.

        * src/preprocessors/HttpInspect/server/hi_server.c :
          File filled with delimiters now successfully gets detected.

        * src/dynamic-preprocessors/appid/service_plugins/service_ftp.c :
          Fix ignores text after FTP response codes.

        * src/preprocessors/HttpInspect/server/hi_server.c :
          Modified Http header parsing of multiline content-encoding header.

        * src/: appIdApi.h, dynamic-preprocessors/appid/appIdApi.c,
          dynamic-preprocessors/appid/appInfoTable.h,
          dynamic-preprocessors/appid/flow.h,
          dynamic-preprocessors/appid/fw_appid.c,
          dynamic-preprocessors/appid/luaDetectorApi.c,
          dynamic-preprocessors/appid/detector_plugins/detector_http.c :
          Made changes in getHttpSearch() to return value based on any payloadAppId match,
          not just CHP patterns.

        * src/preprocessors/: snort_httpinspect.c,
          HttpInspect/server/hi_server.c :
          Fixed Coverity issue - Unsigned compared against 0.

        * src/preprocessors/: snort_httpinspect.c,
          HttpInspect/server/hi_server.c :
          Improved chunked gzip content handling.

        * src/: dynamic-preprocessors/sdf/spp_sdf.c, obfuscation.c :
          Fix to mask sensitive data spanning multiple raw packets.

        * src/sfutil/sfghash.c :
          Added NULL pointer checks to all the functions in sfghash.c.

        * src/preprocessors/spp_httpinspect.c :
          Fix Sets file_depth after Snort reload.


        * src/dynamic-preprocessors/appid/: fw_appid.c, httpCommon.h,
          luaDetectorApi.c, detector_plugins/detector_http.c,
          detector_plugins/detector_http.h :
          Fix allows multiple key patterns per AppId instance in CHPMultiAddAction().

        * src/preprocessors/HttpInspect/files/file_decomp_SWF.c :
          Fixed an issue with LZMA flash decompression.

        * etc/sf_rule_options, src/detection-plugins/sp_byte_extract.c,
          src/detection-plugins/sp_byte_extract.h :
          Changed code to allow 1 to 10 bytes (bytes_to_extract )values in byte_extract rule.

        * configure.in, doc/snort_manual.tex, etc/snort.conf,
          rpm/snort.spec, src/dynamic-plugins/sf_dynamic_meta.h,
          src/dynamic-plugins/sf_engine/examples/detection_lib_meta.h,
          src/win32/WIN32-Includes/config.h,
          src/win32/WIN32-Prj/snort_installer.nsi :
          API version updated.

        * src/dynamic-preprocessors/appid/fw_appid.c :
          Fix prevents bogus generic clients, and also prevents things like "MPEG"
          showing up as a client in case of AppleCoreMedia.

        * src/detection-plugins/sp_byte_jump.c :
          Now from_end option acccepts 0-10 bytes in byte_jump rule.

        * src/dynamic-preprocessors/appid/: fw_appid.c, httpCommon.h :
          Added more AppId instances for CHPMultixxx Lua api.

         * configure.in, src/appIdApi.h, src/sfdaq.c, src/sfdaq.h,
          src/tag.c, src/dynamic-plugins/sf_dynamic_plugins.c,
          src/dynamic-preprocessors/appid/appIdApi.c,
          src/dynamic-preprocessors/appid/flow.c,
          src/dynamic-preprocessors/appid/flow.h,
          src/dynamic-preprocessors/appid/fw_appid.c,
          src/dynamic-preprocessors/appid/fw_appid.h,
          src/dynamic-preprocessors/appid/luaDetectorApi.c,
          src/dynamic-preprocessors/appid/luaDetectorApi.h,
          src/dynamic-preprocessors/appid/luaDetectorFlowApi.c,
          src/dynamic-preprocessors/appid/client_plugins/client_app_aim.c,
          src/dynamic-preprocessors/appid/client_plugins/client_app_base.c,
          src/dynamic-preprocessors/appid/client_plugins/client_app_bit.c,
          src/dynamic-preprocessors/appid/client_plugins/client_app_bit_tracker.c,
          src/dynamic-preprocessors/appid/client_plugins/client_app_msn.c,
          src/dynamic-preprocessors/appid/client_plugins/client_app_rtp.c,
          src/dynamic-preprocessors/appid/client_plugins/client_app_smtp.c,
          src/dynamic-preprocessors/appid/client_plugins/client_app_ssh.c,
          src/dynamic-preprocessors/appid/client_plugins/client_app_timbuktu.c,
          src/dynamic-preprocessors/appid/client_plugins/client_app_tns.c,
          src/dynamic-preprocessors/appid/client_plugins/client_app_vnc.c,
          src/dynamic-preprocessors/appid/client_plugins/client_app_ym.c,
          src/dynamic-preprocessors/appid/detector_plugins/detector_dns.c,
          src/dynamic-preprocessors/appid/detector_plugins/detector_http.c,
          src/dynamic-preprocessors/appid/detector_plugins/detector_imap.c,
          src/dynamic-preprocessors/appid/detector_plugins/detector_kerberos.c,
          src/dynamic-preprocessors/appid/detector_plugins/detector_pattern.c,
          src/dynamic-preprocessors/appid/detector_plugins/detector_pop3.c,
          src/dynamic-preprocessors/appid/detector_plugins/detector_sip.c,
          src/dynamic-preprocessors/appid/service_plugins/service_MDNS.c,
          src/dynamic-preprocessors/appid/service_plugins/service_api.h,
          src/dynamic-preprocessors/appid/service_plugins/service_base.c,
          src/dynamic-preprocessors/appid/service_plugins/service_base.h,
          src/dynamic-preprocessors/appid/service_plugins/service_battle_field.c,
          src/dynamic-preprocessors/appid/service_plugins/service_bgp.c,
          src/dynamic-preprocessors/appid/service_plugins/service_bit.c,
          src/dynamic-preprocessors/appid/service_plugins/service_bootp.c,
          src/dynamic-preprocessors/appid/service_plugins/service_dcerpc.c,
          src/dynamic-preprocessors/appid/service_plugins/service_direct_connect.c,
          src/dynamic-preprocessors/appid/service_plugins/service_flap.c,
          src/dynamic-preprocessors/appid/service_plugins/service_ftp.c,
          src/dynamic-preprocessors/appid/service_plugins/service_irc.c,
          src/dynamic-preprocessors/appid/service_plugins/service_lpr.c,
          src/dynamic-preprocessors/appid/service_plugins/service_mysql.c,
          src/dynamic-preprocessors/appid/service_plugins/service_netbios.c,
          src/dynamic-preprocessors/appid/service_plugins/service_nntp.c,
          src/dynamic-preprocessors/appid/service_plugins/service_ntp.c,
          src/dynamic-preprocessors/appid/service_plugins/service_radius.c,
          src/dynamic-preprocessors/appid/service_plugins/service_rexec.c,
          src/dynamic-preprocessors/appid/service_plugins/service_rfb.c,
          src/dynamic-preprocessors/appid/service_plugins/service_rlogin.c,
          src/dynamic-preprocessors/appid/service_plugins/service_rpc.c,
          src/dynamic-preprocessors/appid/service_plugins/service_rshell.c,
          src/dynamic-preprocessors/appid/service_plugins/service_rsync.c,
          src/dynamic-preprocessors/appid/service_plugins/service_rtmp.c,
          src/dynamic-preprocessors/appid/service_plugins/service_smtp.c,
          src/dynamic-preprocessors/appid/service_plugins/service_snmp.c,
          src/dynamic-preprocessors/appid/service_plugins/service_ssh.c,
          src/dynamic-preprocessors/appid/service_plugins/service_ssl.c,
          src/dynamic-preprocessors/appid/service_plugins/service_telnet.c,
          src/dynamic-preprocessors/appid/service_plugins/service_tftp.c,
          src/dynamic-preprocessors/appid/service_plugins/service_timbuktu.c,
          src/dynamic-preprocessors/appid/service_plugins/service_tns.c,
          src/dynamic-preprocessors/appid/test/appIdTests.c,
          src/dynamic-preprocessors/appid/util/common_util.h,
          src/file-process/file_resume_block.c,
          src/preprocessors/Session/session_expect.c,
          src/preprocessors/Stream6/snort_stream_tcp.c :
          Added the flag to prevent third-party application identification
          to expected connections. Changed the internal and external flags
          field into one 64-bit flags field. Added address space and
          instance to AppID debug. Cleaned up some compiler warnings.
          Added the debugging flags and info to the service validator function to
          allow internal debugging. Fixed processing of packets without any payload.
          Fixed tftp and rshell detection. Fixed third-party application identification
          proto state for sessions after http. Fixed expected session allow for AppId
          continutation (tftp, snmp).

        * src/dynamic-preprocessors/appid/: appInfoTable.c, appInfoTable.h,
          fw_appid.h :
          Fixed the issue where AppId for Facebook over SPDY/HTTP 1.1 is incorrect.

        * src/dynamic-preprocessors/appid/fw_appid.c :
          Fixed Coverity warning for Uninitialized variable.

        * src/dynamic-preprocessors/appid/: httpCommon.h, luaDetectorApi.c,
          detector_plugins/detector_http.c :
          Changed code in CHPAddAction to REWRITE/INSERT side effect.
                                                                           
        * src/dynamic-preprocessors/appid/appInfoTable.c :
          Disabled internal AppID detectors for HTTP/2 by default.

        * src/preprocessors/HttpInspect/: include/h2_common.h,
          utils/h2_common.c, utils/h2_paf.c :
          Added support for HTTP/2.

        * src/dynamic-preprocessors/imap/imap_buffer_dump.c,
          src/dynamic-preprocessors/imap/imap_buffer_dump.h,
          src/dynamic-preprocessors/ftptelnet/ftptelnet_buffer_dump.c,
          src/dynamic-preprocessors/ftptelnet/ftptelnet_buffer_dump.h,
          src/dynamic-preprocessors/dcerpc2/dcerpc2_buffer_dump.c,
          src/dynamic-preprocessors/dcerpc2/dcerpc2_buffer_dump.h,
          src/dynamic-preprocessors/ssl/ssl_buffer_dump.c,
          src/dynamic-preprocessors/ssl/ssl_buffer_dump.h,
          src/dynamic-preprocessors/ssh/ssh_buffer_dump.c,
          src/dynamic-preprocessors/ssh/ssh_buffer_dump.h,
          src/dynamic-preprocessors/dns/dns_buffer_dump.c,
          src/dynamic-preprocessors/dns/dns_buffer_dump.h,
          src/dynamic-preprocessors/modbus/modbus_buffer_dump.c,
          src/dynamic-preprocessors/modbus/modbus_buffer_dump.h,
          src/preprocessors/HttpInspect/utils/hi_buffer_dump.c,
          src/preprocessors/HttpInspect/include/hi_buffer_dump.h,
          src/output-plugins/spo_log_buffer_dump.h,
          src/output-plugins/spo_log_buffer_dump.c,
          src/dynamic-preprocessors/smtp/smtp_buffer_dump.c,
          src/dynamic-preprocessors/smtp/smtp_buffer_dump.h,
          src/dynamic-preprocessors/sip/sip_buffer_dump.c,
          src/dynamic-preprocessors/sip/sip_buffer_dump.h,
          src/dynamic-preprocessors/pop/pop_buffer_dump.c,
          src/dynamic-preprocessors/pop/pop_buffer_dump.h,
          src/dynamic-preprocessors/dnp3/dnp3_buffer_dump.c,
          src/dynamic-preprocessors/dnp3/dnp3_buffer_dump.h,
          src/dynamic-preprocessors/gtp/gtp_buffer_dump.c,
          src/dynamic-preprocessors/gtp/gtp_buffer_dump.h,
          src/dynamic-preprocessors/imap/imap_buffer_dump.c :
          Added these files as part of Buffer-dump feature.

        * src/detection-plugins/sp_byte_math.c,
          src/detection-plugins/sp_byte_math.h :
          Added new rule option "byte_math".
                                                                                                                          


2016-04-26 Rahul Burman <rahburma@cisco.com>
Snort 2.9.8.3

        * src/build.h: updating build number to 383

        * configure.in, src/preprocessors/HttpInspect/server/hi_server.c:
          Modified Http header parsing of multiline content-encoding header.

        * src/preprocessors/: snort_httpinspect.c,
          HttpInspect/server/hi_server.c:
          Fixed an issue where file position pointer was incorrectly set for HTTP response
          containing chunked and gzip data.

        * src/preprocessors/Stream6/: snort_stream_tcp.c
          Added sanity check to TCP trimming in out-of-order FIN case.

        * src/parser.c:
          Disabled port groups that are not useful unless adapative profiling is enabled.

        * src/: dynamic-preprocessors/sdf/spp_sdf.c, obfuscation.c:
          Fixed an issue of incorrect masking of sensitive data.

2016-03-18 Gaurav Nagare <gnagare@cisco.com>
Snort 2.9.8.2

	* src/build.h: updating build number to 335

	* src/dynamic-plugins/: sf_engine/examples/detection_lib_meta.h,
	  sf_dynamic_meta.h:
          Updated detection API version to 2.6 to use the latest snort SO rules.
	
        * src/: dynamic-preprocessors/sdf/spp_sdf.c,
	  preprocessors/Stream6/snort_stream_tcp.c, obfuscation.c:
          Fixed several issues with SDF and obfuscation.

	* src/: profiler.h, preprocessors/perf_indicators.c,
	  preprocessors/perf_indicators.h: 
          Resolved snort build issue with "--disable-perfprofiling" configure 
          option.

	* src/: decode.c, decode.h: 
          Added Double VLAN tagging support.

	* src/file-process/file_mime_process.c:
          Enhanced mime parsing by adding support for detecting files
          after unknown headers and no headers.

	* src/preprocessors/HttpInspect/server/hi_server.c:
          Fixed memory leak.
	  
        * src/preprocessors/HttpInspect/utils/hi_paf.c:
          Fixed issue with gzip decompression. If the server response specifies
          Content-Encoding as GZIP, but no Content-Length field for HTTP version 1.0.

	* doc/snort_manual.pdf, src/preprocessors/snort_httpinspect.c,
	  src/preprocessors/spp_httpinspect.c:
          Fixed Snort memory leak in parsing HTTP xff options.

	* src/preprocessors/spp_httpinspect.c: 
          Fixed Coverity issues.

	* src/preprocessors/: snort_httpinspect.c, snort_httpinspect.h,
	  HttpInspect/include/hi_paf.h, HttpInspect/server/hi_server.c,
	  HttpInspect/utils/hi_paf.c: 
          Improved End of Header(EOH) identification for response header spanning multiple
	  reassembled packets.

	* src/preprocessors/: HttpInspect/utils/hi_paf.c,
	  Stream6/snort_stream_tcp.c, Stream6/stream_paf.c:
	  Improved packet reassembly for HTTP, added code to purge segment correctly when 
	  PAF decides to ignore packet upon reaching paf_max.

        * src/fpdetect.c:
          Fixed to use outer header callback functions when checking IP rule against outer IPs 
	  and inner header callback when checking against inner IPs.

        * src/preprocessors/spp_httpinspect.c:
          Fixed an issue where http_inspect current and default config had 
          different file depth.

        * src/dynamic-preprocessors/appid/detector_plugins/detector_dns.c:
          Handled malformed DNS host in AppId.

        * src/file-process/: file_api.h, file_segment_process.c, file_service.c:
          Prevented access to file contexts which are pruned when memcap is 
          reached.

        * src/dynamic-preprocessors/appid/: app_forecast.c, app_forecast.h,
          flow.h, fw_appid.c, spp_appid.c, thirdparty_appid_types.h:
          Performance improvements to AppID.

        * src/dynamic-preprocessors/appid/luaDetectorApi.c:
          Created a future-flow API for lua detector.
          Exposed DNS API to lua detector.

        * src/dynamic-preprocessors/ftptelnet/pp_ftp.c:
          Fixed an issue where unexpected SSL negotiation starts for FTP
          with explicit SSL.

        * src/preprocessors/HttpInspect/utils/hi_paf.c:
          Updated HTTP PAF to accept all tokens between method and version
          string in request URI.

	* src/preprocessors/HttpInspect/files/file_decomp_SWF.c:
	  Fixed Flash LZMA decompression issue.

	* src/preprocessors/spp_httpinspect.c:
	  Fixed file_depth intialization issue during Snort reload. 


2015-11-18 Carter Waxman <cwaxman@cisco.com>
Snort 2.9.8.0

   * src/build.h: updating build number to 229

   * src/preprocessors/: session_api.h, spp_session.c,
     Session/session_expect.c, Session/session_expect.h:
     Added support for multiple expected sessions created for
     a single packet.

   * doc/: snort_manual.pdf, snort_manual.tex:
     Changed gtp ports in snort manual

   * src/: dynamic-preprocessors/ftptelnet/ftpp_si.c,
     dynamic-preprocessors/ftptelnet/ftpp_si.h,
     dynamic-preprocessors/ftptelnet/snort_ftptelnet.c,
     preprocessors/spp_session.c:
     Change setAppProcolId to update SFAT for non-TCP traffic

   * src/dynamic-preprocessors/appid/spp_appid.c:
     Fixed reload issues

   * src/dynamic-preprocessors/appid/detector_plugins/detector_sip.c:
     Future flows are now created for both directions on SIP
   
   * src/dynamic-preprocessors/smtp/smtp_paf.c:
     Improved reliability of SMTP PAF

   * src/dynamic-preprocessors/appid/fw_appid.c: Bugs Fixed:
     Improved AppId detection on SSL/TLS protocols for decrypted

   * src/: dynamic-plugins/sf_engine/sf_snort_packet.h,
     dynamic-preprocessors/ftptelnet/snort_ftptelnet.c,
     preprocessors/Stream6/snort_stream_tcp.c:
     Fixed FTP file detection where server SYNs data channel before
     responding to PORT on command channel.

   * src/dynamic-preprocessors/appid/: commonAppMatcher.c, fw_appid.c,
     fw_appid.h, service_plugins/service_ftp.c:
     Improved detection of data on FTPS data channel

   * src/: encode.c, util.h,
     dynamic-preprocessors/appid/test/sessionFile.h,
     preprocessors/spp_session.c, preprocessors/spp_stream6.c,
     preprocessors/Session/session_common.h:
     Added support for MPLS active responses

   * src/dynamic-preprocessors/appid/:
     detector_plugins/detector_pop3.c, service_plugins/service_ftp.c:
     Improved detection of POP3S

   * src/detection-plugins/sp_appid.c:
     Fixed reliability issue with client AppID IPS rules

   * preproc_rules/preprocessor.rules,
     src/dynamic-preprocessors/smtp/smtp_config.c,
     src/dynamic-preprocessors/smtp/smtp_config.h,
     src/dynamic-preprocessors/smtp/smtp_log.h,
     src/dynamic-preprocessors/smtp/smtp_paf.c:
     Added preproc alert for excessive data following "AUTH NTLM\r\n"
     "AUTH CRAM-MD5\r\n"

   * src/dynamic-preprocessors/reputation/: reputation_config.c,
     shmem/shmem_mgmt.c:
     Improved reliability of reputation shared memory on single-cpu
     systems

   * doc/: snort_manual.pdf, snort_manual.tex:
     Fix first/last typo in manual. Thanks Mohsen Abbaspour for reporting it.

   * src/dynamic-preprocessors/appid/spp_appid.c:
     Update AppID to use only global snort config and only process IP packets

   * src/dynamic-preprocessors/appid/service_plugins/service_tftp.c:
     Fixed reversal of TFTP detection had the source and destination
     address data

   * src/: detection-plugins/sp_byte_jump.c,
     dynamic-plugins/sf_convert_dynamic.c,
     dynamic-preprocessors/appid/appIdConfig.c,
     dynamic-preprocessors/appid/commonAppMatcher.c,
     dynamic-preprocessors/appid/fw_appid.c,
     dynamic-preprocessors/appid/luaDetectorApi.c,
     dynamic-preprocessors/appid/client_plugins/client_app_smtp.c,
     dynamic-preprocessors/appid/detector_plugins/detector_http.c,
     dynamic-preprocessors/appid/service_plugins/service_MDNS.c,
     dynamic-preprocessors/ftptelnet/hi_util_kmap.c,
     dynamic-preprocessors/ftptelnet/snort_ftptelnet.c,
     dynamic-preprocessors/reputation/reputation_config.c,
     dynamic-preprocessors/sdf/sdf_detection_option.c,
     dynamic-preprocessors/ssl_common/ssl_config.c,
     dynamic-preprocessors/ssl_common/ssl_ha.c,
     output-plugins/spo_csv.c, preprocessors/spp_arpspoof.c,
     preprocessors/spp_session.c,
     preprocessors/HttpInspect/utils/hi_util_kmap.c, sfutil/ipobj.c,
     sfutil/sfghash.c:
     Added error checks to improve reliability

   * src/dynamic-preprocessors/appid/: flow.h, fw_appid.c,
     service_plugins/service_ssl.c, service_plugins/service_ssl.h:
     Fixed issue where appid info was not populated for ssl
     sessions on non-standard ports

2015-08-28 Rahul Burman <rahburma@cisco.com>
Snort 2.9.8_rc
   * src/build.h:
     updating build number to 195

   * src/preprocessors/HttpInspect/: client/hi_client.c,
     server/hi_server.c:
     NULL check added for call to strndup function.

   * src/output-plugins/spo_alert_unixsock.c:
     Resolved issue where output data is corrupted while writing to unix socket [reported by Alexander Bubnov].

   * src/: dynamic-plugins/sf_dynamic_plugins.c,
     dynamic-plugins/sf_dynamic_preprocessor.h,
     dynamic-preprocessors/ftptelnet/ftpp_si.h,
     dynamic-preprocessors/ftptelnet/ftpp_ui_config.h,
     dynamic-preprocessors/ftptelnet/pp_ftp.c,
     dynamic-preprocessors/ftptelnet/snort_ftptelnet.c:
     Improvements to FTP preprocessor to block malware when downloaded with a client that supports FTP REST.

   * src/dynamic-preprocessors/appid/fw_appid.c:
     Resolved issue where squid detector is not showing expected alerts.
     Reset app ID when SSL is identified on an FTP data channel.

   * src/preprocessors/spp_perfmonitor.c:
     Resolved snort output error issue in perfmonitor preprocessor

   * src/preprocessors/Stream6/snort_stream_tcp.c:
     Resolved issue where snort marks retransmitted packet as bad segment.
     Fixed issue where XFF/ExtraData is not always logged when 'drop' rules trigger [reported by Mike Cox].

   * src/dynamic-preprocessors/reputation/reputation_config.c:
     Fixed unexpected behaviour in reputation config where blacklist is displayed
     in priority field even though whitelist option is set [reported by Mike Cox].

   * src/: decode.h, snort.c,
     dynamic-plugins/sf_engine/sf_snort_packet.h,
     preprocessors/Stream6/snort_stream_tcp.c:
     Improvements done to avoid RETRY verdict for re-transmitted packet.

   * etc/gen-msg.map:
     Fixed a typo where ssp_ssl is renamed to spp_ssl

   * src/preprocessors/spp_session.c:
     Changes done to avoid memory allocation for default no. of sessions when session tracking is disabled.

   * doc/snort_manual.tex:
     Corrected errors in snort_manual.tex [reported by Gabriel Corre].

   * src/dynamic-preprocessors/appid/: appId.h, appIdStats.c,
     service_plugins/service_ftp.c:
     Changes done to differentiate between active and passive FTP connections.

   * src/dynamic-preprocessors/appid/: appIdApi.c, appIdConfig.h,
     appInfoTable.c, flow.h, fw_appid.c, thirdparty_appid_api.h,
     thirdparty_appid_utils.c, detector_plugins/detector_http.c,
     detector_plugins/detector_sip.c:
     Fixed issues reported by valgrind in AppID.

2015-08-05 Victor Roemer  <viroemer@cisco.com>
Snort 2.9.8 Beta
	* src/build.h:
	  Update build number to 176

	* src/dynamic-preprocessors/appid/service_plugins/service_ftp.c:
	  Snort to support EPRT command for active FTP on IPv4 and IPv6

	* src/dynamic-preprocessors/ftptelnet/: ftpp_si.c, ftpp_si.h, pp_ftp.c:
	  Some PDF files were not blocked by snort.

	* src/preprocessors/HttpInspect/client/hi_client.c:
	  Check if packet has start of PDU before generating alert.

	* src/dynamic-preprocessors/smtp/smtp_util.c:
	  SMTP preprocessor email log buffer length update before copying to
	  avoid assert failure.

	* src/: active.c,
	  decode.h,
	  preprocids.h,
	  detection-plugins/sp_react.c,
	  dynamic-plugins/sf_engine/sf_snort_packet.h,
	  dynamic-preprocessors/appid/spp_appid.c,
	  dynamic-preprocessors/reputation/spp_reputation.c,
	  preprocessors/spp_session.c:
	  Sessions that are blocked and trusted. Fix sp_react when sending
	  data.

	* src/dynamic-preprocessors/appid/: flow.h, fw_appid.c,
	  detector_plugins/detector_http.c:
	  Skip simple detection only for those CHP actions that could overrirde
	  client ID, payload ID, etc.

	* doc/snort_manual.tex:
	  Correct Unified2 Packet content.

	* etc/snort.conf,
	  src/preprocessors/snort_httpinspect.c,
	  src/preprocessors/snort_httpinspect.h,
	  src/preprocessors/HttpInspect/client/hi_client.c,
	  src/preprocessors/HttpInspect/server/hi_server.c,
	  src/preprocessors/Stream6/stream_paf.c:
	  Clear True-IP and XFF between HTTP transactions. Prevents Snort
	  from logging extra data on transactions incorrectly.

	* src/sfutil/sf_ip.h:
	  Treat 0.0.0.0/0 as "any" ipv4 address, fixing rule matches on ip header
	  leaf node.

	* src/preprocessors/perf-base.c:
	  Fixed macro usage to work with ICC and C89.

	* src/preprocessors/perf-base.c:
	  Fixed erroneous performance values being generated when Snort is idle.

	* src/dynamic-preprocessors/appid/: service_plugins/service_api.h,
	  util/NetworkSet.h:
	  Fixed appid compilation issues for FreeBSD and OpenBSD.

	* tools/appid_detector_builder.sh:
	 Fix script shortcomings for HTTP URL, Copyright, DetectorClean() stub.

	* src/decode.c:
	  Snort min_ttl decoder rules drop regardless of alert/drop type.

	* src/dynamic-preprocessors/appid/luaDetectorApi.c:
	  Set active flag for sandboxing for SSL Lua detectors.

	* src/: active.h, sfdaq.c, sfdaq.h, snort.c,
	  dynamic-plugins/sf_dynamic_plugins.c,
	  dynamic-plugins/sf_dynamic_preprocessor.h,
	  file-process/file_service.c:
	  Add support for DAQ Retry detection of the current packet. 

	  This change adds active response api function to request a packet
	  retry (method added to dpd struct as well) and to query if the
	  packet disposition is ACTIVE_RETRY.

	* src/preprocessors/: spp_session.c,
	  Session/stream5_ha.c,
	  Session/stream5_ha.h:
	  preprocessors/Stream6/snort_stream_tcp.c:
	  preprocessors/spp_session.c:
	  If session lookup fails for a packet being processed
	  by the Session preprocessor while DAQ HA is enabled and DAQ HA
	  state is available for the packet, retrieve and process the HA
	  state from the DAQ and retry the lookup.  Do not store DAQ HA
	  state when unsupported tunnel types are decoded that might make
	  the underlying hardware's concept of flows not match Snort's.
	  
	* src/dynamic-preprocessors/file/: file_agent.c, file_agent.h,
	  spp_file.c:
	  Support daemon option with file_inspect preprocessor.

	* src/preprocessors/Stream6/snort_stream_tcp.c:
	  When processing asymmetric traffic, TCP segements are no longer
	  queued indefinately, reducing session cache thrashing caused by
	  excessive prunning.

	* src/preprocessors/HttpInspect/session_inspection/hi_si.c:
	  Fix false positive on HI_ANOM_SERVER_ALERT.

	* src/dynamic-preprocessors/appid/: detector_plugins/detector_pattern.c,
	  service_plugins/service_api.h, service_plugins/service_base.c:
	  C detectors were not enabled when testing with a pcap.

	* src/: event.h, sfutil/Unified2_common.h:
	 Increase max size for app ID names so they don't get truncated in alerts.

	* src/dynamic-preprocessors/appid/commonAppMatcher.c:
	  Fix an issue with old/new config and AppID reload swap.

	* src/dynamic-preprocessors/appid/service_plugins/service_bootp.c:
	  Fix in AppId bootp srevice plugin for packets without layer 2 header.

	* snort.8:
	  Updated -q and -M switch description in snort manpage.

	* src/dynamic-preprocessors/appid/: flow.h, fw_appid.c,
	  detector_plugins/detector_pattern.h, util/NetworkSet.h,
	  util/OutputFile.c, util/sfutil.c:
	  Fix Snort compilation issues on OSX when AppID is enabled.

	* src/: dynamic-plugins/sf_dynamic_define.h,
	  dynamic-plugins/sf_engine/sf_snort_plugin_api.h,
	  dynamic-plugins/sf_engine/examples/sfsnort_dynamic_detection_lib.h,
	  dynamic-plugins/sf_preproc_example/sf_dynamic_preproc_lib.h,
	  dynamic-preprocessors/appid/appId.h, dynamic-preprocessors/appid/flow.h,
	  dynamic-preprocessors/appid/host_tracker.h,
	  dynamic-preprocessors/appid/rna_flow.h,
	  dynamic-preprocessors/appid/service_state.h,
	  dynamic-preprocessors/appid/spp_appid.c,
	  dynamic-preprocessors/appid/thirdparty_appid_api.h,
	  dynamic-preprocessors/appid/client_plugins/client_app_api.h,
	  dynamic-preprocessors/appid/client_plugins/client_app_bit.c,
	  dynamic-preprocessors/appid/client_plugins/client_app_bit_tracker.c,
	  dynamic-preprocessors/appid/client_plugins/client_app_rtp.c,
	  dynamic-preprocessors/appid/client_plugins/client_app_ssh.c,
	  dynamic-preprocessors/appid/client_plugins/client_app_timbuktu.c,
	  dynamic-preprocessors/appid/client_plugins/client_app_tns.c,
	  dynamic-preprocessors/appid/client_plugins/client_app_vnc.c,
	  dynamic-preprocessors/appid/detector_plugins/detector_dns.c,
	  dynamic-preprocessors/appid/detector_plugins/detector_imap.c,
	  dynamic-preprocessors/appid/detector_plugins/detector_kerberos.c,
	  dynamic-preprocessors/appid/detector_plugins/detector_pop3.c,
	  dynamic-preprocessors/appid/detector_plugins/detector_sip.c,
	  dynamic-preprocessors/appid/service_plugins/service_base.c,
	  dynamic-preprocessors/appid/service_plugins/service_bit.c,
	  dynamic-preprocessors/appid/service_plugins/service_timbuktu.c,
	  dynamic-preprocessors/appid/service_plugins/service_tns.c,
	  side-channel/dynamic-plugins/sf_dynamic_side_channel_lib.h:
	  Rename SO_PUBLIC to SF_SO_PUBLIC.
	  Removed unused appid/rna code.

	* doc/README.appid, rpm/snort.spec, tools/Makefile.am,
	  tools/appid_detector_builder.sh:
	  Added shell script to build simple LUA detectors for Snort.

	* src/dynamic-preprocessors/appid/: luaDetectorApi.c,
	  client_plugins/client_app_base.c, client_plugins/client_app_base.h:
	  Add sanity checks for lua client mod calls.
	  Add function for service detectors to add clients.
	  Open client-side API to allow clients to be added outside of client api.

	* configure.in, src/dynamic-output/plugins/output_lib.h:
	  Don't export visibility hidden or invalid daq include path.

	* src/dynamic-preprocessors/appid/service_plugins/service_tftp.c:
	  Switch source and destination when adding the expected flow.

	* doc/README.stream5, doc/snort_manual.tex, etc/snort.conf,
	  src/preprocessors/Stream6/snort_stream_tcp.c:
	  Added a new configure option "log_asymmetric_traffic" to turn
	  on/off logging the message for asymmetric traffic. By default, it
	  will be turned off.

	* src/detect.c:
	  Call correct function to get app names for alerts.
	
	* configure.in, src/dynamic-preprocessors/appid/dns_defs.h,
	  src/dynamic-preprocessors/appid/client_plugins/client_app_rtp.c,
	  src/dynamic-preprocessors/appid/service_plugins/service_api.h,
	  src/dynamic-preprocessors/appid/service_plugins/service_netbios.c:
	  Replace use of __BYTE_ORDER with use of WORDS_BIGENDIAN or SF_BIGENDIAN.

	* src/dynamic-preprocessors/appid/fw_appid.c:
	  Free http_session->new_uri and new_cookie before reassigning. 

	* src/: preprocessors/spp_normalize.c, snort.h:
	  When normaization is removed from snort conf, a reload would not
	  disable it in Stream.

	* src/preprocessors/perf_indicators.h:
	  Added a NULL check for a pointer argument in a perf_indicator utility 
	  inline function.

	* src/: parser.c, preprocessors/Stream6/snort_stream_tcp.c,
	  sfutil/sfPolicyUserData.h:
	  Fixed an issue where stream fails during multiple-policy
	  configuration if stream_tcp configs are present in the default, but
	  not child policies.

	* src/dynamic-preprocessors/appid/appInfoTable.c:
	  App name(s) in Snort rules are now case insensitive.

	* doc/snort_manual.tex,
	  src/preprocessors/snort_httpinspect.c,
	  src/preprocessors/snort_httpinspect.h,
	  src/preprocessors/spp_httpinspect.c,
	  src/preprocessors/stream_api.h,
	  src/preprocessors/HttpInspect/include/hi_si.h,
	  src/preprocessors/HttpInspect/include/hi_ui_config.h,
	  src/preprocessors/HttpInspect/server/hi_server.c,
	  src/preprocessors/HttpInspect/session_inspection/hi_si.c,
	  src/preprocessors/HttpInspect/utils/hi_paf.c,
	  src/preprocessors/Session/session_common.h,
	  src/preprocessors/Stream6/snort_stream_tcp.c,
	  src/preprocessors/Stream6/stream_paf.c,
	  src/preprocessors/Stream6/stream_paf.h:
	  Stop reassembly if HTTP flow depth has been reached.

	* src/dynamic-preprocessors/appid/: fw_appid.c:
	  Fix for core while processing SIP traffic from ignore sessions.

	* src/dynamic-preprocessors/appid/service_plugins/service_ssl.c:
	  Fix for parsing SSL client hello packet (do not assume that this
	  packet always contains extensions field).

	* src/: dynamic-preprocessors/dcerpc2/dce2_paf.c,
	  dynamic-preprocessors/dnp3/dnp3_paf.c,
	  dynamic-preprocessors/ftptelnet/snort_ftptelnet.c,
	  dynamic-preprocessors/imap/imap_paf.c,
	  dynamic-preprocessors/pop/pop_paf.c,
	  dynamic-preprocessors/sip/sip_paf.c,
	  dynamic-preprocessors/smtp/smtp_paf.c,
	  preprocessors/spp_stream6.c,
	  preprocessors/stream_api.h,
	  preprocessors/HttpInspect/utils/hi_paf.c,
	  preprocessors/Session/session_common.h,
	  preprocessors/Stream6/snort_stream_tcp.c,
	  preprocessors/Stream6/snort_stream_tcp.h,
	  preprocessors/Stream6/stream_paf.c,
	  preprocessors/Stream6/stream_paf.h:
	  Allow 2 PAF clients to be active at a time.

	* src/detection-plugins/detection_options.c:
	  Detection_filter events incorrect both raw and reassembled packets
	  used.  Added a check that, if session is being reassembled, consider
	  reassembled packet. Else, consider raw packet for count.

	  When "no_stream" is present in the rule, need to consider raw packets
	  only, even though session reassembly is happening. Took care of this
	  case by adding OtnFlowIgnoreReassembled(otn) check.

	* src/sfutil/: sf_email_attach_decode.c, sf_email_attach_decode.h:
	  Filename parsed from Mime body for UUencoded file.

	* src/: detect.c, detect.h, event_queue.c, event_queue.h,
	  event_wrapper.c, event_wrapper.h, fpdetect.c, fpdetect.h,
	  ppm.c, tag.c, tag.h, file-process/file_service.c,
	  preprocessors/Stream6/snort_stream_tcp.c, sfutil/sfPolicyData.h,
	  sfutil/sfrf.c:
	  Internal (gid:135) rate filtering events now use runtime NAP instead 
	  of runtime IPS for rule tree lookups.

	* src/dynamic-preprocessors/Makefile.am:
	  Fix for Snort compilation issue on OSX.

	* src/: appIdApi.h, decode.h, detect.c, snort.c, snort.h,
	  dynamic-plugins/sf_dynamic_plugins.c,
	  dynamic-plugins/sf_engine/sf_snort_packet.h,
	  dynamic-preprocessors/appid/appIdApi.c,
	  dynamic-preprocessors/appid/flow.c,
	  dynamic-preprocessors/appid/flow.h,
	  dynamic-preprocessors/appid/luaDetectorApi.c,
	  dynamic-preprocessors/appid/luaDetectorApi.h,
	  dynamic-preprocessors/appid/client_plugins/client_app_aim.c,
	  dynamic-preprocessors/appid/client_plugins/client_app_api.h,
	  dynamic-preprocessors/appid/client_plugins/client_app_base.c,
	  dynamic-preprocessors/appid/client_plugins/client_app_base.h,
	  dynamic-preprocessors/appid/client_plugins/client_app_bit.c,
	  dynamic-preprocessors/appid/client_plugins/client_app_bit_tracker.c,
	  dynamic-preprocessors/appid/client_plugins/client_app_msn.c,
	  dynamic-preprocessors/appid/client_plugins/client_app_rtp.c,
	  dynamic-preprocessors/appid/client_plugins/client_app_smtp.c,
	  dynamic-preprocessors/appid/client_plugins/client_app_ssh.c,
	  dynamic-preprocessors/appid/client_plugins/client_app_timbuktu.c,
	  dynamic-preprocessors/appid/client_plugins/client_app_tns.c,
	  dynamic-preprocessors/appid/client_plugins/client_app_vnc.c,
	  dynamic-preprocessors/appid/client_plugins/client_app_ym.c,
	  dynamic-preprocessors/appid/detector_plugins/detector_dns.c,
	  dynamic-preprocessors/appid/detector_plugins/detector_imap.c,
	  dynamic-preprocessors/appid/detector_plugins/detector_kerberos.c,
	  dynamic-preprocessors/appid/detector_plugins/detector_pattern.c,
	  dynamic-preprocessors/appid/detector_plugins/detector_pop3.c,
	  dynamic-preprocessors/appid/detector_plugins/detector_sip.c,
	  dynamic-preprocessors/appid/service_plugins/service_api.h,
	  dynamic-preprocessors/appid/service_plugins/service_base.c,
	  dynamic-preprocessors/appid/service_plugins/service_base.h,
	  dynamic-preprocessors/appid/service_plugins/service_rpc.c,
	  dynamic-preprocessors/ftptelnet/pp_ftp.c,
	  dynamic-preprocessors/sip/sip_dialog.c,
	  preprocessors/session_api.h,
	  preprocessors/sip_common.h,
	  preprocessors/spp_session.c,
	  preprocessors/spp_session.h,
	  preprocessors/spp_stream6.c,
	  preprocessors/stream_api.h,
	  preprocessors/Session/session_expect.c,
	  preprocessors/Session/session_expect.h:
	  Allow all preprocessors to create expected session calls.

	* src/dynamic-plugins/: sf_dynamic_plugins.c, sf_dynamic_preprocessor.h:
	  Corrected function prototype definition for DP API method called to
	  register an Active Response callback.

	* src/snort.c:
	  Clean up the inline failopen thread before calling DAQ_Stop in
	  SnortCleanup(). Prevent running in daemon mode from killing these
	  threads.

	* src/preprocessors/: perf-base.h, perf.c:
	  Don't clear procpidstats structure, so snort doesn't core.

	* src/dynamic-preprocessors/appid/: service_state.h,
	  service_plugins/service_base.c:
	  Restart service search state machine if previous session was only
	  partial.

	* configure.in, src/sfdaq.c, src/sfdaq.h, 
	  src/dynamic-plugins/sf_dynamic_plugins.c,
	  src/dynamic-plugins/sf_dynamic_preprocessor.h:
	  Added accessor methods for DAQ query flow method.

	* src/preprocessors/snort_httpinspect.c:
	  Added checks to prevent raw packets from being used for file process
	  in HTTP.

	* src/dynamic-preprocessors/appid/: flow.h, fw_appid.c:
	  Fix for processing HTTPS data to extract client app id.

	* src/preprocessors/: perf-base.c, Stream6/snort_stream_tcp.c:
	  Prunes due to timouts will are now counted by perfmonitor as prunes.

	* doc/snort_manual.tex, src/parser.c, src/parser.h, src/snort.h,
	  src/detection-plugins/detection_options.c:
	  Introduced config option `disable_replace.

	* preproc_rules/preprocessor.rules,
	  src/preprocessors/session_api.h,
	  src/preprocessors/snort_httpinspect.c,
	  src/preprocessors/HttpInspect/event_output/hi_eo_log.c,
	  src/preprocessors/HttpInspect/include/hi_eo_events.h,
	  src/preprocessors/Stream6/snort_stream_tcp.c
	  etc/gen-msg.map:
	  HI_EO_SERVER_PROTOCOL_OTHER alert is added to detect SSH tunneling over HTTP.

	* configure.in:
	  Remove unused declaration of ADD_WERROR.

	* src/: active.c, detection-plugins/sp_react.c:
	  Changed code to add FIN on last data packet and bump the seq for the 
	  FIN flag.

	* src/active.c:
	  Added a FIN packet after the last data packet and before the reset.

	* src/dynamic-preprocessors/appid/fw_appid.c:
	  Fixed HTTP header field offset calculation for fragmented HTTP headers.

	* doc/: snort_manual.pdf, snort_manual.tex:
	  Added note about fast pattern matcher being case insensitive.

	* src/: dynamic-plugins/sf_dynamic_plugins.c,
	  dynamic-plugins/sf_dynamic_preprocessor.h,
	  dynamic-preprocessors/appid/spp_appid.c:
	  Allow for multiple isAppIdRequired functions.

	* doc/snort_manual.tex:
	  When not set by preprocessor, set file_data pointer to beg. of
	  payload.  Also fixed an issue when doe_ptr is moved to http
	  buffers, the length for those buffers is incorrect.

	* src/: snort.c, preprocessors/perf.c, preprocessors/perf.h,
	  preprocessors/spp_perfmonitor.c: 
	  Change the way perfmon dumps stats to ensure that multiple
	  instances will dump stats at offsets from absolute time. This gives
	  Snort the ability to dump stats asynchronously (when idle).

	* src/snort.c:
	  Change the order of permissions drop and chroot so that we set 
	  the uid and gid before creating the pid file.

	* src/preprocessors/Stream6/snort_stream_tcp.c:
	  Change PAF to handle full PDU in single tcp segment correctly.

	* src/decode.c: 
	  Prevent duplicate alerting of decoder rule 116:296.

	* src/dynamic-preprocessors/appid/fw_appid.c:
	  Use memcpy instead of strdup.

	* src/dynamic-preprocessors/appid/detector_plugins/detector_http.c:
	  Fixed the calculation of 'end' index in http_header_pattern_match
	  when HTTP header does not have a properly terminated 'Server'
	  field.

	* src/: log_text.c, log_text.h, output-plugins/spo_alert_fast.c,
	  output-plugins/spo_alert_full.c:
	  Add AppID to console alert logs.
	 
	* src/dynamic-preprocessors/appid/: service_state.c,
	  service_plugins/service_base.c:
	  Don't fail adding a service if the id_state is already in the host cache.

	* src/dynamic-preprocessors/appid/fw_appid.c:
	  Addressed pinhole issue not allowing FTP-Data sessions.

	* src/: decode.c, parser.c, sfdaq.c, sfdaq.h, snort.c, snort.h:
	  Update snort to handle the DAQ flags to determine which tunnels it 
	  can render flow verdicts to hardware.
	 
	* src/active.c:
	  Included function for sending UDP response(s).

	* src/: sfutil/sfrt_flat.c,
	  dynamic-preprocessors/reputation/reputation_config.c:
	  Limit number of IP entries based on memcap. Avoiding issue of sfrt table
	  not being created in the first place.

	* src/: tag.c, detection-plugins/detection_leaf_node.c,
	  file-process/file_capture.c, file-process/file_mempool.c,
	  file-process/file_resume_block.c,
	  file-process/file_segment_process.c,
	  file-process/file_segment_process.h, preprocessors/perf-flow.c,
	  preprocessors/portscan.c, preprocessors/Session/session_expect.c,
	  sfutil/sf_ip.h, sfutil/sfrf.c, sfutil/sfthd.c, sfutil/sfthd.h:
	  Replaced all sfaddr_t occurrences in hash keys with struct in6_addr.

	* src/sfutil/sfdebug.h, tools/control/sfcontrol.c:
	  Fixed ascii output of file data.

	* src/: profiler.h, snort.c, dynamic-plugins/sf_dynamic_plugins.c,
	  dynamic-plugins/sf_dynamic_preprocessor.h,
	  dynamic-preprocessors/Makefile.am, preprocessors/Makefile.am,
	  preprocessors/perf_indicators.c,
	  preprocessors/perf_indicators.h:
	  New dynamic-preprocessor API hooks for fetching a set of snort
	  performance indicators and the pcap readback mode bit.

	* src/sfutil/sfdebug.h, tools/control/sfcontrol.c:
	  Fixed string termination to only dump values that have been initialized.

	* src/sfutil/: sfrt_flat.c, sfrt_flat.h, sfrt_flat_dir.c,
	  sfrt_flat_dir.h:
	  Memory optimizations for reputation preprocessor

	* src/: decode.h, detect.c, detection_util.c, plugbase.c, plugbase.h,
	  preprocids.h, snort.h, dynamic-plugins/sf_engine/Makefile.am,
	  dynamic-plugins/sf_engine/sf_snort_packet.h,
	  preprocessors/spp_frag3.c, preprocessors/spp_session.c,
	  sfutil/sf_ip.c, sfutil/sf_ip.h:
	  Changed the preprocessor mask from 32-bit to 64-bit.
	  Changed all declarations to use PreprocEnableMask as the type.
	 
	* src/: file-process/file_resume_block.c, sfutil/sfxhash.c,
	  sfutil/sfxhash.h:
	  Added a memcap to sfxhash usage in file_resume_block.
	  
	* src/dynamic-preprocessors/dcerpc2/: dce2_smb2.c, dce2_smb2.h,
	  dce2_stats.h, spp_dce2.c:
	  Currently, we use file size to avoid processing pipe and print
	  share data because file size is 0 in that case. However, for
	  smbclient, it sets file size to be zero which snort fails to
	  identify those files correctly.

	* src/: dynamic-preprocessors/appid/commonAppMatcher.c,
	  dynamic-preprocessors/appid/hostPortAppCache.c,
	  dynamic-preprocessors/appid/lengthAppCache.c,
	  dynamic-preprocessors/appid/service_state.c,
	  dynamic-preprocessors/appid/util/NetworkSet.c,
	  preprocessors/Session/session_expect.c, sfutil/sfxhash.c,
	  sfutil/sfxhash.h:
	  Create SFXHASH with non-negative sizes only. 

	* doc/snort_manual.tex:
	  Documentation for new Port Override feature.

	* src/dynamic-preprocessors/appid/: luaDetectorApi.c,
	  luaDetectorApi.h, client_plugins/client_app_base.c,
	  detector_plugins/detector_pattern.c,
	  service_plugins/service_base.c:
	  Fix memory leaks in detector_pattern.

	* src/dynamic-preprocessors/appid/service_plugins/service_dns.c,
	  src/dynamic-preprocessors/appid/service_plugins/service_base.c,
	  src/dynamic-preprocessors/appid/service_plugins/service_api.h,
	  src/dynamic-preprocessors/appid/fw_appid.h,
	  src/dynamic-preprocessors/appid/fw_appid.c,
	  src/dynamic-preprocessors/appid/appIdApi.c,
	  src/dynamic-plugins/sf_dynamic_plugins.c,
	  src/appIdApi.h:
	  Included 2 new Appid Api calls for DNS_QUERY and DNS_QUERY_LEN.

	* src/preprocessors/HttpInspect/client/hi_client.c:
	  Enable publishing of host name from raw packets for Appid.

	* src/: post_detection.c, post_detection.h:
	  Inline modifier removed from post detection initialization function.

	* src/post_detection.h:
	  Remove static modifier from inline function definition.

	* src/decode.c:
	  FabricPath decoding modified the packet data pointer and length fields
	  used to caluclate ethernet header offesets incorrectly.

	* src/: Makefile.am, decode.h, detect.c, post_detection.c,
	  post_detection.h, snort.c, dynamic-examples/Makefile.am,
	  dynamic-plugins/sf_dynamic_plugins.c, 
	  dynamic-plugins/sf_dynamic_preprocessor.h,
	  dynamic-plugins/sf_engine/sf_snort_packet.h,
	  dynamic-preprocessors/Makefile.am:
	  Provide an API method available to all preprocessors to register a 
	  callback function that is called post-detection processing of the 
	  packet on which the callback was registered.

	* src/dynamic-preprocessors/appid/: commonAppMatcher.c,
	  thirdparty_appid_api.h, thirdparty_appid_utils.c:
	  Use Snort's logging facility for 3rd party AppID impls.

	* src/: decode.c, decode.h, encode.c, generators.h, sf_protocols.h,
	  dynamic-plugins/sf_engine/sf_snort_packet.h:
	  Added a decoding for Cisco Metadata headers.

	* src/dynamic-preprocessors/appid/: commonAppMatcher.c, fw_appid.c,
	  fw_appid.h, client_plugins/client_app_api.h, 
	  client_plugins/client_app_base.c, detector_plugins/detector_pattern.c,
	  detector_plugins/detector_sip.c, service_plugins/service_api.h,
	  service_plugins/service_base.c, service_plugins/service_base.h,
	  util/sf_mlmp.c, util/sf_mlmp.h:
	  Fixes for sandboxing sip and http.

	* src/dynamic-preprocessors/appid/: appIdConfig.c,
	  luaDetectorApi.c,
	  detector_plugins/detector_imap.c,
	  detector_plugins/detector_kerberos.c,
	  detector_plugins/detector_pop3.c, 
	  detector_plugins/detector_sip.c,
	  service_plugins/service_MDNS.c,
	  service_plugins/service_battle_field.c,
	  service_plugins/service_bgp.c,
	  service_plugins/service_bit.c,
	  service_plugins/service_bootp.c,
	  service_plugins/service_dcerpc.c,
	  service_plugins/service_direct_connect.c,
	  service_plugins/service_dns.c,
	  service_plugins/service_flap.c,
	  service_plugins/service_ftp.c,
	  service_plugins/service_irc.c,
	  service_plugins/service_lpr.c,
	  service_plugins/service_mysql.c,
	  service_plugins/service_netbios.c,
	  service_plugins/service_nntp.c,
	  service_plugins/service_ntp.c,
	  service_plugins/service_radius.c,
	  service_plugins/service_rexec.c,
	  service_plugins/service_rfb.c,
	  service_plugins/service_rlogin.c,
	  service_plugins/service_rpc.c,
	  service_plugins/service_rshell.c,
	  service_plugins/service_rsync.c,
	  service_plugins/service_rtmp.c,
	  service_plugins/service_smtp.c,
	  service_plugins/service_snmp.c,
	  service_plugins/service_ssh.c,
	  service_plugins/service_ssl.c,
	  service_plugins/service_telnet.c,
	  service_plugins/service_tftp.c,
	  service_plugins/service_timbuktu.c,
	  service_plugins/service_tns.c:
	  Initialize current_ref_count for all service plugins.

	* src/: detection-plugins/sp_appid.c, dynamic-preprocessors/appid/fw_appid.c:
	  Fixed AppID in snort rules, trim appNames.

	* src/dynamic-preprocessors/appid/: flow.h, fw_appid.c, host_tracker.h,
	  service_state.h, client_plugins/client_app_base.c,
	  service_plugins/service_base.c:
	  Allow multiple service and client detectors to be evaluated on that same flow.

	* src/dynamic-preprocessors/appid/: Makefile.am,
	  appIdConfig.h,
	  commonAppMatcher.c,
	  luaDetectorApi.c,
	  luaDetectorApi.h,
	  luaDetectorModule.c,
	  client_plugins/client_app_base.c,
	  client_plugins/client_app_base.h,
	  detector_plugins/detector_base.c,
	  detector_plugins/detector_pattern.c,
	  detector_plugins/detector_pattern.h,
	  service_plugins/service_api.h,
	  service_plugins/service_base.c,
	  service_plugins/service_base.h,
	  service_plugins/service_pattern.c,
	  service_plugins/service_pattern.h:
	  Implemented new Lua API to inject pattern/port for client and server.

	* src/dynamic-preprocessors/: appid/fw_appid.h,
	  appid/luaDetectorApi.c,
	  appid/luaDetectorApi.h,
	  appid/luaDetectorModule.c,
	  appid/spp_appid.c,
	  appid/service_plugins/service_MDNS.c,
	  dcerpc2/spp_dce2.c,
	  dnp3/spp_dnp3.c,
	  dns/spp_dns.c,
	  ftptelnet/spp_ftptelnet.c,
	  gtp/spp_gtp.c,
	  imap/spp_imap.c,
	  isakmp/spp_isakmp.c,
	  modbus/spp_modbus.c,
	  pop/spp_pop.c,
	  reputation/spp_reputation.c,
	  sdf/spp_sdf.c,
	  sip/spp_sip.c,
	  smtp/spp_smtp.c,
	  ssh/spp_ssh.c,
	  ssl_common/ssl_config.c,
	  ssl_common/ssl_ha.c:
	  Implemented lua detector performance profiling.

	* src/generators.h, src/dynamic-preprocessors/dcerpc2/dce2_event.c,
	  src/dynamic-preprocessors/dcerpc2/dce2_event.h,
	  src/dynamic-preprocessors/dcerpc2/dce2_smb2.c,
	  doc/README.dcerpc2, doc/snort_manual.tex,
	  preproc_rules/preprocessor.rules, etc/gen-msg.map:
	  SMBv2 and SMBv3 preprocessor alerts update.

	* src/encode.c:
	  Use ip6h struct to reference the src/dst address bytes.

	* configure.in,
	  src/file-process/file_segment_process.c,
	  src/file-process/file_segment_process.h,
	  src/file-process/file_service.c,
	  src/file-process/file_stats.c,
	  src/file-process/libs/file_lib.c,
	  src/file-process/Makefile.am,
	  src/file-process/file_api.h,
	  src/dynamic-preprocessors/sip/sip_utils.h,
	  src/dynamic-preprocessors/dcerpc2/Makefile.am,
	  src/dynamic-preprocessors/dcerpc2/dce2_config.c,
	  src/dynamic-preprocessors/dcerpc2/dce2_config.h,
	  src/dynamic-preprocessors/dcerpc2/dce2_session.h,
	  src/dynamic-preprocessors/dcerpc2/dce2_smb.c,
	  src/dynamic-preprocessors/dcerpc2/dce2_smb.h,
	  src/dynamic-preprocessors/dcerpc2/dce2_smb2.c,
	  src/dynamic-preprocessors/dcerpc2/dce2_smb2.h,
	  src/dynamic-preprocessors/dcerpc2/dce2_stats.h,
	  src/dynamic-preprocessors/dcerpc2/sf_dce2.dsp,
	  src/dynamic-preprocessors/dcerpc2/spp_dce2.c:
	  doc/README.dcerpc2,
	  doc/snort_manual.tex:
	  SMBv2 and SMBv3 file inspection support.

	* src/: Makefile.am,
	  appIdApi.h,
	  detect.c,
	  event.h,
	  sf_sdlist.c,
	  snort_debug.h,
	  detection-plugins/sp_appid.c,
	  detection-plugins/sp_appid.h,
	  dynamic-plugins/sf_dynamic_plugins.c,
	  dynamic-plugins/sf_dynamic_preprocessor.h, 
	  dynamic-plugins/sf_engine/sf_snort_plugin_api.c,
	  dynamic-preprocessors/Makefile.am,
	  dynamic-preprocessors/appid/Makefile.am,
	  dynamic-preprocessors/appid/appId.c,
	  dynamic-preprocessors/appid/appId.h,
	  dynamic-preprocessors/appid/appIdApi.c,
	  dynamic-preprocessors/appid/appIdConfig.c,
	  dynamic-preprocessors/appid/appIdConfig.h,
	  dynamic-preprocessors/appid/appIdStats.c,
	  dynamic-preprocessors/appid/appInfoTable.c,
	  dynamic-preprocessors/appid/appInfoTable.h,
	  dynamic-preprocessors/appid/app_forecast.c,
	  dynamic-preprocessors/appid/app_forecast.h,
	  dynamic-preprocessors/appid/commonAppMatcher.c,
	  dynamic-preprocessors/appid/commonAppMatcher.h,
	  dynamic-preprocessors/appid/flow.c,
	  dynamic-preprocessors/appid/flow.h,
	  dynamic-preprocessors/appid/flow_error.h,
	  dynamic-preprocessors/appid/fw_appid.c,
	  dynamic-preprocessors/appid/fw_appid.h,
	  dynamic-preprocessors/appid/hostPortAppCache.c,
	  dynamic-preprocessors/appid/hostPortAppCache.h,
	  dynamic-preprocessors/appid/host_tracker.h,
	  dynamic-preprocessors/appid/httpCommon.h,
	  dynamic-preprocessors/appid/lengthAppCache.c,
	  dynamic-preprocessors/appid/lengthAppCache.h,
	  dynamic-preprocessors/appid/luaDetectorApi.c,
	  dynamic-preprocessors/appid/luaDetectorApi.h,
	  dynamic-preprocessors/appid/luaDetectorFlowApi.c,
	  dynamic-preprocessors/appid/luaDetectorFlowApi.h,
	  dynamic-preprocessors/appid/luaDetectorModule.c,
	  dynamic-preprocessors/appid/luaDetectorModule.h,
	  dynamic-preprocessors/appid/rna_flow.h,
	  dynamic-preprocessors/appid/service_state.c,
	  dynamic-preprocessors/appid/service_state.h,
	  dynamic-preprocessors/appid/spp_appid.c,
	  dynamic-preprocessors/appid/thirdparty_appid_api.h,
	  dynamic-preprocessors/appid/thirdparty_appid_types.h,
	  dynamic-preprocessors/appid/thirdparty_appid_utils.c,
	  dynamic-preprocessors/appid/thirdparty_appid_utils.h,
	  dynamic-preprocessors/appid/client_plugins/clientAppConfig.h,
	  dynamic-preprocessors/appid/client_plugins/client_app_aim.c,
	  dynamic-preprocessors/appid/client_plugins/client_app_aim.h,
	  dynamic-preprocessors/appid/client_plugins/client_app_api.h,
	  dynamic-preprocessors/appid/client_plugins/client_app_base.c,
	  dynamic-preprocessors/appid/client_plugins/client_app_base.h,
	  dynamic-preprocessors/appid/client_plugins/client_app_bit.c,
	  dynamic-preprocessors/appid/client_plugins/client_app_bit_tracker.c,
	  dynamic-preprocessors/appid/client_plugins/client_app_msn.c,
	  dynamic-preprocessors/appid/client_plugins/client_app_msn.h,
	  dynamic-preprocessors/appid/client_plugins/client_app_rtp.c,
	  dynamic-preprocessors/appid/client_plugins/client_app_smtp.c,
	  dynamic-preprocessors/appid/client_plugins/client_app_smtp.h,
	  dynamic-preprocessors/appid/client_plugins/client_app_ssh.c,
	  dynamic-preprocessors/appid/client_plugins/client_app_timbuktu.c,
	  dynamic-preprocessors/appid/client_plugins/client_app_tns.c,
	  dynamic-preprocessors/appid/client_plugins/client_app_vnc.c,
	  dynamic-preprocessors/appid/client_plugins/client_app_ym.c,
	  dynamic-preprocessors/appid/client_plugins/client_app_ym.h,
	  dynamic-preprocessors/appid/detector_plugins/detector_api.h,
	  dynamic-preprocessors/appid/detector_plugins/detector_base.c,
	  dynamic-preprocessors/appid/detector_plugins/detector_http.c,
	  dynamic-preprocessors/appid/detector_plugins/detector_http.h,
	  dynamic-preprocessors/appid/detector_plugins/detector_imap.c,
	  dynamic-preprocessors/appid/detector_plugins/detector_kerberos.c,
	  dynamic-preprocessors/appid/detector_plugins/detector_pop3.c,
	  dynamic-preprocessors/appid/detector_plugins/detector_sip.c,
	  dynamic-preprocessors/appid/detector_plugins/detector_sip.h,
	  dynamic-preprocessors/appid/detector_plugins/http_url_patterns.c,
	  dynamic-preprocessors/appid/detector_plugins/http_url_patterns.h,
	  dynamic-preprocessors/appid/service_plugins/serviceConfig.h,
	  dynamic-preprocessors/appid/service_plugins/service_MDNS.c,
	  dynamic-preprocessors/appid/service_plugins/service_MDNS.h,
	  dynamic-preprocessors/appid/service_plugins/service_api.h,
	  dynamic-preprocessors/appid/service_plugins/service_base.c,
	  dynamic-preprocessors/appid/service_plugins/service_base.h,
	  dynamic-preprocessors/appid/service_plugins/service_battle_field.c,
	  dynamic-preprocessors/appid/service_plugins/service_battle_field.h,
	  dynamic-preprocessors/appid/service_plugins/service_bgp.c,
	  dynamic-preprocessors/appid/service_plugins/service_bgp.h,
	  dynamic-preprocessors/appid/service_plugins/service_bit.c,
	  dynamic-preprocessors/appid/service_plugins/service_bootp.c,
	  dynamic-preprocessors/appid/service_plugins/service_bootp.h,
	  dynamic-preprocessors/appid/service_plugins/service_dcerpc.c,
	  dynamic-preprocessors/appid/service_plugins/service_dcerpc.h,
	  dynamic-preprocessors/appid/service_plugins/service_direct_connect.c,
	  dynamic-preprocessors/appid/service_plugins/service_direct_connect.h,
	  dynamic-preprocessors/appid/service_plugins/service_dns.c,
	  dynamic-preprocessors/appid/service_plugins/service_dns.h,
	  dynamic-preprocessors/appid/service_plugins/service_flap.c,
	  dynamic-preprocessors/appid/service_plugins/service_flap.h,
	  dynamic-preprocessors/appid/service_plugins/service_ftp.c,
	  dynamic-preprocessors/appid/service_plugins/service_ftp.h,
	  dynamic-preprocessors/appid/service_plugins/service_irc.c,
	  dynamic-preprocessors/appid/service_plugins/service_irc.h,
	  dynamic-preprocessors/appid/service_plugins/service_lpr.c,
	  dynamic-preprocessors/appid/service_plugins/service_lpr.h,
	  dynamic-preprocessors/appid/service_plugins/service_mysql.c,
	  dynamic-preprocessors/appid/service_plugins/service_mysql.h,
	  dynamic-preprocessors/appid/service_plugins/service_netbios.c,
	  dynamic-preprocessors/appid/service_plugins/service_netbios.h,
	  dynamic-preprocessors/appid/service_plugins/service_nntp.c,
	  dynamic-preprocessors/appid/service_plugins/service_nntp.h,
	  dynamic-preprocessors/appid/service_plugins/service_ntp.c,
	  dynamic-preprocessors/appid/service_plugins/service_ntp.h,
	  dynamic-preprocessors/appid/service_plugins/service_pattern.c,
	  dynamic-preprocessors/appid/service_plugins/service_pattern.h,
	  dynamic-preprocessors/appid/service_plugins/service_radius.c,
	  dynamic-preprocessors/appid/service_plugins/service_radius.h,
	  dynamic-preprocessors/appid/service_plugins/service_rexec.c,
	  dynamic-preprocessors/appid/service_plugins/service_rexec.h,
	  dynamic-preprocessors/appid/service_plugins/service_rfb.c,
	  dynamic-preprocessors/appid/service_plugins/service_rfb.h,
	  dynamic-preprocessors/appid/service_plugins/service_rlogin.c,
	  dynamic-preprocessors/appid/service_plugins/service_rlogin.h,
	  dynamic-preprocessors/appid/service_plugins/service_rpc.c,
	  dynamic-preprocessors/appid/service_plugins/service_rpc.h,
	  dynamic-preprocessors/appid/service_plugins/service_rshell.c,
	  dynamic-preprocessors/appid/service_plugins/service_rshell.h,
	  dynamic-preprocessors/appid/service_plugins/service_rsync.c,
	  dynamic-preprocessors/appid/service_plugins/service_rsync.h,
	  dynamic-preprocessors/appid/service_plugins/service_rtmp.c,
	  dynamic-preprocessors/appid/service_plugins/service_rtmp.h,
	  dynamic-preprocessors/appid/service_plugins/service_smtp.c,
	  dynamic-preprocessors/appid/service_plugins/service_smtp.h,
	  dynamic-preprocessors/appid/service_plugins/service_snmp.c,
	  dynamic-preprocessors/appid/service_plugins/service_snmp.h,
	  dynamic-preprocessors/appid/service_plugins/service_ssh.c,
	  dynamic-preprocessors/appid/service_plugins/service_ssh.h,
	  dynamic-preprocessors/appid/service_plugins/service_ssl.c,
	  dynamic-preprocessors/appid/service_plugins/service_ssl.h,
	  dynamic-preprocessors/appid/service_plugins/service_telnet.c,
	  dynamic-preprocessors/appid/service_plugins/service_telnet.h,
	  dynamic-preprocessors/appid/service_plugins/service_tftp.c,
	  dynamic-preprocessors/appid/service_plugins/service_tftp.h,
	  dynamic-preprocessors/appid/service_plugins/service_timbuktu.c,
	  dynamic-preprocessors/appid/service_plugins/service_tns.c,
	  dynamic-preprocessors/appid/util/NetworkSet.c,
	  dynamic-preprocessors/appid/util/NetworkSet.h,
	  dynamic-preprocessors/appid/util/common_util.h,
	  dynamic-preprocessors/appid/util/fw_avltree.c,
	  dynamic-preprocessors/appid/util/ip_funcs.c,
	  dynamic-preprocessors/appid/util/ip_funcs.h,
	  dynamic-preprocessors/appid/util/sf_mlmp.c,
	  dynamic-preprocessors/appid/util/sfutil.c,
	  dynamic-preprocessors/appid/util/sfutil.h,
	  preprocessors/session_api.h,
	  preprocessors/spp_session.c,
	  sfutil/Unified2_common.h:
	  Snort side changes to openAppid to support openAVC

	* src/dynamic-plugins/sf_dynamic_preprocessor.h,
	  src/sfutil/sf_ip.h:
	  Bump dpd version.

	* configure.in, src/parser.c, src/fpcreate.c, src/fpdetect.c,
	  src/fpdetect, src/parser.c, src/pcrm.c, src/pcrm.h, src/signature.c,
	  src/signature.h, src/detection-plugins/Makefile.am,
	  src/detection-plugins/detection_leaf_node.c,
	  src/detection-plugins/detection_options.c,
	  src/sfutil/sfportobject.h:
	  NEW FEATURE Port Override. Adds new metadata keywords "else-ports",
	  "or-ports" and "and-ports".

	* src/sfdaq.c,
	  src/sfdaq.h,
	  src/dynamic-plugins/sf_dynamic_plugins.c,
	  src/dynamic-plugins/sf_dynamic_preprocessor.h,
	  src/dynamic-preprocessors/dcerpc2/dce2_config.c,
	  src/preprocessors/HttpInspect/user_interface/hi_ui_server_lookup.c,
	  src/sfutil/sfPolicy.c,
	  src/target-based/sftarget_reader.c:
	  Add a generic DAQ modify flow function to dpd.

	* configure.in,
	  src/debug.c,
	  src/decode.c,
	  src/decode.h,
	  src/detect.c,
	  src/detection_filter.c,
	  src/detection_filter.h,
	  src/encode.c,
	  src/fpcreate.c,
	  src/fpdetect.c,
	  src/ipv6_port.h,
	  src/log.c,
	  src/log_text.c,
	  src/parser.c,
	  src/ppm.c,
	  src/rate_filter.c,
	  src/sfdaq.c,
	  src/sfdaq.h,
	  src/sfthreshold.c,
	  src/sfthreshold.h,
	  src/snort.c,
	  src/snort.h,
	  src/snort_debug.h,
	  src/tag.c,
	  src/util.c,
	  src/util.h,
	  src/detection-plugins/sp_ftpbounce.c,
	  src/detection-plugins/sp_session.c,
	  src/dynamic-plugins/sf_dynamic_plugins.c,
	  src/dynamic-plugins/sf_dynamic_preprocessor.h,
	  src/dynamic-plugins/sf_engine/sf_snort_packet.h,
	  src/dynamic-preprocessors/appid/flow.c,
	  src/dynamic-preprocessors/appid/flow.h,
	  src/dynamic-preprocessors/appid/fw_appid.c,
	  src/dynamic-preprocessors/appid/fw_appid.h,
	  src/dynamic-preprocessors/appid/hostPortAppCache.c,
	  src/dynamic-preprocessors/appid/hostPortAppCache.h,
	  src/dynamic-preprocessors/appid/luaDetectorApi.c,
	  src/dynamic-preprocessors/appid/luaDetectorFlowApi.c,
	  src/dynamic-preprocessors/appid/rna_flow.h,
	  src/dynamic-preprocessors/appid/service_state.c,
	  src/dynamic-preprocessors/appid/service_state.h,
	  src/dynamic-preprocessors/appid/detector_plugins/detector_sip.c,
	  src/dynamic-preprocessors/appid/service_plugins/service_api.h,
	  src/dynamic-preprocessors/appid/service_plugins/service_base.c,
	  src/dynamic-preprocessors/appid/service_plugins/service_ftp.c,
	  src/dynamic-preprocessors/appid/service_plugins/service_rexec.c,
	  src/dynamic-preprocessors/appid/service_plugins/service_rpc.c,
	  src/dynamic-preprocessors/appid/service_plugins/service_rshell.c,
	  src/dynamic-preprocessors/appid/service_plugins/service_snmp.c,
	  src/dynamic-preprocessors/appid/service_plugins/service_ssl.c,
	  src/dynamic-preprocessors/appid/service_plugins/service_tftp.c,
	  src/dynamic-preprocessors/appid/util/ip_funcs.h,
	  src/dynamic-preprocessors/dcerpc2/dce2_config.c,
	  src/dynamic-preprocessors/dcerpc2/dce2_config.h,
	  src/dynamic-preprocessors/ftptelnet/ftp_bounce_lookup.c,
	  src/dynamic-preprocessors/ftptelnet/ftp_bounce_lookup.h,
	  src/dynamic-preprocessors/ftptelnet/ftpp_si.c,
	  src/dynamic-preprocessors/ftptelnet/ftpp_si.h,
	  src/dynamic-preprocessors/ftptelnet/ftpp_ui_client_lookup.c,
	  src/dynamic-preprocessors/ftptelnet/ftpp_ui_client_lookup.h,
	  src/dynamic-preprocessors/ftptelnet/ftpp_ui_config.c,
	  src/dynamic-preprocessors/ftptelnet/ftpp_ui_config.h,
	  src/dynamic-preprocessors/ftptelnet/ftpp_ui_server_lookup.c,
	  src/dynamic-preprocessors/ftptelnet/ftpp_ui_server_lookup.h,
	  src/dynamic-preprocessors/ftptelnet/pp_ftp.c,
	  src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.c,
	  src/dynamic-preprocessors/imap/spp_imap.c,
	  src/dynamic-preprocessors/reputation/reputation_config.c,
	  src/dynamic-preprocessors/reputation/spp_reputation.c,
	  src/dynamic-preprocessors/sip/sip_parser.c,
	  src/dynamic-preprocessors/ssl_common/ssl_ha.c,
	  src/dynamic-preprocessors/ssl_common/ssl_inspect.c,
	  src/file-process/file_resume_block.c, 
	  src/output-plugins/spo_alert_sf_socket.c,
	  src/output-plugins/spo_log_ascii.c,
	  src/output-plugins/spo_unified2.c,
	  src/preprocessors/perf-flow.c,
	  src/preprocessors/perf-flow.h,
	  src/preprocessors/portscan.c,
	  src/preprocessors/portscan.h,
	  src/preprocessors/session_api.h,
	  src/preprocessors/sip_common.h,
	  src/preprocessors/snort_httpinspect.c,
	  src/preprocessors/snort_httpinspect.h,
	  src/preprocessors/spp_arpspoof.c,
	  src/preprocessors/spp_frag3.c,
	  src/preprocessors/spp_session.c,
	  src/preprocessors/spp_sfportscan.c,
	  src/preprocessors/spp_stream6.c,
	  src/preprocessors/stream_api.h, 
	  src/preprocessors/HttpInspect/client/hi_client.c, 
	  src/preprocessors/HttpInspect/files/file_decomp.c, 
	  src/preprocessors/HttpInspect/include/file_decomp.h, 
	  src/preprocessors/HttpInspect/include/hi_si.h, 
	  src/preprocessors/HttpInspect/include/hi_ui_config.h, 
	  src/preprocessors/HttpInspect/include/hi_ui_server_lookup.h,
	  src/preprocessors/HttpInspect/session_inspection/hi_si.c, 
	  src/preprocessors/HttpInspect/user_interface/hi_ui_config.c,
	  src/preprocessors/HttpInspect/user_interface/hi_ui_server_lookup.c,
	  src/preprocessors/Session/session_common.h, 
	  src/preprocessors/Session/session_expect.c,
	  src/preprocessors/Session/session_expect.h,
	  src/preprocessors/Session/stream5_ha.c,
	  src/preprocessors/Session/stream5_ha.h, 
	  src/preprocessors/Stream6/snort_stream_icmp.c,
	  src/preprocessors/Stream6/snort_stream_icmp.h,
	  src/preprocessors/Stream6/snort_stream_tcp.c,
	  src/preprocessors/Stream6/snort_stream_tcp.h,
	  src/preprocessors/Stream6/snort_stream_udp.c,
	  src/preprocessors/Stream6/snort_stream_udp.h,
	  src/preprocessors/Stream6/stream_paf.c,
	  src/sfutil/ipobj.c,
	  src/sfutil/ipobj.h,
	  src/sfutil/sfPolicy.c,
	  src/sfutil/sfPolicy.h,
	  src/sfutil/sf_ip.c,
	  src/sfutil/sf_ip.h,
	  src/sfutil/sf_iph.c,
	  src/sfutil/sf_iph.h,
	  src/sfutil/sf_ipvar.c,
	  src/sfutil/sf_ipvar.h,
	  src/sfutil/sf_vartable.c,
	  src/sfutil/sfrf.c,
	  src/sfutil/sfrf.h,
	  src/sfutil/sfrt.c,
	  src/sfutil/sfrt.h,
	  src/sfutil/sfrt_dir.c,
	  src/sfutil/sfrt_dir.h,
	  src/sfutil/sfrt_flat.c,
	  src/sfutil/sfrt_flat.h,
	  src/sfutil/sfrt_flat_dir.c,
	  src/sfutil/sfrt_flat_dir.h,
	  src/sfutil/sfthd.c,
	  src/sfutil/sfthd.h,
	  src/sfutil/util_net.c,
	  src/sfutil/util_net.h,
	  src/sfutil/test/sf_ip_test.c,
	  src/sfutil/test/sfrf_test.c,
	  src/sfutil/test/sfrt_test.c,
	  src/sfutil/test/sfthd_test.c,
	  src/side-channel/sidechannel.c,
	  src/target-based/sftarget_reader.c,
	  src/target-based/sftarget_reader.h: 
	  Refactor sfip_t/sfaddr_t code to be compatible with struct in6_addr.

2015-08-13 Rahul Burman <rahburma@cisco.com>
Snort 2.9.7.6
    * src/build.h:
          updating build number to 285

    * src/dynamic-preprocessors/reputation/reputation_config.c:
          Fixed unexpected behaviour in reputation config where blacklist is displayed
          in priority field even though whitelist option is set [reported by Mike Cox].

    * src/preprocessors/Stream6/snort_stream_tcp.c:
          Fixed issue where XFF/ExtraData is not always logged when 'drop' rules trigger [reported by Mike Cox].
          Fixed issue in TCP session deletion when being called from Stream5 HA.

    * src/: active.h, file-process/file_service.c:
          ACTIVE_DROP is changed to ACTIVE_FORCE_DROP when file_verdict is pending.

    * src/dynamic-preprocessors/appid/fw_appid.c:
          Fixed issue where openappid does not provide the Content-Type field for use with CHPAddAction.

    * doc/snort_manual.tex:
          Corrected errors in snort_manual.tex [reported by Gabriel Corre].

    * preproc_rules/preprocessor.rules
          src/preprocessors/: session_api.h, snort_httpinspect.c,
          HttpInspect/event_output/hi_eo_log.c, HttpInspect/include/hi_eo_events.h
          Stream6/snort_stream_tcp.c:
          Enhancement done to detect 'SSH tunneling over HTTP'.

    * src/sfutil/sfportobject.c:
          Fixed Memory leaks [reported by Bill Parker].

    * doc/snort_manual.tex:
          Corrected the information about unified2 record structure [reported by Avery Rozar].

    * etc/snort.conf, src/preprocessors/snort_httpinspect.c,
	  src/preprocessors/snort_httpinspect.h,
          src/preprocessors/HttpInspect/client/hi_client.c,
          src/preprocessors/HttpInspect/server/hi_server.c,
          src/preprocessors/Stream6/stream_paf.c:
          Fixed issue where original client IP in intrusion event is incorrectly
          populated with XFF of the last GET request.

    * src/preprocessors/: snort_httpinspect.c, snort_httpinspect.h,
          HttpInspect/server/hi_server.c,
          snort_httpinspect.c, snort_httpinspect.h,
          HttpInspect/server/hi_server.c:
          Http unlimited decompression will now decompress the entire stream.

    * src/decode.c:
          Added a check so that min_ttl decoder do not drop packet in alert mode.

    * etc/snort.conf, src/preprocessors/snort_httpinspect.c,
          src/preprocessors/snort_httpinspect.h,
          src/preprocessors/HttpInspect/client/hi_client.c,
          src/preprocessors/HttpInspect/server/hi_server.c
          Fixed issue where original client IP in intrusion event is incorrectly populated with XFF of the last GET request.

2015-07-01 Carter Waxman <cwaxman@cisco.com>
Snort 2.9.7.5
    * src/build.h:
      updating build number to 262

    * src/preprocessors/Stream6/snort_stream_tcp.c: 
      Improved handling of asymmetric traffic

    * src/active.c: 
      Active responses no longer set the FIN flag on the last segment
      transmitted

    * src/dynamic-preprocessors/appid/luaDetectorApi.c:
      Added sanity checks to client api
      
    * doc/snort_manual.pdf,
      src/: dynamic-preprocessors/dcerpc2/dce2_paf.c,
      dynamic-preprocessors/dnp3/dnp3_paf.c,
      dynamic-preprocessors/ftptelnet/snort_ftptelnet.c,
      dynamic-preprocessors/imap/imap_paf.c,
      dynamic-preprocessors/pop/pop_paf.c,
      dynamic-preprocessors/sip/sip_paf.c,
      dynamic-preprocessors/smtp/smtp_paf.c,
      preprocessors/session_api.h, preprocessors/spp_stream6.c,
      preprocessors/stream_api.h,
      preprocessors/HttpInspect/utils/hi_paf.c,
      preprocessors/Session/session_common.h,
      preprocessors/Stream6/snort_stream_tcp.c,
      preprocessors/Stream6/snort_stream_tcp.h,
      preprocessors/Stream6/stream_paf.c,
      preprocessors/Stream6/stream_paf.h: 
      Multiple PAF clients can Read/Write to the same user data

    * src/: file-process/file_api.h, file-process/file_mail_common.h,
      file-process/file_mime_process.c,
      sfutil/sf_email_attach_decode.c, sfutil/sf_email_attach_decode.h: 
      Fixed filename parsing from Mime body for UUencoded MIME

    * src/preprocessors/perf-base.c,
      src/preprocessors/Stream6/snort_stream_tcp.c: 
      Prunes triggered by timeouts are now accounted by perfmonitor.

    * src/preprocessors/spp_session.c: 
      Log warning instead of Fatal Error
      if a stream5_global config is in a non-default policy
      
    * src/detection-plugins/sp_base64_decode.c: 
      Removed unused checks
      
    * src/snort.c:
      Improved reliability of configuration reloads

    * src/preprocessors/snort_httpinspect.c: 
      Fixed issue in http
      file processing where SHAs may not always be correct.

    * doc/snort_manual.pdf,
      src/sfutil/sf_email_attach_decode.c: 
      Fixed handling new line chars in QP encoding
      

    * src/preprocessors/snort_httpinspect.c: 
      Fixed inconsistent behavior when configuring "max_gzip_mem -1"

2015-22-04 Joel Cornett <jocornet@cisco.com>
Snort 2.9.7.3
    * src/build.h:
      updating build number to 217

    * src/: decode.h, detection-plugins/sp_clientserver.c,
      dynamic-plugins/sf_engine/sf_snort_packet.h,
      dynamic-plugins/sf_engine/sf_snort_plugin_api.c,
      dynamic-preprocessors/dcerpc2/dce2_session.h,
      dynamic-preprocessors/sdf/spp_sdf.c,
      preprocessors/HttpInspect/server/hi_server.c,
      preprocessors/Stream6/snort_stream_tcp.c,
      preprocessors/snort_httpinspect.c, preprocessors/spp_normalize.c:
      Added mode safety checks to normalization.
      Fixed an issue in PAF where the start of the PDU after flushing was not
      being set correctly in some case.
      Improved Stream reassembly of HTTPS sessions

    * src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.c:
      Stability improvements for ftp_telnet preprocessor

    * doc/snort_manual.pdf, doc/snort_manual.tex,
      src/detection-plugins/sp_base64_decode.c,
      src/detection-plugins/sp_base64_decode.h,
      src/detection-plugins/sp_file_data.c:
      Improved performance for file preprocessor
      Documentation changes

    * src/dynamic-preprocessors/appid/: service_plugins/service_base.c,
      service_state.c:
      Various OpenAppId improvements

    * configure.in:
      Fixed issue with configure script handling of -Werror compiler flags

    * src/decode.c:
      Improved decoding of IPv6 extensions

    * src/detection-plugins/detection_options.c:
      Fixed an issue where the protected_content rule option was not
      backtracking correctly in some cases

    * src/snort.c:
      Fixed snort handling of PID files

    * tools/: u2openappid/u2openappid.c, u2spewfoo/u2spewfoo.c:
      Fixed usage info.

    * src/dynamic-preprocessors/sip/: Makefile.am, sf_sip.dsp, sip_dialog.c,
      sip_parser.c, spp_sip.c:
      Added PAF support for TCP traffic

    * src/: log_text.c, log_text.h, output-plugins/spo_alert_fast.c,
      output-plugins/spo_alert_full.c:
      Extended support for OpenAppId logging to cmg and console output loggers

    * src/dynamic-preprocessors/appid/service_plugins/service_ssl.c:
      Improved SSLv3 handling for OpenAppId

2014-24-12 Victor Roemer <viroemer@cisco.com>
Snort 2.9.7.2
    * src/build.h:
      updating build number to 177

    * src/preprocessors/Stream6/snort_stream_tcp.c:
	  Resolved an issue where the inline normalization preprocessor
	  incorrectly resized packets when 'preprocessor normalize_tcp: trim'
	  was enabled.

    * src/decode.c, src/encode.c:
      Added support for Cisco FabricPath decoding/encoding.
      Ensure flow_id is copied into the DAQ_PktHdr_t.

    * src/snort.h, src/sfutil/sfrt.c, src/sfutil/sfrt.h
      src/target-based/sftarget_reader.c:
      Moved ntohl conversion inside of the sfrt api for both IPv4 and IPv6.

    * src/target-based/sftarget_protocol_reference.c
      Lookup application protocol id only after the session is established.
      Assign application protocol id to the session when using host attribute table.

    * src/util.c:
      Changes for suppressing configuration logging.

    * src/file-process/file_service.c:
      Assign the file config to a file context prior to checking if HTTP continuation.

2014-10-10 Carter Waxman <cwaxman@cisco.com>
Snort 2.9.7.0
    * src/build.h: updating build number to 149
    
    * src/dynamic-preprocessors/appid/spp_appid.c:
      Fixed issue in which AppID would be disabled after a reload.
    
    * configure.in:
      Added dependency for OpenSSL when building with --enable-openappid
    
    * doc/: README.http_inspect, snort_manual.pdf, snort_manual.tex:
      Added documentation for the new Extended X-Forwarded-For
      capabilities

    * src/preprocessors/Stream6/snort_stream_tcp.c:
      Reused the TcpSessionCleanup logic to add a function to flush queued unacked segments.

2014-09-15 Joel Cornett <jocornet@cisco.com>
Snort 2.9.7.0-rc
    * src/build.h:
      updating build number to 147

    * configure.in,
      src/sfdaq.c:
      Fixed C99 compliance issue with DAQ.

    * src/preprocessors/:
      Stream6/snort_stream_tcp.c,
      spp_session.c:
      Improved stability of TCP session decoding.

    * tools/u2streamer/u2streamer.c:
      Improved stability of u2streamer tool.

    * src/snort.c:
      Fixed issue with daemonization mode. Thanks to Eugenio Perez
      for noting the issue and proposing a fix.

    * src/:
      dynamic-plugins/sf_dynamic_plugins.c,
      dynamic-plugins/sf_dynamic_preprocessor.h,
      preprocessor/Stream6/snort_stream_tcp.c,
      encode.c, encode.h, snort.c, snort.h:
      Added support to detect heartbleed attacks.

    * build/dobuild.sh,
      rpm/README.build_rpms, rpm/generate-all-rpms, rpm/snort.spec,
      src/dynamic-preprocessors/appid/Makefile.am:
      Added OpenAppID to snort RPM.

    * doc/: README.active, README.file_ips, INSTALL, snort_manual.tex: 
      Updated documentation.

    * doc/INSTALL:
      Added common configuration mistakes and fixes to INSTALL.
      Thanks to Bill Parker for the documentation.

    * src/dynamic-preprocessors/ftptelnet/pp_ftp.c:
      Improved FTP traffic handling.

    * src/dynamic-preprocessors/appid/detector_plugins:
      detector_http.c, detector_imap.c, detector_pop3.c:
      Improved stability of OpenAppID preprocessor parsing HTTP
      headers.

    * src/:
      parser.c, snort.c, snort.h, util.c:
      Added a new option `--suppress-config-log` to Snort command
      line arguments. This option suppresses logging of
      configuration information to output.

    * src/:
      active.c, active.h,
      preprocessors/Stream6/snort_stream_ip.c,
      preprocessors/Stream6/snort_stream_tcp.c,
      preprocessors/Stream6/snort_stream_udp.c:
      Fixed issue with blacklisting of flow traffic.

    * src/preprocessors:
      spp_session.c, spp_stream6.c:
      Improved stability of Stream6 preprocessor.

    * configure.in,
      src/dynamic-preprocessors/ftptelnet/ftpp_si.c,
      src/dynamic-preprocessors/ftptelnet/ftpp_si.h,
      src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.c,
      src/dynamic-preprocessors/imap/snort_imap.c,
      src/dynamic-preprocessors/imap/snort_imap.h,
      src/dynamic-preprocessors/pop/snort_pop.c,
      src/dynamic-preprocessors/pop/snort_pop.h,
      src/dynamic-preprocessors/smtp/snort_smtp.c,
      src/dynamic-preprocessors/smtp/snort_smtp.h,
      src/dynamic-preprocessors/ssl_common/ssl_include.h,
      src/dynamic-preprocessors/ssl_common/ssl_inspect.c,
      src/dynamic-preprocessors/ssl_common/ssl_session.h,
      src/encode.c:
      Fixed encoding issue with DAQ packet headers.

    * doc/README.ssl,
      doc/snort_manual.pdf,
      doc/snort_manual.tex,
      etc/gen-msg.map,
      preproc_rules/preprocessor.rules,
      src/dynamic-preprocessors/ssl_common/ssl.c,
      src/dynamic-preprocessors/ssl_common/ssl.h,
      src/dynamic-preprocessors/ssl_common/ssl_config.c,
      src/dynamic-preprocessors/ssl_common/ssl_config.h,
      src/dynamic-preprocessors/ssl_common/ssl_inspect.c,
      src/dynamic-preprocessors/ssl_common/ssl_inspect.h,
      src/dynamic-preprocessors/ssl_common/ssl_session.h:
      Added support to detect heartbleed attacks.

    * doc/snort_manual.tex,
      src/dynamic-examples/dynamic-rule/detection_lib_meta.h,
      src/dynamic-plugins/sf_dynamic_engine.h,
      src/dynamic-plugins/sf_dynamic_meta.h,
      src/dynamic-plugins/sf_dynamic_preprocessor.h,
      src/dynamic-plugins/sf_engine/examples/detection_lib_meta.h,
      src/dynamic-plugins/sf_engine/sf_snort_packet.h,
      src/preprocessors/Stream6/snort_stream_tcp.c,
      src/decode.c, src/decode.h, src/encode.c, src/parser.c,
      src/parser.h, src/snort.c, src/snort.h:
      Added a new config option `max_ip6_extensions` to change the
      maximum number of IPv6 extension headers decoded. Thanks to
      Antonio Atlasis for providing data to the ChangeLog.

    * src/dynamic-preprocessors/modbus/:
      modbus_paf.h, modbus_roptions.c, spp_modbus.c:
      Improved traffic handling by modbus preprocessor

    * src/:
      dynamic-preprocessors/dns/spp_dns.c,
      dynamic-preprocessors/imap/spp_imap.c,
      dynamic-preprocessors/pop/spp_pop.c,
      dynamic-preprocessors/smtp/spp_smtp.c,
      dynamic-preprocessors/ssh/spp_ssh.c,
      preprocessors/spp_session.c:
      Fixed issue with stream configuration state changing across
      reloads. Thanks to Eugenio Perez for noting the issue.

    * src/dynamic-preprocessors/appid/Makefile.am:
      Fixed compilation issue with OpenAppID on OpenBSD.

    * src/plugbase.c:
      Improved implementation of plugin API.

    * src:
      detection-plugins/sp_ftpbounce.c,
      dynamic-preprocessors/ftptelnet/snort_ftptelnet.c:
      Improved stability of FTP preprocessor.

    * configure.in,
      src/dynamic-preprocessors/appid/appIdConfig.c,
      src/dynamic-preprocessors/appid/appIdConfig.h,
      src/dynamic-preprocessors/appid/flow.h,
      src/dynamic-preprocessors/appid/fw_appid.c,
      src/dynamic-preprocessors/appid/fw_appid.h,
      src/dynamic-preprocessors/appid/luaDetectorApi.h:
      Fixed compilation issues with OpenAppID on Mac OS X.

    * src/preprocessors/:
      perf-flow.c, spp_perfmonitor.c:
      Minimum flow-ip-memcap changed to 8200.

    * src/sf_sdlist.c:
      Fixed implementation of `sf_sdlist`. Thanks to Yang Zhang
      for noting the issue.

    * src/:
      preprocessors/Stream6/snort_stream_tcp.c,
      preprocessors/spp_frag3.c,
      preprocessors/spp_normalize.c:
      active.h, decode.c,
      Check checksum configuration as well as na_policy_mode
      setting before drop.

    * src/preprocessors/snort_httpinspect.c:
      Improved handling in HTTPInspect preprocessor.

    * src/sfutil/mpse.c:
      Fixed building snort with --disable-perfprofiling. Thanks to
      Yonatan Ben-David for noting the issue.

    * src:
      encode.c, encode.h:
      Fixed ICMPv6 encoding issue.

    * etc/snort.conf,
      src/detection-plugins/sp_file_type.c,
      src/dynamic-preprocessors/Makefile.am,
      src/dynamic-preprocessors/ftptelnet/Makefile.am,
      src/dynamic-preprocessors/imap/Makefile.am,
      src/dynamic-preprocessors/pop/Makefile.am,
      src/dynamic-preprocessors/sf_dynamic_initialize/sf_dynamic_initialize.dsp,
      src/dynamic-preprocessors/smtp/Makefile.am,
      src/dynamic-preprocessors/ssl/Makefile.am,
      src/preprocessors/Session/Makefile.am,
      src/win32/WIN32-Prj/sf_engine.dsp,
      src/win32/WIN32-Prj/snort.dsp,
      src/win32/WIN32-Prj/snort.dsw,
      src/win32/WIN32-Prj/snort_installer.nsi:
      Fixed Win32 and distcheck build issues.

    * doc/OpenDetectorDeveloperGuide.docx,
      doc/OpenDetectorDeveloperGuide.pdf,
      src/dynamic-preprocessors/appid/Makefile.am,
      src/dynamic-preprocessors/appid/appInfoTable.c,
      src/dynamic-preprocessors/appid/detector_plugins/detector_http.c,
      src/dynamic-preprocessors/appid/detector_plugins/detector_http.h,
      src/dynamic-preprocessors/appid/fw_appid.c,
      src/dynamic-preprocessors/appid/httpCommon.h,
      src/dynamic-preprocessors/appid/luaDetectorApi.c,
      src/dynamic-preprocessors/appid/service_plugins/service_base.c,
      src/dynamic-preprocessors/appid/service_plugins/service_rtmp.c,
      src/dynamic-preprocessors/appid/service_plugins/service_rtmp.h:
      Added RTMP detector (w/ metadata) to OpenAppID and updated
      Lua API.

2014-06-04 Carter Waxman <cwaxman@cisco.com>
Snort 2.9.7.0.beta
    * src/build.h:
      updating build number to 109

    * src/: detection-plugins/sp_base64_decode.c,
      dynamic-plugins/sf_engine/sf_snort_plugin_api.c:
      Use correct buffer size for base64 decoding.
      Fix the bound check for base64_decode rule. Thanks Joshua providing the
      patch.

    * src/: detect.c,
      dynamic-preprocessors/reputation/spp_reputation.c,
      dynamic-preprocessors/reputation/shmem/shmem_config.h,
      dynamic-preprocessors/reputation/shmem/shmem_mgmt.c,
      preprocessors/session_api.h, preprocessors/spp_session.c:
      Improved reputation performance by only checking IPs once per
      session. Changed control socket to respond 0 when reloading empty IP
      reputation lists. Avoid registering reputation preprocessor when there are no IP lists

    * src/: active.c, fpdetect.c,
      dynamic-preprocessors/dcerpc2/dce2_smb.c,
      file-process/file_resume_block.c: 
      Fixed build issue when configuring with --disable-active-response
      --disable-react --disable-flexresp3 (Reported by Jeremy Hoel)

    * src/parser.c
      src/preprocessors/Session/stream5_ha.c,
      src/preprocessors/Stream6/snort_stream_icmp.c,
      src/preprocessors/Stream6/snort_stream_tcp.c,
      src/preprocessors/Stream6/snort_stream_udp.c,
      src/preprocessors/spp_session.c:
      Fixed configuration parsing issues.

    * src/: fpcreate.c, fpdetect.c:
      Fixed rule protocol mapping when using target-based detection.

    * src/preprocessors/perf-base.c: 
      Added field in now files for number of normalizers used.

    * src/preprocessors/Stream6/snort_stream_tcp.c:
      Fix handling of data on syn for Mac OSX reassembly.

    * src/dynamic-plugins/sf_dynamic_plugins.c:
      Remove optional field check to improve compatiblity for DragonFlyBSD.
      Thanks Joshua Kinard providing patch.

    * src/detect.c:
      Fixed AppID not correctly handling packets without sessions (Discovered by
      James Lay)

    * src/preprocessors/snort_httpinspect.c:
      Fixed issue with HTTP session data handling. (Discovered by James Lay)

    * src/snort.c:
      Fixed parsing of custom rule types on reload.

    * src/util.c:
      Fixed timestamp arithmetic error (Reported by David Turnbull)

    * src/: sf_protocols.h, preprocessors/perf-base.c,
      preprocessors/perf-base.h, preprocessors/session_api.h,
      preprocessors/spp_session.c, preprocessors/spp_stream6.c,
      preprocessors/stream_api.h,
      preprocessors/Stream6/stream_common.c,
      preprocessors/Stream6/stream_common.h:
      Fixed IP protocol number type (Reported by Joshua Kinard)

    * src/: strlcatu.h, strlcpyu.h:
      Wrap function signatures for strlcat/strlcpy.  Thanks to James
      Golab for reporting the issue.

     * doc/: snort_manual.pdf, snort_manual.tex:
      Typos fixed (Credit to Jenah J. Sigurdson)
    
    * src/: encode.h, parser.c, dynamic-preprocessors/imap/imap_paf.c,
      dynamic-preprocessors/pop/pop_paf.c,
      dynamic-preprocessors/smtp/smtp_paf.c,
      file-process/file_mail_common.h, preprocessors/stream_api.h,
      preprocessors/Stream6/stream_paf.c:
      Fixed PAF flushing behavior when encountering gaps.
      paf_max now has a hard flush limit of ~64,000. Email protocols will
      flush within 1500 characters of paf_max.

    * src/: dynamic-preprocessors/dns/spp_dns.c,
      dynamic-preprocessors/imap/snort_imap.c,
      dynamic-preprocessors/pop/snort_pop.c,
      preprocessors/session_api.h, preprocessors/spp_rpc_decode.c,
      preprocessors/spp_session.c,
      preprocessors/Stream6/snort_stream_tcp.c:
      Changed flushing to use receiver's flush policy in all functions.
      Updated POP, IMAP, DNS, RPC, and SSL to use the correct directions.
      Added SSN_TO_SERVER(SSN_FROM_CLIENT) and SSN_TO_CLIENT(SSN_FROM_SERVER)
      to make code more readable (Discovered by John Enure).

    * src/detection_util.c:
      Fixed Http buffer name initialization.

    * src/preprocessors/HttpInspect/normalization/hi_norm.c:
      Fixed URI parsing and normalization.

    * doc/README.file_ips, src/plugbase.c, src/rule_option_types.h,
      src/detection-plugins/Makefile.am,
      src/detection-plugins/detection_options.c,
      src/detection-plugins/sp_file_type.c,
      src/file-process/file_api.h, src/file-process/file_service.c,
      src/file-process/libs/file_config.c,
      src/file-process/libs/file_config.h,
      src/file-process/libs/file_identifier.c,
      src/file-process/libs/file_lib.c,
      src/file-process/libs/file_lib.h:
      Allow registration of the same file type callback.
      Harden file_type and file_group rule options.
      Fix file id to always use the matched file id.
      File identifier rule options 'type' and 'ver' no longer accept
      arbitrary ASCII characters as valid arguments, only
      permitting [A-Za-z0-9_.] characters.
      Snort's 'file_type' rule option now checks for trailing comma (,)
      and pipe (|) separators and other typo like mistakes.

    * configure.in,
      src/active.c,
      src/active.h,
      src/decode.c,
      src/detection-plugins/detection_options.c,
      src/detection-plugins/sp_replace.c,
      src/dynamic-plugins/sf_dynamic_plugins.c,
      src/parser.c,
      src/parser.h,
      src/preprocessors/Stream6/snort_stream_tcp.c,
      src/preprocessors/normalize.c,
      src/preprocessors/normalize.h,
      src/preprocessors/perf-base.c,
      src/preprocessors/perf-base.h,
      src/preprocessors/spp_normalize.c,
      src/preprocessors/spp_normalize.h,
      src/preprocessors/spp_session.c,
      src/snort.c,
      src/snort.h:
      Added would-normalize normalization statistics for inline_test mode.
      Normalization behavior now enabled / configured using na_policy_mode.
      Fix typos in spp_normalize.c (Thanks to Gregory S Thomas for mentioning).

    * doc/README.normalize, doc/snort_manual.pdf, doc/snort_manual.tex,
      src/preprocessors/normalize.c, src/preprocessors/perf-base.c,
      src/preprocessors/perf-base.h, src/preprocessors/spp_normalize.c,
      src/preprocessors/spp_normalize.h,
      src/preprocessors/Stream6/snort_stream_tcp.c:
      TCP normalization configurations have been split into more granular options.
      URP normalization is now ENABLED with the "urp" keyword instead of
      DISABLED. New performance monitor stats have been introduced for these
      changes.

    * src/decode.h,
      src/detect.c,
      src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.c,
      src/preprocessors/Session/session_expect.c,
      src/preprocessors/Stream6/snort_stream_tcp.c,
      src/preprocessors/spp_stream6.c,
      src/preprocessors/stream_api.h:
      Changed priority of ftp-telnet reassembly to improve performance.
      Process end of file data correctly for ftp data channel.

    * etc/file_magic.conf, 
      src/sfutil/sf_email_attach_decode.c:
      File type UUENCODED is now all caps.
      Set file data pointer correctly after UU decoding ends.

    * src/: dynamic-preprocessors/imap/imap_config.c,
      dynamic-preprocessors/pop/pop_config.c,
      dynamic-preprocessors/smtp/smtp_config.c,
      file-process/file_mime_config.c, file-process/file_mime_config.h:
      +0 and -0 are no longer valid values for decoding depth.
    
    * src/dynamic-preprocessors/dnp3/spp_dnp3.c:
      Validate DNP3 packets before processing.
    
    * src/: snort.c, snort.h, sfutil/intel-soft-cpm.c,
      sfutil/intel-soft-cpm.h:
      Fixed issues during reload.

    * configure.in,
      doc/README.http_inspect,
      doc/snort_manual.pdf,
      doc/snort_manual.tex,
      etc/gen-msg.map,
      preproc_rules/preprocessor.rules,
      src/generators.h,
      src/preprocessors/HttpInspect/Makefile.am,
      src/preprocessors/HttpInspect/event_output/hi_eo_log.c,
      src/preprocessors/HttpInspect/files/Makefile.am,
      src/preprocessors/HttpInspect/files/file_decomp.c,
      src/preprocessors/HttpInspect/files/file_decomp_PDF.c,
      src/preprocessors/HttpInspect/files/file_decomp_SWF.c,
      src/preprocessors/HttpInspect/files/include/file_decomp.h,
      src/preprocessors/HttpInspect/files/include/file_decomp_PDF.h
      src/preprocessors/HttpInspect/include/Makefile.am,
      src/preprocessors/HttpInspect/include/file_decomp.h,
      src/preprocessors/HttpInspect/include/file_decomp_PDF.h,
      src/preprocessors/HttpInspect/include/file_decomp_SWF.h,
      src/preprocessors/HttpInspect/include/hi_eo_events.h,
      src/preprocessors/HttpInspect/include/hi_include.h,
      src/preprocessors/HttpInspect/include/hi_ui_config.h,
      src/preprocessors/HttpInspect/server/hi_server.cr,
      src/preprocessors/snort_httpinspect.c,
      src/preprocessors/snort_httpinspect.h,
      src/preprocessors/spp_httpinspect.c,
      src/util.c:
      Added ability for HttpInspect to decompress DEFLATE and LZMA encoded
      SWF content and DEFLATE encoded pdf content.

    * src/preprocessors/spp_perfmonitor.c:
      Fixed race condition in perf montitor during reload.

    * src/preprocessors/HttpInspect/client/hi_client.c,
      src/preprocessors/HttpInspect/include/hi_client.h,
      src/preprocessors/HttpInspect/include/hi_ui_config.h,
      src/preprocessors/HttpInspect/user_interface/hi_ui_config.c,
      src/preprocessors/snort_httpinspect.c:
      Added Enhanced XFF support to HttpInspect.

    * src/profiler.c:
      Fixed duplicate profiler entries when using multiple policies.

    * configure.in, src/Makefile.am, src/dump.c, src/dump.h,
      src/snort.c, src/control/sfcontrol.h, tools/control/Makefile.am,
      tools/control/README.snort_dump_packets_control,
      tools/control/sfcontrol.c, tools/control/snort_dump_packets.c:
      Added control socket command to dump packets.

    * src/: preprocessors/snort_httpinspect.c,
      preprocessors/snort_httpinspect.h,
      preprocessors/HttpInspect/client/hi_client.c,
      preprocessors/HttpInspect/include/hi_ui_config.h,
      preprocessors/HttpInspect/include/hi_ui_iis_unicode_map.h,
      preprocessors/HttpInspect/session_inspection/hi_si.c,
      preprocessors/HttpInspect/user_interface/hi_ui_config.c,
      preprocessors/HttpInspect/user_interface/hi_ui_iis_unicode_map.c,
      sfutil/util_jsnorm.c, sfutil/util_jsnorm.h:
      Removed dead max_pipeline and inspection_type configurations.
      Improved memory efficiency of unicode->ascii map.
      Expanded possible number of preprocessor alerts for HttpInspect from 31 to 63.

    * src/dynamic-preprocessors/sdf/sdf_pattern_match.c:
      Fixed FindPiiRecursively to better handle partial matches.

    * src/dynamic-preprocessors/sip/sip_parser.c:
      Fixed handling SDP when caller and callee have identical session
      ids.

    * src/: dynamic-preprocessors/Makefile.am,
      dynamic-preprocessors/sip/sip_config.h,
      dynamic-preprocessors/sip/sip_dialog.c,
      dynamic-preprocessors/sip/spp_sip.h, preprocessors/Makefile.am,
      preprocessors/sip_common.h, preprocessors/spp_stream6.c,
      preprocessors/stream_api.h:
      Support better SIP parsing and call handling.
    
    * Makefile.am,
      configure.in,
      doc/Makefile.am,
      doc/README,
      doc/README.frag3,
      doc/USAGE,
      doc/WISHLIST,
      doc/snort_manual.tex,
      dynamic-plugins/sf_dynamic_plugins.c,
      dynamic-plugins/sf_dynamic_preprocessor.h,
      dynamic-preprocessors/ftptelnet/ftpp_si.c,
      dynamic-preprocessors/ftptelnet/snort_ftptelnet.c,
      dynamic-preprocessors/imap/snort_imap.c,
      dynamic-preprocessors/pop/snort_pop.c,
      dynamic-preprocessors/smtp/snort_smtp.c,
      dynamic-preprocessors/ssl_common/ssl_config.c,
      dynamic-preprocessors/ssl_common/ssl_include.h,
      dynamic-preprocessors/ssl_common/ssl_inspect.c,
      etc/Makefile.am,
      etc/gen-msg.map,
      libs/ssl_include.h,
      rpm/snort.spec,
      snort.8,
      src/Makefile.am,
      src/active.c,
      src/active.h,
      src/byte_extract.c,
      src/checksum.h,
      src/debug.c,
      src/decode.c,
      src/decode.h,
      src/detect.c,
      src/detect.h,
      src/detection-plugins/detection_options.c,
      src/detection-plugins/detection_options.h,
      src/detection-plugins/sp_asn1.c,
      src/detection-plugins/sp_asn1_detect.c,
      src/detection-plugins/sp_byte_check.c,
      src/detection-plugins/sp_byte_check.h,
      src/detection-plugins/sp_byte_jump.c,
      src/detection-plugins/sp_byte_jump.h,
      src/detection-plugins/sp_clientserver.c,
      src/detection-plugins/sp_clientserver.h,
      src/detection-plugins/sp_dsize_check.c,
      src/detection-plugins/sp_dsize_check.h,
      src/detection-plugins/sp_flowbits.c,
      src/detection-plugins/sp_flowbits.h,
      src/detection-plugins/sp_ftpbounce.c,
      src/detection-plugins/sp_ftpbounce.h,
      src/detection-plugins/sp_icmp_code_check.c,
      src/detection-plugins/sp_icmp_code_check.h,
      src/detection-plugins/sp_icmp_id_check.c,
      src/detection-plugins/sp_icmp_id_check.h,
      src/detection-plugins/sp_icmp_seq_check.c,
      src/detection-plugins/sp_icmp_seq_check.h,
      src/detection-plugins/sp_icmp_type_check.c,
      src/detection-plugins/sp_icmp_type_check.h,
      src/detection-plugins/sp_ip_fragbits.c,
      src/detection-plugins/sp_ip_fragbits.h,
      src/detection-plugins/sp_ip_id_check.c,
      src/detection-plugins/sp_ip_id_check.h,
      src/detection-plugins/sp_ip_proto.c,
      src/detection-plugins/sp_ip_proto.h,
      src/detection-plugins/sp_ip_same_check.c,
      src/detection-plugins/sp_ip_same_check.h,
      src/detection-plugins/sp_ip_tos_check.c,
      src/detection-plugins/sp_ip_tos_check.h,
      src/detection-plugins/sp_ipoption_check.c,
      src/detection-plugins/sp_ipoption_check.h,
      src/detection-plugins/sp_isdataat.c,
      src/detection-plugins/sp_isdataat.h,
      src/detection-plugins/sp_pattern_match.c,
      src/detection-plugins/sp_pattern_match.h,
      src/detection-plugins/sp_pcre.c,
      src/detection-plugins/sp_react.c,
      src/detection-plugins/sp_react.h,
      src/detection-plugins/sp_replace.c,
      src/detection-plugins/sp_replace.h,
      src/detection-plugins/sp_respond.h,
      src/detection-plugins/sp_respond3.c,
      src/detection-plugins/sp_rpc_check.c,
      src/detection-plugins/sp_rpc_check.h,
      src/detection-plugins/sp_session.c,
      src/detection-plugins/sp_session.h,
      src/detection-plugins/sp_tcp_ack_check.c,
      src/detection-plugins/sp_tcp_ack_check.h,
      src/detection-plugins/sp_tcp_flag_check.c,
      src/detection-plugins/sp_tcp_flag_check.h,
      src/detection-plugins/sp_tcp_seq_check.c,
      src/detection-plugins/sp_tcp_seq_check.h,
      src/detection-plugins/sp_tcp_win_check.c,
      src/detection-plugins/sp_tcp_win_check.h,
      src/detection-plugins/sp_ttl_check.c,
      src/detection-plugins/sp_ttl_check.h,
      src/detection_filter.c,
      src/detection_filter.h,
      src/detection_util.c,
      src/detection_util.h,
      src/dynamic-examples/Makefile.am,
      src/dynamic-plugins/sf_convert_dynamic.c,
      src/dynamic-plugins/sf_convert_dynamic.h,
      src/dynamic-plugins/sf_dynamic_plugins.c,
      src/dynamic-plugins/sf_dynamic_preprocessor.h,
      src/dynamic-plugins/sf_preproc_example/sf_dynamic_preproc_lib.c,
      src/dynamic-plugins/sf_preproc_example/sf_dynamic_preproc_lib.h,
      src/dynamic-plugins/sf_preproc_example/spp_nfs_setup.c,
      src/dynamic-plugins/sf_preproc_example/spp_nfs_setup.h,
      src/dynamic-plugins/sf_src/dynamic_plugins.c,
      src/dynamic-plugins/sf_src/dynamic_preprocessor.h,
      src/dynamic-plugins/sp_dynamic.c,
      src/dynamic-plugins/sp_dynamic.h,
      src/dynamic-plugins/sp_preprocopt.c,
      src/dynamic-plugins/sp_preprocopt.h,
      src/dynamic-preprocessors/Makefile.am,
      src/dynamic-preprocessors/ftptelnet/Makefile.am,
      src/dynamic-preprocessors/ftptelnet/ftpp_si.c,
      src/dynamic-preprocessors/ftptelnet/ftpp_si.h,
      src/dynamic-preprocessors/ftptelnet/pp_ftp.c,
      src/dynamic-preprocessors/ftptelnet/pp_telnet.c,
      src/dynamic-preprocessors/ftptelnet/sf_ftptelnet.dsp,
      src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.c,
      src/dynamic-preprocessors/imap/Makefile.am,
      src/dynamic-preprocessors/imap/imap_config.c,
      src/dynamic-preprocessors/imap/imap_config.h,
      src/dynamic-preprocessors/imap/imap_log.c,
      src/dynamic-preprocessors/imap/imap_log.h,
      src/dynamic-preprocessors/imap/imap_util.c,
      src/dynamic-preprocessors/imap/imap_util.h,
      src/dynamic-preprocessors/imap/sf_imap.dsp,
      src/dynamic-preprocessors/imap/snort_imap.c,
      src/dynamic-preprocessors/imap/snort_imap.h,
      src/dynamic-preprocessors/imap/spp_imap.c,
      src/dynamic-preprocessors/imap/spp_imap.h,
      src/dynamic-preprocessors/libs/Makefile.am,
      src/dynamic-preprocessors/libs/sfdynamic_preproc_libs.dsp,
      src/dynamic-preprocessors/libs/ssl.c,
      src/dynamic-preprocessors/libs/ssl.h,
      src/dynamic-preprocessors/libs/ssl_include.h,
      src/dynamic-preprocessors/pop/Makefile.am,
      src/dynamic-preprocessors/pop/pop_config.c,
      src/dynamic-preprocessors/pop/pop_config.h,
      src/dynamic-preprocessors/pop/pop_log.c,
      src/dynamic-preprocessors/pop/pop_log.h,
      src/dynamic-preprocessors/pop/pop_util.c,
      src/dynamic-preprocessors/pop/pop_util.h,
      src/dynamic-preprocessors/pop/sf_pop.dsp,
      src/dynamic-preprocessors/pop/snort_pop.c,
      src/dynamic-preprocessors/pop/snort_pop.h,
      src/dynamic-preprocessors/pop/spp_pop.c,
      src/dynamic-preprocessors/pop/spp_pop.h,
      src/dynamic-preprocessors/reputation/shmem/sflinux_helpers.c,
      src/dynamic-preprocessors/reputation/shmem/sflinux_helpers.h,
      src/dynamic-preprocessors/reputation/shmem/shmem_common.h,
      src/dynamic-preprocessors/reputation/shmem/shmem_config.c,
      src/dynamic-preprocessors/reputation/shmem/shmem_config.h,
      src/dynamic-preprocessors/reputation/shmem/shmem_datamgmt.c,
      src/dynamic-preprocessors/reputation/shmem/shmem_datamgmt.h,
      src/dynamic-preprocessors/reputation/shmem/shmem_lib.c,
      src/dynamic-preprocessors/reputation/shmem/shmem_lib.h,
      src/dynamic-preprocessors/reputation/shmem/shmem_mgmt.c,
      src/dynamic-preprocessors/reputation/shmem/shmem_mgmt.h,
      src/dynamic-preprocessors/sf_dynamic_initialize/sf_dynamic_initialize.dsp,
      src/dynamic-preprocessors/sip/sf_sip.dsp,
      src/dynamic-preprocessors/smtp/Makefile.am,
      src/dynamic-preprocessors/smtp/sf_smtp.dsp,
      src/dynamic-preprocessors/smtp/snort_smtp.c,
      src/dynamic-preprocessors/smtp/snort_smtp.h,
      src/dynamic-preprocessors/ssl/Makefile.am,
      src/dynamic-preprocessors/ssl/sf_ssl.dsp,
      src/dynamic-preprocessors/ssl_common/ssl.c,
      src/dynamic-preprocessors/ssl_common/ssl.h,
      src/dynamic-preprocessors/ssl_common/ssl_config.c,
      src/dynamic-preprocessors/ssl_common/ssl_config.h,
      src/dynamic-preprocessors/ssl_common/ssl_ha.c,
      src/dynamic-preprocessors/ssl_common/ssl_ha.h,
      src/dynamic-preprocessors/ssl_common/ssl_include.h,
      src/dynamic-preprocessors/ssl_common/ssl_inspect.c,
      src/dynamic-preprocessors/ssl_common/ssl_inspect.h,
      src/dynamic-preprocessors/ssl_common/ssl_session.h,
      src/encode.c,
      src/encode.h,
      src/event.h,
      src/event_queue.c,
      src/event_wrapper.c,
      src/fpcreate.c,
      src/fpcreate.h,
      src/fpdetect.c,
      src/fpdetect.h,
      src/generators.h,
      src/hashstring.c,
      src/hashstring.h,
      src/idle_processing.c,
      src/log.c,
      src/log.h,
      src/log_text.c,
      src/mempool.c,
      src/mempool.h,
      src/mstring.c,
      src/mstring.h,
      src/output-plugins/spo_alert_fast.c,
      src/output-plugins/spo_alert_fast.h,
      src/output-plugins/spo_alert_full.c,
      src/output-plugins/spo_alert_full.h,
      src/output-plugins/spo_alert_sf_socket.c,
      src/output-plugins/spo_alert_syslog.c,
      src/output-plugins/spo_alert_syslog.h,
      src/output-plugins/spo_alert_test.c,
      src/output-plugins/spo_alert_test.h,
      src/output-plugins/spo_alert_unixsock.c,
      src/output-plugins/spo_alert_unixsock.h,
      src/output-plugins/spo_csv.c,
      src/output-plugins/spo_csv.h,
      src/output-plugins/spo_log_ascii.c,
      src/output-plugins/spo_log_ascii.h,
      src/output-plugins/spo_log_null.c,
      src/output-plugins/spo_log_null.h,
      src/output-plugins/spo_log_tcpdump.c,
      src/output-plugins/spo_log_tcpdump.h,
      src/output-plugins/spo_unified2.h,
      src/packet_time.c,
      src/parser.c,
      src/parser.h,
      src/parser/IpAddrSet.c,
      src/parser/IpAddrSet.h,
      src/pcrm.c,
      src/pcrm.h,
      src/plugbase.c,
      src/plugbase.h,
      src/plugin_enum.h,
      src/ppm.c,
      src/preprocessors/HttpInspect/include/hi_client.h,
      src/preprocessors/HttpInspect/include/hi_paf.h,
      src/preprocessors/HttpInspect/utils/hi_paf.c,
      src/preprocessors/Session/stream5_ha.c,
      src/preprocessors/normalize.c,
      src/preprocessors/normalize.h,
      src/preprocessors/perf-base.c,
      src/preprocessors/perf-base.h,
      src/preprocessors/perf-event.c,
      src/preprocessors/perf-event.h,
      src/preprocessors/perf-flow.c,
      src/preprocessors/perf-flow.h,
      src/preprocessors/perf.c,
      src/preprocessors/perf.h,
      src/preprocessors/session_api.h
      src/preprocessors/sfprocpidstats.c,
      src/preprocessors/sfprocpidstats.h,
      src/preprocessors/spp_arpspoof.c,
      src/preprocessors/spp_arpspoof.h,
      src/preprocessors/spp_bo.c,
      src/preprocessors/spp_bo.h,
      src/preprocessors/spp_frag3.c,
      src/preprocessors/spp_frag3.h,
      src/preprocessors/spp_normalize.c,
      src/preprocessors/spp_normalize.h,
      src/preprocessors/spp_perfmonitor.c,
      src/preprocessors/spp_perfmonitor.h,
      src/preprocessors/spp_rpc_decode.c,
      src/preprocessors/spp_rpc_decode.h,
      src/preprocessors/spp_session.c,
      src/preprocessors/spp_stream5.c,
      src/preprocessors/spp_stream5.h,
      src/preprocessors/stream_api.c,
      src/preprocessors/stream_api.h,
      src/preprocessors/stream_expect.c,
      src/preprocessors/stream_expect.h,
      src/profiler.c,
      src/profiler.h,
      src/rate_filter.c,
      src/rate_filter.h,
      src/rules.h,
      src/sf_protocols.h,
      src/sf_sdlist.c,
      src/sf_sdlist.h,
      src/sf_sdlist_types.h,
      src/sfdaq.c,
      src/sfdaq.h,
      src/sfthreshold.c,
      src/sfutil/acsmx.c,
      src/sfutil/acsmx.h,
      src/sfutil/acsmx2.c,
      src/sfutil/bitop.h,
      src/sfutil/bitop_funcs.h,
      src/sfutil/getopt.h,
      src/sfutil/mpse.c,
      src/sfutil/mpse.h,
      src/sfutil/sf_email_attach_decode.c,
      src/sfutil/sf_email_attach_decode.h,
      src/sfutil/sf_ip.c,
      src/sfutil/sf_iph.c,
      src/sfutil/sf_sechash.c,
      src/sfutil/sf_sechash.h,
      src/sfutil/sha2.h,
      src/sfutil/util_jsnorm.c,
      src/sfutil/util_jsnorm.h,
      src/sfutil/util_unfold.c,
      src/sfutil/util_unfold.h,
      src/signature.h,
      src/snort.c,
      src/snort.h,
      src/snort_debug.h,
      src/spo_plugbase.h,
      src/tag.c,
      src/tag.h,
      src/util.c,
      src/util.h,
      src/win32/WIN32-Code/getopt.c,
      src/win32/WIN32-Code/inet_aton.c,
      src/win32/WIN32-Code/misc.c,
      src/win32/WIN32-Includes/config.h,
      src/win32/WIN32-Includes/getopt.h,
      src/win32/WIN32-Prj/snort_installer.nsi,
      ssl/ssl_setup.c,
      tools/control/sfcontrol.c:
      Refactor SSL code to make a library for state processing across
      non-native protocols that use SSL via STARTTLS. Update IMAP/POP/FTP/SSL
      preprocessors to use new SSL library, and activation of PAF for those
      protocols. Add ability to share basic state for SSL.

    * configure.in,
      doc/README.session,
      doc/README.stream5,
      doc/snort_manual.pdf,
      doc/snort_manual.tex,
      dynamic-preprocessors/dns/spp_dns.c,
      dynamic-preprocessors/ftptelnet/snort_ftptelnet.c,
      dynamic-preprocessors/gtp/spp_gtp.c,
      dynamic-preprocessors/imap/spp_imap.c,
      dynamic-preprocessors/modbus/spp_modbus.c,
      dynamic-preprocessors/pop/spp_pop.c,
      dynamic-preprocessors/sip/spp_sip.c,
      dynamic-preprocessors/smtp/spp_smtp.c,
      dynamic-preprocessors/ssh/spp_ssh.c,
      etc/sf_rule_options,
      preprocessors/Session/session_common.c,
      preprocessors/Session/session_common.h,
      preprocessors/Session/session_expect.c,
      preprocessors/Stream6/snort_stream_ip.c,
      preprocessors/Stream6/snort_stream_tcp.c,
      preprocessors/Stream6/snort_stream_tcp.h,
      preprocessors/Stream6/snort_stream_udp.c,
      preprocessors/Stream6/stream_common.h,
      preprocessors/session_api.h,
      preprocessors/snort_httpinspect.c,
      preprocessors/spp_rpc_decode.c,
      preprocessors/spp_session.c,
      preprocessors/spp_stream6.c,
      preprocessors/stream_api.h,
      preprocids.h,
      src/Makefile.am,
      src/active.c,
      src/active.h,
      src/build.h,
      src/detect.c,
      src/detect.h,
      src/detection-plugins/Makefile.am,
      src/detection-plugins/sp_clientserver.c,
      src/detection-plugins/sp_flowbits.c,
      src/detection-plugins/sp_pattern_match.c,
      src/detection-plugins/sp_pattern_match.h,
      src/dynamic-examples/Makefile.am,
      src/dynamic-examples/dynamic-preprocessor/spp_example.c,
      src/dynamic-output/plugins/output_lib.h,
      src/dynamic-output/plugins/output_plugin.c,
      src/dynamic-plugins/sf_convert_dynamic.c,
      src/dynamic-plugins/sf_dynamic_plugins.c,
      src/dynamic-plugins/sf_dynamic_preprocessor.h,
      src/dynamic-plugins/sf_engine/sf_snort_detection_engine.c,
      src/dynamic-plugins/sf_engine/sf_snort_packet.h,
      src/dynamic-plugins/sf_engine/sf_snort_plugin_api.h,
      src/dynamic-plugins/sf_engine/sf_snort_plugin_content.c,
      src/dynamic-plugins/sp_preprocopt.c,
      src/dynamic-preprocessors/Makefile.am,
      src/dynamic-preprocessors/dcerpc2/dce2_cl.c,
      src/dynamic-preprocessors/dcerpc2/dce2_config.c,
      src/dynamic-preprocessors/dcerpc2/dce2_config.h,
      src/dynamic-preprocessors/dcerpc2/dce2_paf.c,
      src/dynamic-preprocessors/dcerpc2/dce2_roptions.c,
      src/dynamic-preprocessors/dcerpc2/dce2_session.h,
      src/dynamic-preprocessors/dcerpc2/dce2_smb.c,
      src/dynamic-preprocessors/dcerpc2/snort_dce2.c,
      src/dynamic-preprocessors/dcerpc2/snort_dce2.h,
      src/dynamic-preprocessors/dcerpc2/spp_dce2.c,
      src/dynamic-preprocessors/dnp3/dnp3_roptions.c,
      src/dynamic-preprocessors/dnp3/spp_dnp3.c,
      src/dynamic-preprocessors/dnp3/spp_dnp3.h,
      src/dynamic-preprocessors/dns/spp_dns.c,
      src/dynamic-preprocessors/dns/spp_dns.h,
      src/dynamic-preprocessors/file/file_agent.c,
      src/dynamic-preprocessors/file/file_event_log.c,
      src/dynamic-preprocessors/file/spp_file.c,
      src/dynamic-preprocessors/ftptelnet/ftpp_si.c,
      src/dynamic-preprocessors/ftptelnet/ftpp_si.h,
      src/dynamic-preprocessors/ftptelnet/pp_ftp.c,
      src/dynamic-preprocessors/ftptelnet/pp_telnet.c,
      src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.c,
      src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.h,
      src/dynamic-preprocessors/ftptelnet/spp_ftptelnet.c,
      src/dynamic-preprocessors/gtp/gtp_roptions.c,
      src/dynamic-preprocessors/gtp/spp_gtp.c,
      src/dynamic-preprocessors/imap/imap_config.c,
      src/dynamic-preprocessors/imap/imap_config.h,
      src/dynamic-preprocessors/imap/sf_imap.dsp,
      src/dynamic-preprocessors/imap/snort_imap.c,
      src/dynamic-preprocessors/imap/snort_imap.h,
      src/dynamic-preprocessors/imap/spp_imap.c,
      src/dynamic-preprocessors/libs/sfdynamic_preproc_libs.dsp,
      src/dynamic-preprocessors/modbus/modbus_decode.c,
      src/dynamic-preprocessors/modbus/modbus_roptions.c,
      src/dynamic-preprocessors/modbus/spp_modbus.c,
      src/dynamic-preprocessors/modbus/spp_modbus.h,
      src/dynamic-preprocessors/pop/pop_config.c,
      src/dynamic-preprocessors/pop/pop_config.h,
      src/dynamic-preprocessors/pop/pop_util.c,
      src/dynamic-preprocessors/pop/sf_pop.dsp,
      src/dynamic-preprocessors/pop/snort_pop.c,
      src/dynamic-preprocessors/pop/snort_pop.h,
      src/dynamic-preprocessors/pop/spp_pop.c,
      src/dynamic-preprocessors/reputation/spp_reputation.c,
      src/dynamic-preprocessors/sdf/spp_sdf.c,
      src/dynamic-preprocessors/sip/sip_dialog.c,
      src/dynamic-preprocessors/sip/sip_roptions.c,
      src/dynamic-preprocessors/sip/spp_sip.c,
      src/dynamic-preprocessors/smtp/sf_smtp.dsp,
      src/dynamic-preprocessors/smtp/smtp_config.c,
      src/dynamic-preprocessors/smtp/smtp_config.h,
      src/dynamic-preprocessors/smtp/smtp_util.c,
      src/dynamic-preprocessors/smtp/snort_smtp.c,
      src/dynamic-preprocessors/smtp/spp_smtp.c,
      src/dynamic-preprocessors/ssh/spp_ssh.c,
      src/encode.c,
      src/encode.h,
      src/event_queue.c,
      src/event_wrapper.c,
      src/file-process/file_api.h,
      src/file-process/file_mime_process.c,
      src/file-process/file_mime_process.h,
      src/file-process/file_service.c,
      src/file-process/file_stats.c,
      src/file-process/libs/file_config.c,
      src/file-process/libs/file_config.h,
      src/fpcreate.c,
      src/fpdetect.c,
      src/generators.h,
      src/parser.c,
      src/parser.h,
      src/plugbase.c,
      src/plugbase.h,
      src/ppm.c,
      src/preprocessors/HttpInspect/include/hi_ui_config.h,
      src/preprocessors/HttpInspect/session_inspection/hi_si.c,
      src/preprocessors/Makefile.am,
      src/preprocessors/Session/Makefile.am,
      src/preprocessors/Session/session_common.c,
      src/preprocessors/Session/session_common.h,
      src/preprocessors/Session/session_expect.c,
      src/preprocessors/Session/session_expect.h,
      src/preprocessors/Session/snort_session.c,
      src/preprocessors/Session/snort_session.h,
      src/preprocessors/Session/stream5_ha.c,
      src/preprocessors/Session/stream5_ha.h,
      src/preprocessors/Stream6/Makefile.am,
      src/preprocessors/Stream6/snort_stream_icmp.c,
      src/preprocessors/Stream6/snort_stream_icmp.h,
      src/preprocessors/Stream6/snort_stream_ip.c,
      src/preprocessors/Stream6/snort_stream_ip.h,
      src/preprocessors/Stream6/snort_stream_tcp.c,
      src/preprocessors/Stream6/snort_stream_tcp.h,
      src/preprocessors/Stream6/snort_stream_udp.c,
      src/preprocessors/Stream6/snort_stream_udp.h,
      src/preprocessors/Stream6/stream_common.c,
      src/preprocessors/Stream6/stream_common.h,
      src/preprocessors/Stream6/stream_paf.c,
      src/preprocessors/Stream6/stream_paf.h,
      src/preprocessors/perf-base.c,
      src/preprocessors/portscan.c,
      src/preprocessors/session_api.c,
      src/preprocessors/session_api.h,
      src/preprocessors/snort_httpinspect.c,
      src/preprocessors/snort_httpinspect.h,
      src/preprocessors/spp_arpspoof.c,
      src/preprocessors/spp_bo.c,
      src/preprocessors/spp_frag3.c,
      src/preprocessors/spp_httpinspect.c,
      src/preprocessors/spp_normalize.c,
      src/preprocessors/spp_perfmonitor.c,
      src/preprocessors/spp_rpc_decode.c,
      src/preprocessors/spp_session.c, 
      src/preprocessors/spp_session.h,
      src/preprocessors/spp_sfportscan.c,
      src/preprocessors/spp_stream5.c,
      src/preprocessors/spp_stream5.h,
      src/preprocessors/spp_stream6.c,
      src/preprocessors/spp_stream6.h,
      src/preprocessors/stream_api.h,
      src/preprocessors/stream_expect.c,
      src/preprocessors/stream_expect.h,
      src/preprocids.h,
      src/sf_sdlist.c,
      src/sf_sdlist.h,
      src/sfdaq.c,
      src/sfdaq.h,
      src/sfutil/sfPolicy.c,
      src/sfutil/sfPolicy.h,
      src/sfutil/sfPolicyData.h,
      src/sfutil/sfPolicyUserData.h,
      src/sfutil/sf_email_attach_decode.h,
      src/sfutil/sfrf.c,
      src/sfutil/sfthd.c,
      src/sfutil/test/sf_ip_test.c,
      src/snort.c,
      src/snort.h,
      src/target-based/sftarget_protocol_reference.c,
      src/target-based/sftarget_reader.c,
      src/target-based/sftarget_reader.h,
      src/util.c,
      src/win32/WIN32-Prj/snort.dsp,
      tools/Makefile.a:
      Split the session tracking and reassembly functionality of Stream5
      into new Session and Stream preprocessors.

    * configure.in,
      doc/INSTALL,
      doc/Makefile.am,
      doc/README.appid,
      doc/snort_manual.tex,
      src/detect.c,
      src/detection-plugins/Makefile.am,
      src/detection-plugins/detection_options.c,
      src/detection-plugins/sp_appid.c,
      src/detection-plugins/sp_appid.h
      src/dynamic-plugins/sf_dynamic_common.h,
      src/dynamic-plugins/sf_dynamic_define.h,
      src/dynamic-plugins/sf_dynamic_meta.h,
      src/dynamic-plugins/sf_dynamic_plugins.c,
      src/dynamic-plugins/sf_dynamic_preprocessor.h,
      src/dynamic-plugins/sf_engine/Makefile.am,
      src/dynamic-plugins/sf_engine/sf_snort_packet.h,
      src/dynamic-preprocessors/Makefile.am
      src/dynamic-preprocessors/Makefile.am,
      src/dynamic-preprocessors/appid/Makefile.am,
      src/dynamic-preprocessors/appid/appId.h,
      src/dynamic-preprocessors/appid/appIdConfig.c,
      src/dynamic-preprocessors/appid/appIdConfig.h,
      src/dynamic-preprocessors/appid/appIdStats.c,
      src/dynamic-preprocessors/appid/appIdStats.h,
      src/dynamic-preprocessors/appid/appInfoTable.c,
      src/dynamic-preprocessors/appid/appInfoTable.h,
      src/dynamic-preprocessors/appid/attribute.h,
      src/dynamic-preprocessors/appid/client_plugins/Makefile.am,
      src/dynamic-preprocessors/appid/client_plugins/client_app_aim.c,
      src/dynamic-preprocessors/appid/client_plugins/client_app_aim.h,
      src/dynamic-preprocessors/appid/client_plugins/client_app_api.h,
      src/dynamic-preprocessors/appid/client_plugins/client_app_base.c,
      src/dynamic-preprocessors/appid/client_plugins/client_app_base.h,
      src/dynamic-preprocessors/appid/client_plugins/client_app_bit.c,
      src/dynamic-preprocessors/appid/client_plugins/client_app_bit_tracker.c,
      src/dynamic-preprocessors/appid/client_plugins/client_app_msn.c,
      src/dynamic-preprocessors/appid/client_plugins/client_app_msn.h,
      src/dynamic-preprocessors/appid/client_plugins/client_app_rtp.c,
      src/dynamic-preprocessors/appid/client_plugins/client_app_sip.c,
      src/dynamic-preprocessors/appid/client_plugins/client_app_sip.h,
      src/dynamic-preprocessors/appid/client_plugins/client_app_smtp.c,
      src/dynamic-preprocessors/appid/client_plugins/client_app_smtp.h,
      src/dynamic-preprocessors/appid/client_plugins/client_app_ssh.c,
      src/dynamic-preprocessors/appid/client_plugins/client_app_template.c,
      src/dynamic-preprocessors/appid/client_plugins/client_app_timbuktu.c,
      src/dynamic-preprocessors/appid/client_plugins/client_app_tns.c,
      src/dynamic-preprocessors/appid/client_plugins/client_app_vnc.c,
      src/dynamic-preprocessors/appid/client_plugins/client_app_ym.c,
      src/dynamic-preprocessors/appid/client_plugins/client_app_ym.h,
      src/dynamic-preprocessors/appid/commonAppMatcher.c,
      src/dynamic-preprocessors/appid/commonAppMatcher.h,
      src/dynamic-preprocessors/appid/detector_plugins/Makefile.am,
      src/dynamic-preprocessors/appid/detector_plugins/detector_api.h,
      src/dynamic-preprocessors/appid/detector_plugins/detector_base.c,
      src/dynamic-preprocessors/appid/detector_plugins/detector_base.h,
      src/dynamic-preprocessors/appid/detector_plugins/detector_http.c,
      src/dynamic-preprocessors/appid/detector_plugins/detector_http.h,
      src/dynamic-preprocessors/appid/detector_plugins/detector_imap.c,
      src/dynamic-preprocessors/appid/detector_plugins/detector_kerberos.c,
      src/dynamic-preprocessors/appid/detector_plugins/detector_pop3.c,
      src/dynamic-preprocessors/appid/detector_plugins/detector_sip.c,
      src/dynamic-preprocessors/appid/detector_plugins/detector_sip.h,
      src/dynamic-preprocessors/appid/detector_plugins/http_url_patterns.c,
      src/dynamic-preprocessors/appid/detector_plugins/http_url_patterns.h,
      src/dynamic-preprocessors/appid/diffScript.sh,
      src/dynamic-preprocessors/appid/doxy_api.c,
      src/dynamic-preprocessors/appid/flow.c,
      src/dynamic-preprocessors/appid/flow.h,
      src/dynamic-preprocessors/appid/flow_error.h,
      src/dynamic-preprocessors/appid/fw_appid.c,
      src/dynamic-preprocessors/appid/fw_appid.h,
      src/dynamic-preprocessors/appid/hostPortAppCache.c,
      src/dynamic-preprocessors/appid/hostPortAppCache.h,
      src/dynamic-preprocessors/appid/host_tracker.h,
      src/dynamic-preprocessors/appid/httpCommon.h,
      src/dynamic-preprocessors/appid/luaDetectorApi.c,
      src/dynamic-preprocessors/appid/luaDetectorApi.h,
      src/dynamic-preprocessors/appid/luaDetectorFlowApi.c,
      src/dynamic-preprocessors/appid/luaDetectorFlowApi.h,
      src/dynamic-preprocessors/appid/luaDetectorModule.c,
      src/dynamic-preprocessors/appid/luaDetectorModule.h,
      src/dynamic-preprocessors/appid/rna_flow.h,
      src/dynamic-preprocessors/appid/service_plugins/Makefile.am,
      src/dynamic-preprocessors/appid/service_plugins/dcerpc.c,
      src/dynamic-preprocessors/appid/service_plugins/dcerpc.h,
      src/dynamic-preprocessors/appid/service_plugins/service_MDNS.c,
      src/dynamic-preprocessors/appid/service_plugins/service_MDNS.h,
      src/dynamic-preprocessors/appid/service_plugins/service_api.h,
      src/dynamic-preprocessors/appid/service_plugins/service_base.c,
      src/dynamic-preprocessors/appid/service_plugins/service_base.h,
      src/dynamic-preprocessors/appid/service_plugins/service_battle_field.c,
      src/dynamic-preprocessors/appid/service_plugins/service_battle_field.h,
      src/dynamic-preprocessors/appid/service_plugins/service_bgp.c,
      src/dynamic-preprocessors/appid/service_plugins/service_bgp.h,
      src/dynamic-preprocessors/appid/service_plugins/service_bit.c,
      src/dynamic-preprocessors/appid/service_plugins/service_bootp.c,
      src/dynamic-preprocessors/appid/service_plugins/service_bootp.h,
      src/dynamic-preprocessors/appid/service_plugins/service_dcerpc.c,
      src/dynamic-preprocessors/appid/service_plugins/service_dcerpc.h,
      src/dynamic-preprocessors/appid/service_plugins/service_direct_connect.c,
      src/dynamic-preprocessors/appid/service_plugins/service_direct_connect.h,
      src/dynamic-preprocessors/appid/service_plugins/service_dns.c,
      src/dynamic-preprocessors/appid/service_plugins/service_dns.h,
      src/dynamic-preprocessors/appid/service_plugins/service_flap.c,
      src/dynamic-preprocessors/appid/service_plugins/service_flap.h,
      src/dynamic-preprocessors/appid/service_plugins/service_ftp.c,
      src/dynamic-preprocessors/appid/service_plugins/service_ftp.h,
      src/dynamic-preprocessors/appid/service_plugins/service_irc.c,
      src/dynamic-preprocessors/appid/service_plugins/service_irc.h,
      src/dynamic-preprocessors/appid/service_plugins/service_lpr.c,
      src/dynamic-preprocessors/appid/service_plugins/service_lpr.h,
      src/dynamic-preprocessors/appid/service_plugins/service_mysql.c,
      src/dynamic-preprocessors/appid/service_plugins/service_mysql.h,
      src/dynamic-preprocessors/appid/service_plugins/service_netbios.c,
      src/dynamic-preprocessors/appid/service_plugins/service_netbios.h,
      src/dynamic-preprocessors/appid/service_plugins/service_nntp.c,
      src/dynamic-preprocessors/appid/service_plugins/service_nntp.h,
      src/dynamic-preprocessors/appid/service_plugins/service_ntp.c,
      src/dynamic-preprocessors/appid/service_plugins/service_ntp.h,
      src/dynamic-preprocessors/appid/service_plugins/service_pattern.c,
      src/dynamic-preprocessors/appid/service_plugins/service_pattern.h,
      src/dynamic-preprocessors/appid/service_plugins/service_radius.c,
      src/dynamic-preprocessors/appid/service_plugins/service_radius.h,
      src/dynamic-preprocessors/appid/service_plugins/service_rexec.c,
      src/dynamic-preprocessors/appid/service_plugins/service_rexec.h,
      src/dynamic-preprocessors/appid/service_plugins/service_rfb.c,
      src/dynamic-preprocessors/appid/service_plugins/service_rfb.h,
      src/dynamic-preprocessors/appid/service_plugins/service_rlogin.c,
      src/dynamic-preprocessors/appid/service_plugins/service_rlogin.h,
      src/dynamic-preprocessors/appid/service_plugins/service_rpc.c,
      src/dynamic-preprocessors/appid/service_plugins/service_rpc.h,
      src/dynamic-preprocessors/appid/service_plugins/service_rshell.c,
      src/dynamic-preprocessors/appid/service_plugins/service_rshell.h,
      src/dynamic-preprocessors/appid/service_plugins/service_rsync.c,
      src/dynamic-preprocessors/appid/service_plugins/service_rsync.h,
      src/dynamic-preprocessors/appid/service_plugins/service_sip.c,
      src/dynamic-preprocessors/appid/service_plugins/service_sip.h,
      src/dynamic-preprocessors/appid/service_plugins/service_smtp.c,
      src/dynamic-preprocessors/appid/service_plugins/service_smtp.h,
      src/dynamic-preprocessors/appid/service_plugins/service_snmp.c,
      src/dynamic-preprocessors/appid/service_plugins/service_snmp.h,
      src/dynamic-preprocessors/appid/service_plugins/service_ssh.c,
      src/dynamic-preprocessors/appid/service_plugins/service_ssh.h,
      src/dynamic-preprocessors/appid/service_plugins/service_ssl.c,
      src/dynamic-preprocessors/appid/service_plugins/service_ssl.h,
      src/dynamic-preprocessors/appid/service_plugins/service_telnet.c,
      src/dynamic-preprocessors/appid/service_plugins/service_telnet.h,
      src/dynamic-preprocessors/appid/service_plugins/service_template.c,
      src/dynamic-preprocessors/appid/service_plugins/service_tftp.c,
      src/dynamic-preprocessors/appid/service_plugins/service_tftp.h,
      src/dynamic-preprocessors/appid/service_plugins/service_timbuktu.c,
      src/dynamic-preprocessors/appid/service_plugins/service_tns.c,
      src/dynamic-preprocessors/appid/service_plugins/service_util.h,
      src/dynamic-preprocessors/appid/service_state.c,
      src/dynamic-preprocessors/appid/service_state.h,
      src/dynamic-preprocessors/appid/spp_appid.c,
      src/dynamic-preprocessors/appid/spp_appid.h,
      src/dynamic-preprocessors/appid/tools/u2openappid/Makefile.am,
      src/dynamic-preprocessors/appid/tools/u2streamer/Makefile.am,
      src/dynamic-preprocessors/appid/util/Makefile.am,
      src/dynamic-preprocessors/appid/util/OutputFile.c,
      src/dynamic-preprocessors/appid/util/OutputFile.h,
      src/dynamic-preprocessors/appid/util/acsmx.c,
      src/dynamic-preprocessors/appid/util/acsmx.h,
      src/dynamic-preprocessors/appid/util/acsmx2.c,
      src/dynamic-preprocessors/appid/util/acsmx2.h,
      src/dynamic-preprocessors/appid/util/bnfa_search.c,
      src/dynamic-preprocessors/appid/util/bnfa_search.h,
      src/dynamic-preprocessors/appid/util/common_util.h,
      src/dynamic-preprocessors/appid/util/fw_avltree.c,
      src/dynamic-preprocessors/appid/util/fw_avltree.h,
      src/dynamic-preprocessors/appid/util/ip_funcs.h,
      src/dynamic-preprocessors/appid/util/mpse.c,
      src/dynamic-preprocessors/appid/util/mpse.h,
      src/dynamic-preprocessors/appid/util/sf_error.h,
      src/dynamic-preprocessors/appid/util/sf_mlmp.c,
      src/dynamic-preprocessors/appid/util/sf_mlmp.h,
      src/dynamic-preprocessors/appid/util/sf_multi_mpse.c,
      src/dynamic-preprocessors/appid/util/sf_multi_mpse.h,
      src/dynamic-preprocessors/appid/util/sfghash.c,
      src/dynamic-preprocessors/appid/util/sfghash.h,
      src/dynamic-preprocessors/appid/util/sfhashfcn.c,
      src/dynamic-preprocessors/appid/util/sfhashfcn.h,
      src/dynamic-preprocessors/appid/util/sfksearch.c,
      src/dynamic-preprocessors/appid/util/sfksearch.h,
      src/dynamic-preprocessors/appid/util/sflsq.c,
      src/dynamic-preprocessors/appid/util/sflsq.h,
      src/dynamic-preprocessors/appid/util/sfmemcap.c,
      src/dynamic-preprocessors/appid/util/sfmemcap.h,
      src/dynamic-preprocessors/appid/util/sfutil.c,
      src/dynamic-preprocessors/appid/util/sfutil.h,
      src/dynamic-preprocessors/appid/util/sfxhash.c,
      src/dynamic-preprocessors/appid/util/sfxhash.h,
      src/dynamic-preprocessors/file/file_agent.c,
      src/dynamic-preprocessors/imap/spp_imap.c,
      src/event.h,
      src/event_wrapper.c,
      src/file-process/file_service.c,
      src/file-process/file_stats.c,
      src/file-process/file_stats.h,
      src/log.c,
      src/log.h,
      src/output-plugins/spo_alert_unixsock.c,
      src/output-plugins/spo_unified2.c,
      src/plugbase.c,
      src/plugin_enum.h,
      src/ppm.c,
      src/preprocessors/HttpInspect/client/hi_client.c,
      src/preprocessors/HttpInspect/include/hi_client.h,
      src/preprocessors/HttpInspect/include/hi_ui_config.h,
      src/preprocessors/HttpInspect/include/hi_util.h,
      src/preprocessors/HttpInspect/server/hi_server.c,
      src/preprocessors/perf-base.c,
      src/preprocessors/snort_httpinspect.c,
      src/preprocessors/spp_httpinspect.c,
      src/preprocessors/spp_sfportscan.c,
      src/preprocessors/spp_stream5.c,
      src/preprocessors/str_search.c,
      src/preprocessors/str_search.h,
      src/preprocessors/stream_api.h,
      src/preprocids.h,
      src/rule_option_types.h,
      src/sf_protocols.h,
      src/sfutil/Makefile.am,
      src/sfutil/Unified2_common.h,
      src/sfutil/acsmx.c,
      src/sfutil/acsmx2.c,
      src/sfutil/bnfa_search.c,
      src/sfutil/mpse.c,
      src/sfutil/mpse.h,
      src/sfutil/mpse_methods.h,
      src/sfutil/sfPolicy.h,
      src/sfutil/sf_ip.h,
      src/sfutil/sfdebug.h,
      src/sfutil/sfghash.c,
      src/sfutil/sfghash.h,
      src/sfutil/sfhashfcn.c,
      src/sfutil/sfksearch.c,
      src/sfutil/sflsq.c,
      src/sfutil/sflsq.h,
      src/sfutil/sfmemcap.c,
      src/sfutil/sfrt.h,
      src/sfutil/sfxhash.c,
      src/sfutil/sfxhash.h,
      src/signature.h,
      src/snort.c,
      src/snort.h,
      src/snort_debug.h,
      src/tag.c,
      src/target-based/sftarget_protocol_reference.c,
      src/target-based/sftarget_protocol_reference.h,
      src/util.c,
      tools/Makefile.am,
      tools/file_server/file_server.c,
      tools/u2openappid/Makefile.am,
      tools/u2openappid/u2openappid.c,
      tools/u2spewfoo/u2spewfoo.c
      tools/u2spewfoo/u2spewfoo.c,
      tools/u2streamer/Makefile.am,
      tools/u2streamer/SpoolFileIterator.c,
      tools/u2streamer/SpoolFileIterator.h,
      tools/u2streamer/TimestampedFile.c,
      tools/u2streamer/TimestampedFile.h,
      tools/u2streamer/Unified2.c,
      tools/u2streamer/Unified2.h,
      tools/u2streamer/Unified2File.c,
      tools/u2streamer/Unified2File.h,
      tools/u2streamer/UnifiedLog.c,
      tools/u2streamer/UnifiedLog.h,
      tools/u2streamer/sf_error.c,
      tools/u2streamer/sf_error.h,
      src/dynamic-preprocessors/appid/util/common_util.c,
      tools/u2streamer/u2streamer.c:
      Improved support for AppID preprocessor.
      Removed Lua dependency in favor of LuaJIT.
      Fixed appid with Lua/LuaBitOp (no LuaJIT), support FreeBSD
      Fixed OpenBSD, FreeBSD openAppId support, Removed support for Lua
      Added metadata extraction to SSL for AppID. Changed some Lua API names.
      Refactored to use common data structures.
      Fixed return value checks for fseek(), strdup, malloc(), and stat()
      and removed deprecated library calls (Thanks to Bill Parker for
      reporting the issues).

2014-02-21 Steven Sturges <ssturges@sourcefire.com>
	* configure.in, src/detect.c, src/event.h, src/event_wrapper.c,
	  src/log.c, src/log.h, src/plugbase.c, src/plugin_enum.h,
	  src/ppm.c, src/preprocids.h, src/rule_option_types.h,
	  src/sf_protocols.h, src/signature.h, src/snort.c, src/snort.h,
	  src/snort_debug.h, src/tag.c, src/detection-plugins/Makefile.am,
	  src/detection-plugins/detection_options.c,
	  src/dynamic-plugins/sf_dynamic_common.h,
	  src/dynamic-plugins/sf_dynamic_define.h,
	  src/dynamic-plugins/sf_dynamic_meta.h,
	  src/dynamic-plugins/sf_dynamic_plugins.c,
	  src/dynamic-plugins/sf_dynamic_preprocessor.h,
	  src/dynamic-plugins/sf_engine/Makefile.am,
	  src/dynamic-plugins/sf_engine/sf_snort_packet.h,
	  src/dynamic-preprocessors/Makefile.am,
	  src/output-plugins/spo_alert_unixsock.c,
	  src/output-plugins/spo_unified2.c,
	  src/preprocessors/snort_httpinspect.c,
	  src/preprocessors/spp_httpinspect.c,
	  src/preprocessors/spp_sfportscan.c,
	  src/preprocessors/spp_stream5.c, src/preprocessors/stream_api.h,
	  src/preprocessors/HttpInspect/client/hi_client.c,
	  src/preprocessors/HttpInspect/include/hi_client.h,
	  src/preprocessors/HttpInspect/include/hi_ui_config.h,
	  src/preprocessors/HttpInspect/include/hi_util.h,
	  src/preprocessors/HttpInspect/server/hi_server.c,
	  src/preprocessors/Stream5/stream5_common.h,
	  src/sfutil/Unified2_common.h, src/sfutil/sfPolicy.h,
	  src/sfutil/sf_ip.h, src/sfutil/sfrt.h,
	  src/target-based/sftarget_protocol_reference.c,
	  src/target-based/sftarget_protocol_reference.h,
	  tools/Makefile.am, tools/u2spewfoo/u2spewfoo.c,
	  tools/: Makefile.am, u2spewfoo/u2spewfoo.c,
	  u2openappid/Makefile.am, u2openappid/u2openappid.c,
	  u2streamer/Makefile.am, u2streamer/SpoolFileIterator.c,
	  u2streamer/SpoolFileIterator.h, u2streamer/TimestampedFile.c,
	  u2streamer/TimestampedFile.h, u2streamer/Unified2.c,
	  u2streamer/Unified2.h, u2streamer/Unified2File.c,
	  u2streamer/Unified2File.h, u2streamer/UnifiedLog.c,
	  u2streamer/UnifiedLog.h, u2streamer/sf_error.c,
	  u2streamer/sf_error.h, u2streamer/u2streamer.c,
	  src/dynamic-preprocessors/appid/: Makefile.am, appId.h,
	  appIdConfig.c, appIdConfig.h, appIdStats.c, appIdStats.h,
	  appInfoTable.c, appInfoTable.h, attribute.h, commonAppMatcher.c,
	  commonAppMatcher.h, diffScript.sh, doxy_api.c, flow.c, flow.h,
	  flow_error.h, fw_appid.c, fw_appid.h, hostPortAppCache.c,
	  hostPortAppCache.h, host_tracker.h, httpCommon.h,
	  luaDetectorApi.c, luaDetectorApi.h, luaDetectorFlowApi.c,
	  luaDetectorFlowApi.h, luaDetectorModule.c, luaDetectorModule.h,
	  rna_flow.h, service_state.c, service_state.h, spp_appid.c,
	  spp_appid.h, detector_plugins/Makefile.am,
	  detector_plugins/detector_api.h,
	  detector_plugins/detector_base.c,
	  detector_plugins/detector_base.h,
	  detector_plugins/detector_imap.c,
	  detector_plugins/detector_kerberos.c,
	  detector_plugins/detector_pop3.c,
	  detector_plugins/detector_http.c,
	  detector_plugins/detector_http.h,
	  detector_plugins/http_url_patterns.c,
	  detector_plugins/http_url_patterns.h,
	  util/Makefile.am, util/OutputFile.c, util/OutputFile.h,
	  util/acsmx.c, util/acsmx.h, util/acsmx2.c, util/acsmx2.h,
	  util/bnfa_search.c, util/bnfa_search.h, util/common_util.h,
	  util/fw_avltree.c, util/fw_avltree.h, util/ip_funcs.h,
	  util/mpse.c, util/mpse.h, util/sf_error.h, util/sf_mlmp.c,
	  util/sf_mlmp.h, util/sf_multi_mpse.c, util/sf_multi_mpse.h,
	  util/sfghash.c, util/sfghash.h, util/sfhashfcn.c,
	  util/sfhashfcn.h, util/sfksearch.c, util/sfksearch.h,
	  util/sflsq.c, util/sflsq.h, util/sfmemcap.c, util/sfmemcap.h,
	  util/sfutil.c, util/sfutil.h, util/sfxhash.c, util/sfxhash.h,
	  client_plugins/Makefile.am, client_plugins/client_app_aim.c,
	  client_plugins/client_app_aim.h, client_plugins/client_app_api.h,
	  client_plugins/client_app_base.c,
	  client_plugins/client_app_base.h,
	  client_plugins/client_app_bit.c,
	  client_plugins/client_app_bit_tracker.c,
	  client_plugins/client_app_msn.c, client_plugins/client_app_msn.h,
	  client_plugins/client_app_rtp.c, client_plugins/client_app_sip.c,
	  client_plugins/client_app_sip.h,
	  client_plugins/client_app_smtp.c,
	  client_plugins/client_app_smtp.h,
	  client_plugins/client_app_ssh.c,
	  client_plugins/client_app_template.c,
	  client_plugins/client_app_timbuktu.c,
	  client_plugins/client_app_tns.c, client_plugins/client_app_vnc.c,
	  client_plugins/client_app_ym.c, client_plugins/client_app_ym.h,
	  service_plugins/Makefile.am, service_plugins/dcerpc.c,
	  service_plugins/dcerpc.h, service_plugins/service_MDNS.c,
	  service_plugins/service_MDNS.h, service_plugins/service_api.h,
	  service_plugins/service_base.c, service_plugins/service_base.h,
	  service_plugins/service_battle_field.c,
	  service_plugins/service_battle_field.h,
	  service_plugins/service_bgp.c, service_plugins/service_bgp.h,
	  service_plugins/service_bit.c, service_plugins/service_bootp.c,
	  service_plugins/service_bootp.h,
	  service_plugins/service_dcerpc.c,
	  service_plugins/service_dcerpc.h,
	  service_plugins/service_direct_connect.c,
	  service_plugins/service_direct_connect.h,
	  service_plugins/service_dns.c, service_plugins/service_dns.h,
	  service_plugins/service_flap.c, service_plugins/service_flap.h,
	  service_plugins/service_ftp.c, service_plugins/service_ftp.h,
	  service_plugins/service_irc.c, service_plugins/service_irc.h,
	  service_plugins/service_lpr.c, service_plugins/service_lpr.h,
	  service_plugins/service_mysql.c, service_plugins/service_mysql.h,
	  service_plugins/service_netbios.c,
	  service_plugins/service_netbios.h,
	  service_plugins/service_nntp.c, service_plugins/service_nntp.h,
	  service_plugins/service_ntp.c, service_plugins/service_ntp.h,
	  service_plugins/service_pattern.c,
	  service_plugins/service_pattern.h,
	  service_plugins/service_radius.c,
	  service_plugins/service_radius.h,
	  service_plugins/service_rexec.c, service_plugins/service_rexec.h,
	  service_plugins/service_rfb.c, service_plugins/service_rfb.h,
	  service_plugins/service_rlogin.c,
	  service_plugins/service_rlogin.h, service_plugins/service_rpc.c,
	  service_plugins/service_rpc.h, service_plugins/service_rshell.c,
	  service_plugins/service_rshell.h,
	  service_plugins/service_rsync.c, service_plugins/service_rsync.h,
	  service_plugins/service_sip.c, service_plugins/service_sip.h,
	  service_plugins/service_smtp.c, service_plugins/service_smtp.h,
	  service_plugins/service_snmp.c, service_plugins/service_snmp.h,
	  service_plugins/service_ssh.c, service_plugins/service_ssh.h,
	  service_plugins/service_ssl.c, service_plugins/service_ssl.h,
	  service_plugins/service_telnet.c,
	  service_plugins/service_telnet.h,
	  service_plugins/service_template.c,
	  service_plugins/service_tftp.c, service_plugins/service_tftp.h,
	  service_plugins/service_timbuktu.c,
	  service_plugins/service_tns.c, service_plugins/service_util.h,
	  src/detection-plugins/: sp_appid.c, sp_appid.h,
	  doc/README.appid:
	  New Open App ID feature to identify application protocol, client,
	  server, and web application and be able to leverage that within
	  Snort rules.

2014-02-19 Steven Sturges <ssturges@sourcefire.com>
    * doc/snort_manual.pdf, doc/snort_manual.tex, src/active.c,
      src/active.h, src/encode.h, src/detection-plugins/sp_react.c:
      Added Active_SendBigData to active.c for sending multi-packet react
      pages. Modified react.c to use Active_SendBigData to allow payload
      that spans a single TCP packet (1500+ bytes).

    * src/: preprocessors/Stream5/snort_stream5_tcp.c,
      preprocessors/Stream5/stream5_paf.c,
      preprocessors/Stream5/stream5_paf.h,
      dynamic-preprocessors/pop/Makefile.am,
      dynamic-preprocessors/pop/pop_config.c,
      dynamic-preprocessors/pop/pop_config.h,
      dynamic-preprocessors/pop/pop_log.c,
      dynamic-preprocessors/pop/pop_log.h,
      dynamic-preprocessors/pop/pop_paf.c,
      dynamic-preprocessors/pop/pop_paf.h,
      dynamic-preprocessors/pop/pop_util.c,
      dynamic-preprocessors/pop/sf_pop.dsp,
      dynamic-preprocessors/pop/snort_pop.c,
      dynamic-preprocessors/pop/snort_pop.h,
      dynamic-preprocessors/pop/spp_pop.c,
      dynamic-preprocessors/smtp/Makefile.am,
      dynamic-preprocessors/smtp/sf_smtp.dsp,
      dynamic-preprocessors/smtp/smtp_config.c,
      dynamic-preprocessors/smtp/smtp_config.h,
      dynamic-preprocessors/smtp/smtp_log.c,
      dynamic-preprocessors/smtp/smtp_log.h,
      dynamic-preprocessors/smtp/smtp_paf.c,
      dynamic-preprocessors/smtp/smtp_paf.h,
      dynamic-preprocessors/smtp/smtp_util.c,
      dynamic-preprocessors/smtp/smtp_util.h,
      dynamic-preprocessors/smtp/snort_smtp.c,
      dynamic-preprocessors/smtp/snort_smtp.h,
      dynamic-preprocessors/smtp/spp_smtp.c, file-process/Makefile.am,
      file-process/file_api.h, file-process/file_mail_common.h,
      file-process/file_mime_config.c, file-process/file_mime_config.h,
      file-process/file_mime_process.c,
      file-process/file_mime_process.h, file-process/file_service.c,
      dynamic-preprocessors/imap/Makefile.am,
      dynamic-preprocessors/imap/imap_config.c,
      dynamic-preprocessors/imap/imap_config.h,
      dynamic-preprocessors/imap/imap_log.c,
      dynamic-preprocessors/imap/imap_log.h,
      dynamic-preprocessors/imap/imap_paf.c,
      dynamic-preprocessors/imap/imap_paf.h,
      dynamic-preprocessors/imap/imap_util.c,
      dynamic-preprocessors/imap/sf_imap.dsp,
      dynamic-preprocessors/imap/snort_imap.c,
      dynamic-preprocessors/imap/snort_imap.h,
      dynamic-preprocessors/imap/spp_imap.c,
      preprocessors/snort_httpinspect.c, preprocessors/stream_api.h,
      preprocessors/HttpInspect/include/hi_ui_config.h,
      sfutil/sf_email_attach_decode.h,
      dynamic-preprocessors/Makefile.am,
      dynamic-preprocessors/file/file_agent.c: 
      add paf support to smtp/impa/pop protocols.

    * src/dynamic-preprocessors/ssh/spp_ssh.c: 
      count the max_client_bytes once the session is encrypted. Fix the
      ProcessSSHKeyExchange to parse server new keys

    * src/dynamic-preprocessors/ftptelnet/spp_ftptelnet.c: 
      Fix ftp-data perfstats profiling.  

    * configure.in, src/decode.h, src/sfdaq.c, src/sfdaq.h,
      src/dynamic-preprocessors/ftptelnet/pp_ftp.c,
      src/dynamic-preprocessors/sip/sip_dialog.c,
      src/dynamic-preprocessors/ssh/spp_ssh.c,
      src/preprocessors/spp_stream5.c, src/preprocessors/stream_api.h,
      src/preprocessors/stream_expect.c,
      src/preprocessors/stream_expect.h: 
      Add ability to specify details about dynamic protocols/data channels
      via DAQ.

    * src/preprocessors/Stream5/snort_stream5_tcp.c: 
      Checked for existence of policy_id parameter on Stream5 TCP policy.  

    * src/preprocessors/perf-base.c: 
      Ensure pkt_stats cannot go below zero 
      
    * etc/sf_rule_options, src/Makefile.am, src/fpcreate.c,
      src/parser.c, src/parser.h, src/snort.c, src/snort.h,
      src/detection-plugins/sp_pattern_match.c,
      src/detection-plugins/sp_pattern_match.h,
      src/dynamic-plugins/sf_convert_dynamic.c,
      src/dynamic-plugins/sf_dynamic_define.h,
      src/dynamic-plugins/sf_dynamic_meta.h,
      src/dynamic-plugins/sf_engine/Makefile.am,
      src/dynamic-plugins/sf_engine/sf_snort_detection_engine.c,
      src/dynamic-plugins/sf_engine/sf_snort_plugin_api.c,
      src/dynamic-plugins/sf_engine/sf_snort_plugin_api.h,
      src/dynamic-plugins/sf_engine/sf_snort_plugin_content.c,
      src/sfutil/Makefile.am, src/hashstring.c, src/hashstring.h,
      sfutil/sf_sechash.c, sfutil/sf_sechash.h,
      src/file-process/file_capture.c,
      src/file-process/file_resume_block.c,
      src/file-process/libs/Makefile.am,
      src/file-process/libs/file_lib.c, src/sfutil/Makefile.am,
      src/sfutil/md5.c, src/sfutil/md5.h, src/sfutil/sf_sechash.c,
      src/sfutil/sf_sechash.h, src/sfutil/sha2.c, src/sfutil/sha2.h,
      src/win32/WIN32-Prj/snort.dsp, configure.in, 
      doc/snort_manual.pdf, doc/snort_manual.tex: 
      Protected Rule Content feature.  Updating the minor revision number for
      the engine API for share library rules.  Augmented the logic in configure.in
      to force the -lcrypto library to be included in the link.  Added
      implementations of SHA2 and MD5 algorithms to Snort to allow use with older
      versions of OpenSSL.

    * doc/: snort_manual.pdf, snort_manual.tex: 
      Modified descriptions of urilen, dsize, and flags rule options.  

    * doc/snort_manual.pdf, doc/snort_manual.tex,
      src/sfutil/sfPolicy.c: 
      Added check in binding mappings to prevent Snort from loading binding
      policy_ids > 4095, having it reject the configuration on load. Updated
      documentation to include config binding policy_id.  

    * src/preprocessors/spp_stream5.c: 
      New minimum max_tcp sessions is now 2.

    * src/: dynamic-preprocessors/ftptelnet/pp_ftp.c,
      dynamic-preprocessors/ftptelnet/snort_ftptelnet.c,
      dynamic-preprocessors/ftptelnet/spp_ftptelnet.c,
      preprocessors/spp_stream5.c, preprocessors/stream_api.h,
      preprocessors/stream_expect.c, preprocessors/stream_expect.h:
      Change preprocessor order for when FTP data is handled.
      
    * src/: dynamic-examples/dynamic-preprocessor/Makefile.am,
      dynamic-plugins/sf_engine/Makefile.am,
      dynamic-preprocessors/dcerpc2/Makefile.am,
      dynamic-preprocessors/dnp3/Makefile.am,
      dynamic-preprocessors/dns/Makefile.am,
      dynamic-preprocessors/file/Makefile.am,
      dynamic-preprocessors/ftptelnet/Makefile.am,
      dynamic-preprocessors/gtp/Makefile.am,
      dynamic-preprocessors/imap/Makefile.am,
      dynamic-preprocessors/modbus/Makefile.am,
      dynamic-preprocessors/pop/Makefile.am,
      dynamic-preprocessors/reputation/Makefile.am,
      dynamic-preprocessors/rzb_saac/Makefile.am,
      dynamic-preprocessors/sdf/Makefile.am,
      dynamic-preprocessors/sip/Makefile.am,
      dynamic-preprocessors/smtp/Makefile.am,
      dynamic-preprocessors/ssh/Makefile.am,
      dynamic-preprocessors/ssl/Makefile.am: 
      Install libraries into user defined libdir.  Thanks to cjgd7-facebook
	  for reporting the issue.

    * src/: detection-plugins/detection_options.c,
      detection-plugins/sp_pattern_match.c,
      detection-plugins/sp_pattern_match.h,
      dynamic-plugins/sf_convert_dynamic.c: 
      Update 'within' rule limits to handle extraction of a 0
      via byte_extract.

    * src/detection-plugins/: sp_byte_check.c, sp_byte_extract.h,
      sp_byte_jump.c, sp_isdataat.c, sp_pattern_match.c: 
      Modified error outputs to include the specific offending rule option.  

2013-12-30 Steven Sturges <ssturges@sourcefire.com>
Snort 2.9.6.0
	* src/build.h:
	  updating build number to 47

	* doc/README.file, doc/README.file_ips,
	  etc/file_magic.conf, etc/Makefile.am:
	  Added file_magic.conf and fixed a few typos.  Thanks to Joshua Kinard for
	  pointing them out.

	* doc/snort_manual.tex: 
      Update snort team members 

	* src/detection-plugins/sp_file_type.h,
	  src/dynamic-preprocessors/libs/sf_preproc_info.h, 
	  tools/file_server/file_server.c: 
      Clean up copyright and attribution.  
 
	* src/dynamic-preprocessors/sdf/spp_sdf.c: 
      Fix seconndary check for reassembled packets.  

	* doc/: README.GTP, README.PerfProfiling, README.dcerpc2,
	  README.file, README.frag3, README.ftptelnet, README.http_inspect,
	  README.imap, README.multipleconfigs, README.normalize,
	  README.pop, README.reload, README.reputation, README.rpc_decode,
	  README.sfportscan, README.sip, README.unified2, USAGE, WISHLIST,
	  snort_manual.pdf, snort_manual.tex, README.SMTP, README.counts, 
	  README.asn1, README.active, README, NEWS, INSTALL: 
	  Corrected typos in documentation.  Thanks to Mahendra Ladhe for
	  pointing out the mistakes and providing a patch.  

	* src/: file-process/file_capture.c,
	  file-process/file_mime_process.c,
	  dynamic-preprocessors/imap/snort_imap.c,
	  dynamic-preprocessors/smtp/snort_smtp.c,
	  dynamic-preprocessors/file/file_inspect_config.c,
	  dynamic-preprocessors/pop/snort_pop.c,
	  sfutil/sf_email_attach_decode.h: 
      Enable detetion on all file data 

	* src/sfutil/: sfxhash.c, sfxhash.h: 
	  Fix alignment of sfxhash node on sparc. Thanks to Markus Lude.

	* src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.c: 
 	  Identify EOF on single segment PDU transimssions.
	  
	* src/dynamic-preprocessors/dcerpc2/dce2_memory.c: 
 	  Avoid checking memcap for DCE/RPC configuration data.

	* src/preprocessors/Stream5/snort_stream5_tcp.c: 
 	  Tweak retransmit handling to ensure full right overlap condition holds 

2013-11-22 Steven Sturges <ssturges@sourcefire.com>
Snort 2.9.6.0.rc

    * src/build.h: updating build number to 43

    * configure.in, doc/README.ha, doc/snort_manual.pdf,
      doc/snort_manual.tex, doc/Makefile.am: 
      Add Stream5 HA documentation and mark --enable-ha and
      --enable-side-channel as experimental.

    * rpm/snort.spec: 
      Install snort_control, u2boat, u2spewfoo from spec file.
      Thanks to Bradley Turnbough for mentioning it.

    * src/preprocessors/Stream5/snort_stream5_tcp.c: 
      using sequence number overlapping to trigger retransmission
	  handler.  This fixed issue on file blocking.  

    * src/dynamic-preprocessors/: pop/pop_log.c, smtp/smtp_log.c,
      imap/imap_log.c: 
 	  avoid mail decoding prepocessor alerts when they not enabled
	  in config.

    * doc/snort_manual.tex,
      src/: active.c, active.h, decode.c, detect.c, fpdetect.c,
      detection-plugins/sp_react.c,
      dynamic-plugins/sf_dynamic_plugins.c,
      file-process/file_resume_block.c, file-process/file_service.c,
      output-plugins/spo_alert_fast.c, output-plugins/spo_unified2.c,
      preprocessors/spp_bo.c, preprocessors/spp_frag3.c,
      preprocessors/Stream5/snort_stream5_ip.c,
      preprocessors/Stream5/snort_stream5_tcp.c,
      preprocessors/Stream5/snort_stream5_udp.c: 
 	  alerts get wdrop when active is suspended; code for cdrop is ready
	  but disabled 

    * src/: file-process/file_api.h, file-process/file_resume_block.c,
      file-process/file_service.c, file-process/libs/file_lib.h,
      dynamic-preprocessors/file/file_agent.c: 
  	  Add file id to file API callbacks to support multiple file contexts.  

    * preproc_rules/decoder.rules, src/decode.c, src/generators.h: 
 	  Validate authentication headers. New decoder rules (116:465 and 116:466).
    
	* doc/snort_manual.pdf, doc/snort_manual.tex,
      src/detection-plugins/sp_icmp_code_check.c: 
 	  Added data validation checks to the icode rule option. The parser
	  phase will now throw fatal errors for illegal values.  
      Update manual to reflect the additional data validation.

    * src/preprocessors/Stream5/: snort_stream5_ip.c,
      snort_stream5_udp.c: 
 	  Force block for block rule in inline test mode.  

    * src/: dynamic-preprocessors/imap/snort_imap.c,
      dynamic-preprocessors/pop/snort_pop.c,
      dynamic-preprocessors/smtp/snort_smtp.c,
      preprocessors/stream_api.h,
      preprocessors/Stream5/snort_stream5_tcp.c: 
 	  Don't put gaps in reassembled packets 

    * src/: preprocessors/Stream5/snort_stream5_session.c,
      side-channel/sidechannel.c: 
 	  The global list in the session cache is ordered from MRU (head) to
	  LRU (tail), so correctly walk backward rather than forward from the
	  LRU looking for sessions to time out.  Clean up compiler warning in
	  Side Channel.  

    * src/file-process/: libs/file_lib.c, file_api.h, file_capture.c,
      file_service.c, file_service.h: 
      Add multiple file contexts support for file API.  

    * src/: dynamic-preprocessors/ftptelnet/ftpp_si.c,
      dynamic-preprocessors/ftptelnet/ftpp_si.h,
      dynamic-preprocessors/ftptelnet/snort_ftptelnet.c,
      dynamic-preprocessors/ftptelnet/snort_ftptelnet.h,
      preprocessors/Stream5/snort_stream5_tcp.c: 
 	  Add EndOfFile stream event callback. Remove EOF logic from
	  FTP/Preprocessor in lieu of new callback.

    * src/: file-process/file_service.c,
      file-process/file_service_config.c,
      file-process/file_service_config.h, snort.c: 
      make sure file configuration is initialized during reload.  

2013-10-18 Hui Cao <hcao@sourcefire.com>
Snort 2.9.6.0.beta
    * doc/: Makefile.am, README.file, README.file_ips: 
 	  Add readme for experimental file type ips rule keywords.

    * src/detection-plugins/sp_icmp_code_check.c:
      Allow a negative value in the ICMP icode x<>y range check.  This
      permits the rule to include a check for zero

    * src/preprocessors/Stream5/snort_stream5_tcp.c:
      Disable detection when the TCP connection was already closed.

    * src/: dynamic-preprocessors/ftptelnet/ftpp_si.h,
      dynamic-preprocessors/ftptelnet/pp_ftp.c,
      dynamic-preprocessors/ftptelnet/snort_ftptelnet.c,
      file-process/file_api.h:
      Fix FTP-Data file processing.

    * src/snort_bounds.h:
      Avoid assertion for zero size memory copy

    * src/: dynamic-plugins/sf_dynamic_plugins.c,
      detection-plugins/sp_react.c:
      Only inject response page when session is established.

    * src/dynamic-preprocessors/smtp/smtp_log.h,
      src/dynamic-preprocessors/smtp/snort_smtp.c,
      src/dynamic-preprocessors/smtp/snort_smtp.h,
      preproc_rules/preprocessor.rules, etc/gen-msg.map:
      Add a new preprocessor alert to detect Cyrus SASL authentication
      attack.

    * src/dynamic-preprocessors/ssh/spp_ssh.c:
      Set_reassembly to ABSOLUTE only if the traffic is SSH.
      Statefully process ssh version/ssh key exchange
      init/key exchange and/or encrypted data within a single
      reassembled packet. Thanks to Florian Westphal for reporting this.

    * src/file-process/file_mime_process.c:
      For IMAP, the MIME and message will be inside fetch
      body, which will be end at ")".

    * src/: dynamic-preprocessors/dns/spp_dns.c,
      dynamic-preprocessors/ssh/spp_ssh.c,
      Change preprocessor reassembly policy; Changed SSH preprocessor state
      transition based on the dir rather than both.

    * src/: preprocessors/Stream5/snort_stream5_tcp.c:
      Ignore the gap when turning on reassembly dynamically on the very
      first packet of the session.

    * src/dynamic-preprocessors/dnp3/spp_dnp3.c:
      Fix the incorrect mempool warnings. Thanks to Bram for reporting this

    * doc/snort_manual.pdf, doc/snort_manual.tex, configure.in,
      src/snort.c, src/util.c:
      Trim freed memory before and after configuration reload.

    * src/: dynamic-preprocessors/imap/snort_imap.c,
      dynamic-preprocessors/pop/snort_pop.c,
      dynamic-preprocessors/smtp/snort_smtp.c,
      file-process/file_mime_process.c,
      sfutil/sf_email_attach_decode.c:
      Allow 7bit decoding of binary file attachments.
 
    * src/dynamic-preprocessors/sdf/: spp_sdf.c, spp_sdf.h:
      Avoid partial rule tree match during reload.

    * src/tag.c:
      Fix boundary check error so that the global tagged packet limit
      doesn't allow an extra tag.

    * src/: file-process/file_mime_process.h, file-process/file_api.h,
      file-process/file_mime_process.c, file-process/file_service.c,
      dynamic-preprocessors/imap/snort_imap.c,
      dynamic-preprocessors/imap/spp_imap.c,
      dynamic-preprocessors/smtp/snort_smtp.c,
      dynamic-preprocessors/pop/snort_pop.c,
      dynamic-preprocessors/pop/spp_pop.c:
      Add simple PAF support for POP and IMAP.

    * src/: util.c, util.h, sfutil/sf_ip.c, sfutil/sf_ip.h: Bugs
      Add sfip_convert_ip_text_to_binary() to enforce platform agnostic
      IPv4 syntax. Make sure xatou(), xatol(), and xatoup() return values
      within specified range
 
    * doc/snort_manual.tex:
      Update the document to include the '<=' and '>=' operators to
      the byte_test command

    * src/preprocessors/Stream5/snort_stream5_tcp.c:
      Make sure INTERNAL_EVENT_SESSION_ADD event only in the
      ESTABLISHED state.

    * src/sfutil/sf_email_attach_decode.c:
      Check the QP encoding string is valid to avoid decoding end of line
      incorrectly.

    * src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.c:
      Tweak config output to correspond to config input.
      Thanks to Reinoud Koornstra for the suggestion.

    * src/preprocessors/Stream5/: snort_stream5_icmp.c,
      snort_stream5_ip.c, snort_stream5_tcp.c, snort_stream5_udp.c:
      dynamic-preprocessors/pop/snort_pop.c,
      dynamic-preprocessors/smtp/snort_smtp.c,
      dynamic-preprocessors/ssl/spp_ssl.c,
      encode.c, dynamic-preprocessors/dcerpc2/dce2_cl.c,
      dynamic-preprocessors/dcerpc2/dce2_session.h,
      dynamic-preprocessors/dcerpc2/snort_dce2.c,
      dynamic-preprocessors/dns/spp_dns.c,
      dynamic-preprocessors/imap/snort_imap.c:
      preprocessors/spp_rpc_decode.c, preprocessors/spp_stream5.c,
      preprocessors/stream_api.h, preprocessors/stream_expect.c:
      Handle out of order SSL handshake in SMTP.
      Thanks to Bram for the reporting this.

    * src/preprocessors/perf-base.c:
      Update the header printed at top of now file.

    * src/preprocessors/perf-base.c:
      Change name of stat from Blocked Packets to Block Verdicts.

    * src/preprocessors/Stream5/snort_stream5_session.c:
      Timeout a session when session timeout reaches instead of waiting for
      session nominal timeout.

    * configure.in, src/plugbase.c, src/rule_option_types.h,
      src/snort.c, src/detection-plugins/Makefile.am,
      src/detection-plugins/: sp_file_type.c, sp_file_type.h,
      src/detection-plugins/detection_options.c,
      src/dynamic-preprocessors/Makefile.am,
      src/file-process/Makefile.am, src/file-process/file_api.h,
      src/file-process/file_service.c,
      src/file-process/file_service_config.c,
      src/file-process/file_service_config.h,
      src/file-process/libs/Makefile.am,
      src/file-process/libs/file_config.c,
      src/file-process/libs/file_config.h,
      src/file-process/libs/file_lib.c,
      src/file-process/libs/file_lib.h,
      src/preprocessors/spp_stream5.c, tools/Makefile.am,
      doc/: README.file, README.file_ips, Makefile.am:
      File inspection keywords for IPS rules.

    * src/dynamic-preprocessors/sdf/: sdf_pattern_match.c,
      sdf_pattern_match.h, spp_sdf.c, spp_sdf.h:
      Add stateful pattern match of sdf patterns across packets.

    * mkinstalldirs, doc/snort_manual.tex, src/detect.c,
      src/detection_util.h, src/fpdetect.c, src/parser.c, src/tag.c,
      src/tag.h, src/target-based/sf_attribute_table.y,
      tools/u2spewfoo/u2spewfoo.c:
      Support single session capture via tag rule option.
      Log all packets to the same place as original alert. 
      Enable tagging on pass rules.

    * src/: dynamic-preprocessors/imap/snort_imap.c,
      dynamic-preprocessors/imap/snort_imap.h,
      dynamic-preprocessors/pop/snort_pop.c,
      dynamic-preprocessors/pop/snort_pop.h,
      dynamic-preprocessors/smtp/snort_smtp.c,
      dynamic-preprocessors/smtp/snort_smtp.h, file-process/file_api.h,
      file-process/file_mime_process.c, preprocessors/str_search.c,
      preprocessors/str_search.h, sfutil/bnfa_search.c:
      Add Stateful mime boundary search when split between packets.
 
    * src/preprocessors/HttpInspect/client/hi_client.c:
      Change the uri search to start from method end instead of the start
      of payload.

    * configure.in, doc/README.file, doc/snort_manual.pdf,
      src/parser.c, src/preprocids.h, src/snort.c, src/util.c,
      src/detection-plugins/.cvsignore,
      src/dynamic-examples/Makefile.am,
      src/dynamic-plugins/sf_engine/.cvsignore,
      src/dynamic-preprocessors/Makefile.am,
      src/dynamic-preprocessors/file/Makefile.am,
      src/dynamic-preprocessors/file/file_agent.c,
      src/dynamic-preprocessors/file/file_agent.h,
      src/dynamic-preprocessors/file/file_event_log.c,
      src/dynamic-preprocessors/file/file_event_log.h,
      src/dynamic-preprocessors/file/file_inspect_config.c,
      src/dynamic-preprocessors/file/file_inspect_config.h,
      src/dynamic-preprocessors/file/file_sha.c,
      src/dynamic-preprocessors/file/file_sha.h,
      src/dynamic-preprocessors/file/sf_file.dsp,
      src/dynamic-preprocessors/file/spp_file.c,
      src/dynamic-preprocessors/file/spp_file.h,
      src/dynamic-preprocessors/sf_dynamic_initialize/sf_dynamic_initialize.dsp,
      src/file-process/Makefile.am, src/file-process/circular_buffer.c,
      src/file-process/circular_buffer.h, src/file-process/file_api.h,
      src/file-process/file_capture.c, src/file-process/file_capture.h,
      src/file-process/file_mempool.c, src/file-process/file_mempool.h,
      src/file-process/file_resume_block.c,
      src/file-process/file_service.c, src/file-process/file_service.h,
      src/file-process/file_service_config.c,
      src/file-process/file_service_config.h,
      src/file-process/file_stats.c, src/file-process/file_stats.h,
      src/file-process/libs/file_config.c,
      src/file-process/libs/file_config.h,
      src/file-process/libs/file_identifier.c,
      src/file-process/libs/file_identifier.h,
      src/file-process/libs/file_lib.c,
      src/file-process/libs/file_lib.h,
      src/file-process/libs/file_sha256.h, tools/Makefile.am,
      tools/file_server/Makefile.am,
      tools/file_server/README.file_server,
      tools/file_server/file_server.c:
      Add file capture feature and introduce file inspect preprocessor

    * src/preprocessors/Stream5/snort_stream5_tcp.c:
      Parse error if there are missing direction specifiers.
      Thanks to Bram Fabeg for the report.
 
    * src/ipv6_port.h:
      Remove duplicate macro for GET_ORIG_IPH_PROTO.

    * doc/: README.decode, README.gre, README.mpls, snort_manual.pdf,
      snort_manual.tex:
      Update manual and other docs related to tunneling.
      Thanks to Jason Poley for noting it.

    * src/parser.c:
      Not so silently skip duplicate service metadata.

    * src/: log.c, mempool.c, parser.c, snort.c, util.c,
      detection-plugins/sp_ip_tos_check.c,
      detection-plugins/sp_pattern_match.c,
      detection-plugins/sp_replace.c, detection-plugins/sp_session.c,
      detection-plugins/sp_tcp_win_check.c,
      dynamic-preprocessors/dns/spp_dns.c,
      dynamic-preprocessors/ftptelnet/pp_ftp.c,
      dynamic-preprocessors/ftptelnet/snort_ftptelnet.c,
      dynamic-preprocessors/sdf/sdf_pattern_match.c,
      output-plugins/spo_log_ascii.c, output-plugins/spo_log_tcpdump.c,
      preprocessors/HttpInspect/utils/hi_paf.c,
      preprocessors/Stream5/snort_stream5_tcp.c:
      Replace obsolete bzero and index calls.  Credits to Bill Parker

    * src/dynamic-preprocessors/: smtp/snort_smtp.c, ssl/spp_ssl.c,
      libs/ssl.c, libs/ssl.h:
      Check for SSL type only when the SSL handshake is not complete.
      Don't check for type in SSL data.
      Thanks to Bram Fabeg for reporting this.

    * src/preprocessors/: HttpInspect/server/hi_server.c,
      HttpInspect/server/hi_server_norm.c, Stream5/snort_stream5_tcp.c:
      Only check charset bom once per response body;
      Only set charset once per charset=

    * src/profiler.c:
      Fix issue when reading pcaps from command line and using multiple
      policies and --pcap-reset.

    * src/detection-plugins/detection_options.c:
      Don't count RTN perf time in OTN perf time.
      Credits to Reinoud for reporting this.
 
    * doc/README.flowbits:
      Fix typo in flowbits isnotset examples

    * src/snort.c, src/snort.h, src/util.c, snort.8,
      doc/snort_manual.pdf, doc/snort_manual.tex:
      Add a command line switch --no-interface-pidfile to snort.
 
    * src/preprocessors/: spp_stream5.c, Stream5/stream5_common.h:
      Updated Stream's exit stats to use 'filtered' instead of dropped. 

    * src/: detection_util.h, dynamic-preprocessors/sip/spp_sip.c:
      Don't set sip/http buffers to null

    * src/dynamic-plugins/sf_engine/sf_snort_plugin_api.c:
      Return mismatch if requested http buffer was not set

    * src/snort.c: Bugs Fixed:
      Capture packet data for sigabrt and sigbus

    * doc/README.dcerpc2, doc/snort_manual.pdf, doc/snort_manual.tex,
      etc/gen-msg.map, preproc_rules/preprocessor.rules, src/active.c,
      src/active.h, src/encode.c, src/encode.h, src/generators.h,
      src/dynamic-plugins/sf_dynamic_plugins.c,
      src/dynamic-plugins/sf_dynamic_preprocessor.h,
      src/dynamic-preprocessors/dcerpc2/dce2_co.c,
      src/dynamic-preprocessors/dcerpc2/dce2_config.c,
      src/dynamic-preprocessors/dcerpc2/dce2_config.h,
      src/dynamic-preprocessors/dcerpc2/dce2_event.c,
      src/dynamic-preprocessors/dcerpc2/dce2_event.h,
      src/dynamic-preprocessors/dcerpc2/dce2_memory.c,
      src/dynamic-preprocessors/dcerpc2/dce2_memory.h,
      src/dynamic-preprocessors/dcerpc2/dce2_smb.c,
      src/dynamic-preprocessors/dcerpc2/dce2_smb.h,
      src/dynamic-preprocessors/dcerpc2/dce2_stats.h,
      src/dynamic-preprocessors/dcerpc2/snort_dce2.c,
      src/dynamic-preprocessors/dcerpc2/snort_dce2.h,
      src/dynamic-preprocessors/dcerpc2/spp_dce2.c,
      src/dynamic-preprocessors/dcerpc2/spp_dce2.h,
      src/dynamic-preprocessors/dcerpc2/includes/smb.h,
      src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.c,
      src/dynamic-preprocessors/imap/snort_imap.c,
      src/dynamic-preprocessors/pop/snort_pop.c,
      src/dynamic-preprocessors/smtp/snort_smtp.c,
      src/file-process/file_api.h,
      src/file-process/file_mime_process.c,
      src/file-process/file_service.c,
      src/file-process/libs/file_identifier.c,
      src/file-process/libs/file_identifier.h,
      src/file-process/libs/file_lib.c,
      src/file-process/libs/file_lib.h,
      src/preprocessors/snort_httpinspect.c,
      src/preprocessors/Stream5/snort_stream5_tcp.c:
      Add SMB file support

2013-10-18 Steven Sturges <ssturges@sourcefire.com>
Snort 2.9.5.6
    * src/build.h:
      updating build number to 208

    * src/preprocessors/Stream5/snort_stream5_tcp.c:
      add NULL check for preprocessors that check for PAF before
      they check for any actual tcp session

    * src/detection-plugins/: sp_byte_check.c, sp_byte_jump.c,
      sp_isdataat.c, sp_pattern_match.c:
      Test if the byte extracted distance and/or offset is within
      bounds of the search buffer.  Thanks to Nathan Fowler for
      noting the issue.

    * src/preprocessors/HttpInspect/client/hi_client.c:
      clear cookie normalization buffer to avoid accidental null
      dereference in pipelined request.  Thanks to Michael Galapchuk
      for reporting the problem.

2013-09-02 Steven Sturges <ssturges@sourcefire.com>
Snort 2.9.5.5
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
      disable all detection (not just content-base) for packets on previously
      blocked sessions

    * src/preprocessors/perf.c:
      Write perfmon entry when both packet count and time conditions are met,
      rather than waiting for a multiple of the packet count after the time is
      reached.

    * src/dynamic-preprocessors/smtp/snort_smtp.c:
      Stop inspection of the entire session when TLS data is present with
      ignore_tls_data enabled in SMTP - Check for midstream pickups and
      gaps when we miss server hello, and stop inspection as soon as we get
      client hello when ignore_tls_data is turned on

    * src/dynamic-plugins/sf_engine/sf_snort_plugin_pcre.c:
      changed pcre relative match with HTTP buffers to be not allowed in .so
      rules (same as in text rules)

2013-07-03 Steven Sturges <ssturges@sourcefire.com>
Snort 2.9.5.3
    * src/preprocessors/Stream5/snort_stream5_tcp.c:
      Fixed handling of partial segment purging.  Thanks to Lode Mertens
      for reporting the issue.

    * configure.in, src/active.c, src/decode.c, src/decode.h,
      src/detect.c, src/detection_util.c, src/detection_util.h,
      src/encode.c, src/encode.h, src/fpcreate.c, src/fpdetect.c,
      src/log_text.c, src/parser.c, src/plugbase.c, src/ppm.c,
      src/ppm.h, src/profiler.c, src/snort.c, src/util.c, src/util.h,
      src/detection-plugins/detection_options.c,
      src/detection-plugins/sp_byte_check.c,
      src/detection-plugins/sp_ftpbounce.c,
      src/detection-plugins/sp_pattern_match.c,
      src/detection-plugins/sp_pattern_match.h,
      src/detection-plugins/sp_pcre.c, src/detection-plugins/sp_pcre.h,
      src/detection-plugins/sp_replace.c,
      src/detection-plugins/sp_rpc_check.c,
      src/detection-plugins/sp_urilen_check.c,
      src/dynamic-examples/dynamic-preprocessor/spp_example.c,
      src/dynamic-plugins/sf_convert_dynamic.c,
      src/dynamic-plugins/sf_dynamic_common.h,
      src/dynamic-plugins/sf_dynamic_define.h,
      src/dynamic-plugins/sf_dynamic_engine.h,
      src/dynamic-plugins/sf_dynamic_meta.h,
      src/dynamic-plugins/sf_dynamic_plugins.c,
      src/dynamic-plugins/sf_dynamic_preprocessor.h,
      src/dynamic-plugins/sp_dynamic.c,
      src/dynamic-plugins/sf_engine/Makefile.am,
      src/dynamic-plugins/sf_engine/sf_snort_detection_engine.c,
      src/dynamic-plugins/sf_engine/sf_snort_packet.h,
      src/dynamic-plugins/sf_engine/sf_snort_plugin_api.c,
      src/dynamic-plugins/sf_engine/sf_snort_plugin_api.h,
      src/dynamic-plugins/sf_engine/sf_snort_plugin_content.c,
      src/dynamic-plugins/sf_engine/sf_snort_plugin_pcre.c,
      src/dynamic-plugins/sf_engine/examples/bug26266.c,
      src/dynamic-plugins/sf_engine/examples/detection_lib_meta.h,
      src/dynamic-plugins/sf_engine/examples/fake_snort.c,
      src/dynamic-plugins/sf_preproc_example/spp_nfs_setup.c,
      src/dynamic-preprocessors/dcerpc2/dce2_http.h,
      src/dynamic-preprocessors/dcerpc2/spp_dce2.c,
      src/dynamic-preprocessors/dnp3/spp_dnp3.c,
      src/dynamic-preprocessors/dns/spp_dns.c,
      src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.c,
      src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.h,
      src/dynamic-preprocessors/ftptelnet/spp_ftptelnet.c,
      src/dynamic-preprocessors/gtp/spp_gtp.c,
      src/dynamic-preprocessors/imap/snort_imap.c,
      src/dynamic-preprocessors/imap/spp_imap.c,
      src/dynamic-preprocessors/isakmp/spp_isakmp.c,
      src/dynamic-preprocessors/modbus/spp_modbus.c,
      src/dynamic-preprocessors/pop/snort_pop.c,
      src/dynamic-preprocessors/pop/spp_pop.c,
      src/dynamic-preprocessors/reputation/reputation_config.h,
      src/dynamic-preprocessors/reputation/spp_reputation.c,
      src/dynamic-preprocessors/rzb_saac/spp_rzb-saac.c,
      src/dynamic-preprocessors/sdf/spp_sdf.c,
      src/dynamic-preprocessors/sip/sip_dialog.c,
      src/dynamic-preprocessors/sip/sip_parser.c,
      src/dynamic-preprocessors/sip/spp_sip.c,
      src/dynamic-preprocessors/smtp/spp_smtp.c,
      src/dynamic-preprocessors/ssh/spp_ssh.c,
      src/dynamic-preprocessors/ssl/spp_ssl.c,
      src/file-process/file_service.c,
      src/file-process/libs/file_config.c,
      src/output-plugins/spo_unified2.c, src/preprocessors/portscan.c,
      src/preprocessors/snort_httpinspect.c,
      src/preprocessors/spp_arpspoof.c, src/preprocessors/spp_bo.c,
      src/preprocessors/spp_frag3.c,
      src/preprocessors/spp_httpinspect.c,
      src/preprocessors/spp_perfmonitor.c,
      src/preprocessors/spp_rpc_decode.c,
      src/preprocessors/spp_sfportscan.c,
      src/preprocessors/spp_stream5.c, src/preprocessors/stream_api.h,
      src/preprocessors/HttpInspect/client/hi_client.c,
      src/preprocessors/HttpInspect/normalization/hi_norm.c,
      src/preprocessors/Stream5/snort_stream5_tcp.c,
      src/preprocessors/Stream5/snort_stream5_udp.c,
      src/preprocessors/Stream5/stream5_common.h, src/sfutil/sf_iph.c,
      src/sfutil/sf_iph.h, src/sfutil/test/unit_hacks.c:
      Performance improvements and other refactorings. Notable changes
      include: improved HTTP buffer implementation and replaced run-time
      packet checks with assertions.

    * src/preprocessors/Stream5/snort_stream5_tcp.c:
      Ensure proper counting of sessions initializing.

    * doc/Makefile.am, doc/faq.pdf, doc/faq.tex:
      Remove Snort FAQ from source package since its now live on the web.

    * src/preprocessors/: spp_stream5.c, stream_expect.c,
      stream_expect.h:
      Add a memcap to expected session tracking.

    * src/sfutil/sfrt_flat.c:
      Check for memory allocation failure in both IPV4 and IPV6 tables.

    * src/control/sfcontrol.c:
      Do not timeout during shutdown and fix stop processing code in the
      control socket thread.  Add the thread to the list before creation
      of the thread to prevent a race condition.

2013-06-04 Steven Sturges <ssturges@sourcefire.com>
Snort 2.9.5
    * src/: snort.c, preprocessors/spp_stream5.c:
      when block rules fire during shutdown, log them as alert instead
      of drop

    * src/: active.c, active.h,
      preprocessors/Stream5/snort_stream5_session.c:
      don't allow blocks or actions from pruned sessions (unrelated to
      current packet)

    * src/preprocessors/Stream5/snort_stream5_tcp.c:
      don't generate 129:1 in syn-sent

    * src/preprocessors/Stream5/: snort_stream5_tcp.c,
      snort_stream5_udp.c, stream5_common.h:
      don't apply window or mss on midstream pickups
      remove unused flags
      eliminate read-mode check when determining window

    * src/preprocessors/Stream5/snort_stream5_tcp.c:
      don't reassemble on the tracked whitelisted flows
      fix sequence number validation on ack to zero window syn+ack
      fix timestamp tracking to use window base instead of next expected

    * src/preprocessors/spp_stream5.c:
      when stream5 disables inspection, ensure non-content rules are not run

    * src/dynamic-preprocessors/dcerpc2/dce2_smb.c:
      When removing a pipe tracker, NULL out static request tracker's
      pipe tracker for pipe tracker that was dynamically allocated. 

    * src/file-process/libs/file_identifier.c:
      Update some comments and avoid adding the same file magic

    * src/preprocessors/: spp_stream5.c, stream_api.h,
      Stream5/snort_stream5_tcp.c:
      swap client/server on midstream pickup if we identify server by service
      using client port

    * src/file-process/libs/file_identifier.c:
      Remove the code that parent file type might overwrite child file type.

    * preproc_rules/preprocessor.rules, src/generators.h,
      src/preprocessors/HttpInspect/event_output/hi_eo_log.c,
      src/preprocessors/HttpInspect/include/hi_eo_events.h,
      src/preprocessors/HttpInspect/utils/hi_paf.c,
      src/preprocessors/Stream5/snort_stream5_tcp.c:
      HTTP PAF abort improvements

    * doc/: README.frag3, snort_manual.pdf, snort_manual.tex:
      Added config event_trace description to Snort manual.  Removed
      commas from Frag3 example configurations, thanks to Nicholas
      Horton for mentioning this.
 
    * src/: dynamic-preprocessors/reputation/reputation_config.c,
      sfutil/sfrt_flat.c, sfutil/sfrt_flat.h, sfutil/sfrt_flat_dir.c:
      Copy reputation info from another list when a duplicate address is
      inserted. 

    * src/dynamic-preprocessors/smtp/snort_smtp.c:
      Fix issue when SMTP BDAT command specifies 0 length.

    * src/dynamic-preprocessors/reputation/shmem/shmem_datamgmt.c:
      Don't sort the manifest file.

    * src/: snort.h, util.c:
      Fix FatalError to actually exit when initializing in the failopen
      thread. 

    * src/dynamic-preprocessors/reputation/reputation_config.c:
      Update to use more accurate ip list file parsing and validation. 

    * src/: active.h, snort.c, dynamic-plugins/sf_dynamic_plugins.c,
      preprocessors/spp_stream5.c, preprocessors/stream_api.h,
      preprocessors/Stream5/snort_stream5_tcp.c:
      ensure that force blocks persist

    * src/dynamic-preprocessors/reputation/shmem/: shmem_config.c,
      shmem_config.h, shmem_datamgmt.c, shmem_datamgmt.h, shmem_mgmt.c:
      Refactor/cleanup of shared memory, data management logic. 

    * src/: dynamic-examples/dynamic-rule/detection_lib_meta.h,
      dynamic-plugins/sf_dynamic_meta.h,
      dynamic-plugins/sf_engine/sf_snort_detection_engine.c,
      preprocessors/spp_stream5.c, preprocessors/stream_api.h:
      Add a stream API function to populate a session key given a packet.
      Also, export REQ_ENGINE_LIB_MAJOR and REQ_ENGINE_LIB_MINOR from snort

    * src/preprocessors/Stream5/snort_stream5_tcp.c:
      allow stream5 to track whitelisted sessions

    * src/: snort.c, dynamic-preprocessors/dnp3/spp_dnp3.c,
      preprocessors/Stream5/snort_stream5_tcp.c,
      preprocessors/Stream5/stream5_paf.c, sfutil/sfPolicy.c,
      sfutil/sfPolicy.h:
      disable config by vlan or net selection if -DPOLICY_BY_ID_ONLY

    * src/: snort.c, snort.h, dynamic-preprocessors/smtp/spp_smtp.c,
      preprocessors/Stream5/stream5_ha.c,
      preprocessors/Stream5/stream5_ha.h, win32/WIN32-Code/misc.c,
      win32/WIN32-Includes/config.h, win32/WIN32-Prj/snort.dsp:
      don't compile pcap reload for Win, add function for ffs() which
      is not defined in windows. 

    * src/preprocessors/snort_httpinspect.c:
      Support large file processing in post raw data (not in MIME format)

    * src/: decode.c, decode.h, fpcreate.c, fpdetect.c, parser.c,
      parser.h, plugbase.c, plugbase.h, rate_filter.c, rate_filter.h,
      sfthreshold.c, sfthreshold.h, snort.c, snort.h, spo_plugbase.h,
      util.c, util.h, control/sfcontrol.c, control/sfcontrol.h,
      detection-plugins/detection_options.c,
      detection-plugins/detection_options.h,
      detection-plugins/sp_asn1.c, detection-plugins/sp_base64_data.c,
      detection-plugins/sp_base64_decode.c,
      detection-plugins/sp_byte_check.c,
      detection-plugins/sp_byte_extract.c,
      detection-plugins/sp_byte_jump.c,
      detection-plugins/sp_clientserver.c, detection-plugins/sp_cvs.c,
      detection-plugins/sp_dsize_check.c,
      detection-plugins/sp_file_data.c,
      detection-plugins/sp_flowbits.c,
      detection-plugins/sp_ftpbounce.c,
      detection-plugins/sp_icmp_code_check.c,
      detection-plugins/sp_icmp_id_check.c,
      detection-plugins/sp_icmp_seq_check.c,
      detection-plugins/sp_icmp_type_check.c,
      detection-plugins/sp_ip_fragbits.c,
      detection-plugins/sp_ip_id_check.c,
      detection-plugins/sp_ip_proto.c,
      detection-plugins/sp_ip_same_check.c,
      detection-plugins/sp_ip_tos_check.c,
      detection-plugins/sp_ipoption_check.c,
      detection-plugins/sp_isdataat.c,
      detection-plugins/sp_pattern_match.c,
      detection-plugins/sp_pattern_match.h,
      detection-plugins/sp_pcre.c, detection-plugins/sp_pcre.h,
      detection-plugins/sp_pkt_data.c, detection-plugins/sp_react.c,
      detection-plugins/sp_replace.c, detection-plugins/sp_replace.h,
      detection-plugins/sp_respond3.c,
      detection-plugins/sp_rpc_check.c, detection-plugins/sp_session.c,
      detection-plugins/sp_tcp_ack_check.c,
      detection-plugins/sp_tcp_flag_check.c,
      detection-plugins/sp_tcp_seq_check.c,
      detection-plugins/sp_tcp_win_check.c,
      detection-plugins/sp_ttl_check.c,
      detection-plugins/sp_urilen_check.c,
      dynamic-examples/dynamic-preprocessor/sf_preproc_info.h,
      dynamic-examples/dynamic-preprocessor/spp_example.c,
      dynamic-examples/dynamic-rule/detection_lib_meta.h,
      dynamic-output/libs/output_lib.c,
      dynamic-output/plugins/output_api.h,
      dynamic-output/plugins/output_common.h,
      dynamic-output/plugins/output_lib.h,
      dynamic-output/plugins/output_plugin.c,
      dynamic-plugins/sf_convert_dynamic.c,
      dynamic-plugins/sf_convert_dynamic.h,
      dynamic-plugins/sf_dynamic_detection.h,
      dynamic-plugins/sf_dynamic_engine.h,
      dynamic-plugins/sf_dynamic_plugins.c,
      dynamic-plugins/sf_dynamic_preprocessor.h,
      dynamic-plugins/sp_dynamic.c, dynamic-plugins/sp_dynamic.h,
      dynamic-plugins/sp_preprocopt.c, dynamic-plugins/sp_preprocopt.h,
      dynamic-plugins/sf_engine/sf_snort_detection_engine.c,
      dynamic-plugins/sf_engine/sf_snort_detection_engine.h,
      dynamic-plugins/sf_engine/sf_snort_plugin_api.h,
      dynamic-plugins/sf_engine/sf_snort_plugin_loop.c,
      dynamic-plugins/sf_engine/sf_snort_plugin_pcre.c,
      dynamic-plugins/sf_engine/examples/sfsnort_dynamic_detection_lib.c,
      dynamic-plugins/sf_preproc_example/sf_preproc_info.h,
      dynamic-preprocessors/dcerpc2/dce2_config.c,
      dynamic-preprocessors/dcerpc2/dce2_config.h,
      dynamic-preprocessors/dcerpc2/dce2_paf.c,
      dynamic-preprocessors/dcerpc2/dce2_paf.h,
      dynamic-preprocessors/dcerpc2/dce2_roptions.c,
      dynamic-preprocessors/dcerpc2/dce2_roptions.h,
      dynamic-preprocessors/dcerpc2/snort_dce2.c,
      dynamic-preprocessors/dcerpc2/spp_dce2.c,
      dynamic-preprocessors/dnp3/dnp3_paf.c,
      dynamic-preprocessors/dnp3/dnp3_paf.h,
      dynamic-preprocessors/dnp3/dnp3_roptions.c,
      dynamic-preprocessors/dnp3/dnp3_roptions.h,
      dynamic-preprocessors/dnp3/spp_dnp3.c,
      dynamic-preprocessors/dns/spp_dns.c,
      dynamic-preprocessors/ftptelnet/ftpp_ui_server_lookup.c,
      dynamic-preprocessors/ftptelnet/ftpp_ui_server_lookup.h,
      dynamic-preprocessors/ftptelnet/snort_ftptelnet.c,
      dynamic-preprocessors/ftptelnet/snort_ftptelnet.h,
      dynamic-preprocessors/ftptelnet/spp_ftptelnet.c,
      dynamic-preprocessors/gtp/gtp_roptions.c,
      dynamic-preprocessors/gtp/gtp_roptions.h,
      dynamic-preprocessors/gtp/spp_gtp.c,
      dynamic-preprocessors/imap/imap_config.h,
      dynamic-preprocessors/imap/snort_imap.c,
      dynamic-preprocessors/imap/spp_imap.c,
      dynamic-preprocessors/modbus/modbus_paf.c,
      dynamic-preprocessors/modbus/modbus_paf.h,
      dynamic-preprocessors/modbus/modbus_roptions.c,
      dynamic-preprocessors/modbus/modbus_roptions.h,
      dynamic-preprocessors/modbus/spp_modbus.c,
      dynamic-preprocessors/pop/snort_pop.c,
      dynamic-preprocessors/pop/spp_pop.c,
      dynamic-preprocessors/reputation/reputation_config.c,
      dynamic-preprocessors/reputation/reputation_config.h,
      dynamic-preprocessors/reputation/spp_reputation.c,
      dynamic-preprocessors/reputation/shmem/shmem_common.h,
      dynamic-preprocessors/reputation/shmem/shmem_datamgmt.c,
      dynamic-preprocessors/reputation/shmem/shmem_datamgmt.h,
      dynamic-preprocessors/sdf/sdf_detection_option.c,
      dynamic-preprocessors/sdf/sdf_detection_option.h,
      dynamic-preprocessors/sdf/spp_sdf.c,
      dynamic-preprocessors/sdf/spp_sdf.h,
      dynamic-preprocessors/sip/sip_roptions.c,
      dynamic-preprocessors/sip/sip_roptions.h,
      dynamic-preprocessors/sip/spp_sip.c,
      dynamic-preprocessors/sip/spp_sip.h,
      dynamic-preprocessors/smtp/smtp_config.c,
      dynamic-preprocessors/smtp/snort_smtp.c,
      dynamic-preprocessors/smtp/spp_smtp.c,
      dynamic-preprocessors/ssh/spp_ssh.c,
      dynamic-preprocessors/ssl/spp_ssl.c, file-process/file_service.c,
      output-plugins/spo_alert_fast.c, output-plugins/spo_alert_full.c,
      output-plugins/spo_alert_sf_socket.c,
      output-plugins/spo_alert_syslog.c,
      output-plugins/spo_alert_test.c,
      output-plugins/spo_alert_unixsock.c, output-plugins/spo_csv.c,
      output-plugins/spo_log_ascii.c, output-plugins/spo_log_null.c,
      output-plugins/spo_log_tcpdump.c, output-plugins/spo_unified2.c,
      parser/IpAddrSet.c, parser/IpAddrSet.h, preprocessors/portscan.c,
      preprocessors/portscan.h, preprocessors/spp_arpspoof.c,
      preprocessors/spp_bo.c, preprocessors/spp_frag3.c,
      preprocessors/spp_httpinspect.c, preprocessors/spp_normalize.c,
      preprocessors/spp_perfmonitor.c, preprocessors/spp_rpc_decode.c,
      preprocessors/spp_sfportscan.c, preprocessors/spp_stream5.c,
      preprocessors/stream_api.h,
      preprocessors/HttpInspect/include/hi_paf.h,
      preprocessors/HttpInspect/include/hi_ui_server_lookup.h,
      preprocessors/HttpInspect/user_interface/hi_ui_server_lookup.c,
      preprocessors/HttpInspect/utils/hi_paf.c,
      preprocessors/Stream5/snort_stream5_session.h,
      preprocessors/Stream5/snort_stream5_tcp.c,
      preprocessors/Stream5/snort_stream5_tcp.h,
      preprocessors/Stream5/snort_stream5_udp.c,
      preprocessors/Stream5/snort_stream5_udp.h,
      preprocessors/Stream5/stream5_common.c,
      preprocessors/Stream5/stream5_common.h,
      preprocessors/Stream5/stream5_ha.c,
      preprocessors/Stream5/stream5_ha.h,
      preprocessors/Stream5/stream5_paf.c,
      preprocessors/Stream5/stream5_paf.h, sfutil/Makefile.am,
      sfutil/acsmx.c, sfutil/acsmx.h, sfutil/acsmx2.c, sfutil/acsmx2.h,
      sfutil/bnfa_search.c, sfutil/bnfa_search.h,
      sfutil/intel-soft-cpm.c, sfutil/intel-soft-cpm.h, sfutil/mpse.c,
      sfutil/mpse.h, sfutil/sfPolicy.c, sfutil/sfPolicy.h,
      sfutil/sfPolicyData.h, sfutil/sfPolicyUserData.c,
      sfutil/sfPolicyUserData.h, sfutil/sfksearch.c,
      sfutil/sfksearch.h, sfutil/sfrf.c, sfutil/sfrf.h, sfutil/sfrt.c,
      sfutil/sfrt.h, sfutil/sfthd.c, sfutil/sfthd.h,
      sfutil/test/sfrf_test.c, sfutil/test/sfthd_test.c,
      sfutil/test/unit_hacks.c, sfutil/test/unit_hacks.h,
      target-based/sftarget_reader.c, target-based/sftarget_reader.h:
      Add a control channel command that reloads the snort configuration.  If
      a restart is needed, the command will return an error and the new
      configuration will be freed.    Using this can replace the HUP signal,
      which does not have a means of feedback to the user.

    * preproc_rules/preprocessor.rules, src/generators.h,
      src/dynamic-preprocessors/imap/imap_log.c,
      src/dynamic-preprocessors/imap/imap_log.h,
      src/dynamic-preprocessors/pop/pop_log.c,
      src/dynamic-preprocessors/pop/pop_log.h,
      src/dynamic-preprocessors/smtp/smtp_log.c,
      src/dynamic-preprocessors/smtp/smtp_log.h,
      doc/README.imap, doc/README.pop:
      Removed the decoding failure alert for bitencoded/non-encoded
      attachments since it was invalid as we don't decoded these attachments. 

    * src/preprocessors/spp_frag3.c:
      Continue to track fragments if rebuilt packet caused a drop.

    * src/preprocessors/Stream5/snort_stream5_tcp.c:
      Fixed POST_SESSION_CLEANUP() macro to not log messages when Stream5
      is configured with "prune_log_max 0".  Thanks to Gregory S Thomas
      for pointing out the issue.

    * src/preprocessors/Stream5/snort_stream5_tcp.c:
      Skip MAC address verification on packets being routed by a DAQ Module. 

    * src/: decode.c, parser.c:
      Disallow rule-type decode rules with a sid that exceed
      DECODE_INDEX_MAX. 

    * src/decode.c:
      Fixed MPLS header length check. Credits to Jacob Baines for the
      find.
 
    * src/fpdetect.c:
      When decoding Teredo and the inner IPv6 doesn't have any payload,
      reset do_detect_content to ensure content matches are checked when
      evaluating rules against the outer IPv4 'payload'.  Thanks to Yun
      Zheng Hu & L0rd Ch0de1m0rt for reporting the issue & crafting
      traffic to reproduce. 

    * doc/snort_manual.tex:
      Add reference 'msb' to the list of valid ones in the Snort manual. 

    * src/preprocessors/Stream5/snort_stream5_tcp.c:
      flush and free application data on receipt of TCP RST in the
      close-wait state

    * src/: snort.c, preprocessors/spp_stream5.c,
      preprocessors/stream_api.h, preprocessors/stream_expect.c,
      preprocessors/Stream5/snort_stream5_icmp.c,
      preprocessors/Stream5/snort_stream5_ip.c,
      preprocessors/Stream5/snort_stream5_session.c,
      preprocessors/Stream5/snort_stream5_tcp.c,
      preprocessors/Stream5/snort_stream5_tcp.h,
      preprocessors/Stream5/snort_stream5_udp.c,
      preprocessors/Stream5/snort_stream5_udp.h,
      preprocessors/Stream5/stream5_common.c,
      preprocessors/Stream5/stream5_common.h,
      preprocessors/Stream5/stream5_ha.c,
      preprocessors/Stream5/stream5_ha.h, side-channel/Makefile.am,
      side-channel/dmq.c, side-channel/dmq.h, side-channel/rbmq.c,
      side-channel/rbmq.h, side-channel/sidechannel.c,
      side-channel/sidechannel_define.h,
      configure.in:
      Add the ability to share basic session state for Stream via a
      side channel

    * src/: fpdetect.c, parser.c, snort.c, snort.h, util.c,
      dynamic-preprocessors/ftptelnet/snort_ftptelnet.c,
      dynamic-preprocessors/ftptelnet/snort_ftptelnet.h,
      dynamic-preprocessors/ftptelnet/spp_ftptelnet.c,
      preprocessors/Stream5/snort_stream5_tcp.c,
      preprocessors/Stream5/stream5_paf.c:
      Improve some processing performance for small packets

    * src/preprocessors/Stream5/snort_stream5_tcp.c:
      fix alerts on packets with same src/dst ports
      fix prior alert tracking to prevent redundant alerts
      fix missing u2 packets.
 
    * src/dynamic-preprocessors/smtp/snort_smtp.c:
      Copy remaining data to normalization buffer if already normalizing
      and in AUTH state.
 
    * src/ppm.c:
      Apply event filter support for PPM rules. 

    * src/: preprocessors/snort_httpinspect.c,
      dynamic-preprocessors/dcerpc2/snort_dce2.c,
      dynamic-plugins/sf_engine/sf_snort_packet.h,
      detection-plugins/detection_options.c,
      detection-plugins/detection_options.h, decode.h,
      detection_util.c, encode.c, encode.h, fpdetect.c:
      update the packet number check in detection to include
      the rebuilt packet count.

    * doc/snort_manual.tex:
      Update description for rawbytes rule option

    * src/sfutil/sfrt_flat.c:
      correct return value for memory allocation failures

    * src/: file-process/file_mime_process.c,
      dynamic-preprocessors/imap/snort_imap.c,
      dynamic-preprocessors/pop/snort_pop.c,
      dynamic-preprocessors/smtp/snort_smtp.c:
      Check log_state in case of allocation failure

    * src/: file-process/file_mime_process.c,
      dynamic-preprocessors/imap/snort_imap.c,
      dynamic-preprocessors/smtp/snort_smtp.c,
      dynamic-preprocessors/pop/snort_pop.c:
      Processing each mime attachment after the boundary is found. 

    * doc/README.http_inspect, doc/faq.pdf, doc/snort_manual.pdf,
      etc/gen-msg.map, preproc_rules/preprocessor.rules,
      src/generators.h,
      src/dynamic-preprocessors/dcerpc2/dce2_config.c,
      src/preprocessors/spp_stream5.c,
      src/preprocessors/HttpInspect/event_output/hi_eo_log.c,
      src/preprocessors/HttpInspect/include/hi_eo_events.h,
      src/preprocessors/HttpInspect/utils/hi_paf.c,
      src/preprocessors/Stream5/snort_stream5_tcp.c:
      Correct handling of head responses
      Flush extra line feeds with following PDUs (skipped over by http_inspect)
      add profiling for PAF
      Make PAF debug output more readable

    * src/: detect.c, detect.h, generators.h, snort.c, snort.h, util.c,
      output-plugins/spo_log_tcpdump.c, preprocessors/perf-base.c,
      preprocessors/perf-base.h:
      Add a new column for total_alert_pkts to permonitor stats. 

    * src/preprocessors/: perf-base.c, perf.c:
      Fix insolent file handling in perfmonitor. 

    * src/sfutil/sf_vartable.c:
      Free allocation on failure. 

    * src/sfutil/sf_ipvar.c:
      Refactor sfip_node_t list freeing; Free sfip_node_t list on
      allocation failure. 

    * snort.8:
      Update snort.8

    * src/: dynamic-preprocessors/ftptelnet/hi_util_kmap.c,
      dynamic-preprocessors/ftptelnet/pp_ftp.c,
      dynamic-preprocessors/ftptelnet/snort_ftptelnet.c,
      preprocessors/HttpInspect/utils/hi_util_kmap.c:
      Check for NULL parameter pointer before copying into file name.
      Alloc key node after checking for zero length.  Remove
      unnecessary curr_ch NULL check. 

    * src/control/sfcontrol.c:
      Fix error checks for CS_TYPE_MAX to be greater than or equal to.

    * src/dynamic-preprocessors/dcerpc2/: dce2_smb.c, dce2_smb.h:
      Remove unneccessary NULL check of session pointer.  Fix set SMB
      fingerprint functions to just set flag and not return anything. 

    * src/dynamic-preprocessors/sdf/sdf_us_ssn.c:
      Closed file before returning on error.  NULL terminated string gotten
      from fread() before passing to strtok_r.    Checked return value of
      fseek(), ftell() and fread().  Added log messages for errors. 

    * src/preprocessors/Stream5/snort_stream5_tcp.c:
      don't do PAF on midstream pickup sessions
      do midstream pickup on SYN/ACK when packet is within require_3whs
      grace period. 

    * src/preprocessors/Stream5/snort_stream5_tcp.c:
      fix midstream pickup when server data is seen before client.  Thanks to
      John Eure for reporting the issue. 

    * src/preprocessors/perf-flow.c:
      Don't skip logging of flows with 0 packet count for flow-ip tracking. 

    * src/preprocessors/Stream5/snort_stream5_tcp.c:
      fix multi-pdu per segment flushing

    * src/preprocessors/snort_httpinspect.c:
      check http session tracker for file upload processing

    * src/: encode.c, preprocessors/snort_httpinspect.c,
      preprocessors/spp_frag3.c,
      preprocessors/Stream5/snort_stream5_tcp.c:
      Adjust stream reassembly for a few edge cases
 
    * src/preprocessors/snort_httpinspect.c:
      fix the parsing of max gzip mem

    * src/: snort.c, dynamic-output/plugins/output.h,
      dynamic-output/plugins/output_base.c:
      Print dynamic output modules with other plugins durring startup. 

    * doc/snort_manual.pdf, etc/gen-msg.map,
      preproc_rules/decoder.rules, src/decode.c, src/decode.h,
      src/encode.c, src/generators.h, src/sf_protocols.h:
      Add decoding support for ERSpan type 2 and type 3 when ERSpan
      is inside GRE. 

    * src/: snort.c, snort.h:
      Add --pcap-reload Snort flag to reload between pcap runs. 

    * doc/README.daq, doc/faq.pdf, doc/snort_manual.pdf,
      doc/snort_manual.tex, src/decode.h, src/fpdetect.c, src/snort.c,
      src/dynamic-plugins/sf_engine/sf_snort_packet.h,
      src/dynamic-preprocessors/imap/snort_imap.c,
      src/dynamic-preprocessors/pop/snort_pop.c,
      src/dynamic-preprocessors/smtp/smtp_util.c,
      src/dynamic-preprocessors/smtp/snort_smtp.c,
      src/file-process/file_mime_process.c,
      src/output-plugins/spo_unified2.c,
      src/preprocessors/snort_httpinspect.c,
      src/preprocessors/snort_httpinspect.h,
      src/preprocessors/spp_stream5.c, src/preprocessors/stream_api.h,
      src/preprocessors/Stream5/snort_stream5_tcp.c,
      src/preprocessors/Stream5/snort_stream5_tcp.h:
      Ensure logging of extra data captured after alert

    * src/dynamic-preprocessors/reputation/shmem/shmem_mgmt.c:
      When a writer is in read mode, ensure the size is the shared memory
      segment size.

    * src/file-process/: libs/file_lib.c, file_service.c:
      Only display the file stats for types in the current configuration

    * src/: dynamic-preprocessors/ftptelnet/ftpp_si.h,
      preprocessors/spp_stream5.c, preprocessors/stream_api.h,
      preprocessors/Stream5/snort_stream5_session.c,
      control/sfcontrol.c:
      Add a stream api function to return the session key given a session
      pointer.  Expose the SessionKey structure to dynamic preprocessors. 
      For ICMP "sessions", include ICMP type as an element in the key,
      thereby making it a different "session" if the type varies.  Echo
      replies are keyed the same as requests.

    * doc/snort_manual.pdf, doc/snort_manual.tex, src/parser.c,
      src/parser.h, src/snort.c, src/snort.h, doc/README.reload:
      Remove "config read_bin_file" documentation

    * src/: decode.c, decode.h, sfutil/sf_ip.h, sfutil/sf_iph.c,
      preprocessors/perf-base.c,
      dynamic-preprocessors/dcerpc2/snort_dce2.c,
      dynamic-plugins/sf_engine/sf_snort_packet.h,
      dynamic-preprocessors/sdf/spp_sdf.c:
      Update IP6RawHdr structure and fix version extraction for little
      endian machines.  Reduce size of sfip_t by 4 bytes. 

    * src/detection-plugins/sp_pattern_match.c:
      Error if relative rule option used after fast pattern only. 

    * preproc_rules/decoder.rules, src/decode.c, src/generators.h:
      Add decoder alert for IPv6 Routing Type 0 headers. 

    * src/encode.c:
      Replace usage of ScAdapterInlineMode() with DAQ_GetInterfaceMode(). 

    * src/: rate_filter.h, dynamic-preprocessors/sdf/sdf_us_ssn.h,
      dynamic-preprocessors/sdf/spp_sdf.h, sfutil/sfrt_flat_dir.h:
      Cleanup recursive header inclusions. 

    * src/decode.h:
      Fix macros for token ring header field extraction. 

    * src/dynamic-preprocessors/sdf/sdf_us_ssn.c:
      Move SSN advertisement check before stricter validation. 

    * doc/: README.dcerpc2, snort_manual.pdf, snort_manual.tex:
      Update dce_stub_data documentation. 

    * src/parser.c:
      Cleanup function ValidateIPList().
 
    * src/dynamic-output/plugins/output_base.c:
      Remove dead code path.

    * src/detection-plugins/sp_respond3.c:
      FatalError if Resp3_Parse() is called with bad parameters. 

    * src/: snort_bounds.h, preprocessors/perf-base.c:
      Add error recovery to the perfstats logging code.
 
    * src/output-plugins/: spo_alert_fast.c, spo_alert_full.c:
      Add printing of GID:SID:Rev even if there is no msg in a rule. 

    * src/dynamic-preprocessors/: smtp/spp_smtp.c, pop/spp_pop.c,
      imap/spp_imap.c:
      Initialize file depth to all the configurations, not just the default.

    * configure.in, src/decode.h,
      src/detection-plugins/sp_clientserver.c,
      src/dynamic-plugins/sf_engine/sf_snort_packet.h,
      src/dynamic-plugins/sf_engine/sf_snort_plugin_api.c,
      src/dynamic-preprocessors/dcerpc2/dce2_paf.c,
      src/dynamic-preprocessors/dcerpc2/dce2_paf.h,
      src/dynamic-preprocessors/dcerpc2/dce2_session.h,
      src/dynamic-preprocessors/dcerpc2/snort_dce2.c,
      src/dynamic-preprocessors/dcerpc2/spp_dce2.c,
      src/dynamic-preprocessors/dnp3/dnp3_paf.c,
      src/dynamic-preprocessors/dnp3/dnp3_paf.h,
      src/dynamic-preprocessors/dnp3/spp_dnp3.c,
      src/dynamic-preprocessors/ftptelnet/ftpp_si.c,
      src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.c,
      src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.h,
      src/dynamic-preprocessors/ftptelnet/spp_ftptelnet.c,
      src/dynamic-preprocessors/modbus/modbus_paf.c,
      src/dynamic-preprocessors/modbus/modbus_paf.h,
      src/dynamic-preprocessors/modbus/spp_modbus.c,
      src/file-process/file_mime_process.c,
      src/preprocessors/snort_httpinspect.c,
      src/preprocessors/spp_httpinspect.c,
      src/preprocessors/spp_stream5.c, src/preprocessors/stream_api.h,
      src/preprocessors/HttpInspect/client/hi_client.c,
      src/preprocessors/HttpInspect/include/hi_paf.h,
      src/preprocessors/HttpInspect/mode_inspection/hi_mi.c,
      src/preprocessors/HttpInspect/server/hi_server.c,
      src/preprocessors/HttpInspect/utils/hi_paf.c,
      src/preprocessors/Stream5/snort_stream5_tcp.c,
      src/preprocessors/Stream5/snort_stream5_tcp.h,
      src/preprocessors/Stream5/stream5_paf.c,
      src/preprocessors/Stream5/stream5_paf.h:
      Add support for PAF activation by service and hardened PAF (removed
      --disable-paf from configure.in)

    * etc/gen-msg.map, src/decode.c, src/decode.h, src/generators.h,
      preproc_rules/decoder.rules:
      Support decoding of ICMPv6 Node Info Query and Node Info Response.
      Added decoder event for invalid codes therein. 

    * src/preprocessors/: HttpInspect/mode_inspection/hi_mi.c,
      HttpInspect/client/hi_client.c, HttpInspect/include/hi_client.h,
      snort_httpinspect.h:
      Log XFF data on raw packet when reassembly is turned off.

    * src/dynamic-preprocessors/dcerpc2/dce2_smb.c:
      Refactor dead code path in DCE2_SmbTransactionGetName(). 

    * src/dynamic-preprocessors/ftptelnet/ftpp_ui_client_lookup.c:
      Factor out dead code path in ftpp_ui_client_lookup_add().

    * src/preprocessors/spp_bo.c:
      Remove redundant dereferences to array pointer.

    * src/sfutil/sfrf.c:
      Factor out dead code path in SFRF_ConfigAdd(). 

    * src/preprocessors/Stream5/snort_stream5_tcp.c:
      Factor out dead code path in Stream5ProcessTcp().
 
    * src/fpcreate.c:
      Factor out dead code path in fpCreatePortObject2PortGroup(). 

    * src/dynamic-preprocessors/dcerpc2/dce2_roptions.c,
      src/dynamic-preprocessors/dcerpc2/dce2_config.c:
      Factor out dead code paths in DCE2 Preproc. 

    * src/dynamic-plugins/sf_engine/sf_snort_plugin_api.c:
      Factor out dead code paths in SetCursorInternal().
 
    * src/dynamic-preprocessors/sip/: sip_roptions.c, spp_sip.c,
      spp_sip.h:
      add user defined SIP method to parsing policy instead of running policy

    * src/preprocessors/HttpInspect/include/hi_eo_events.h,
      src/preprocessors/HttpInspect/event_output/hi_eo_log.c,
      etc/gen-msg.map, src/generators.h,
      preproc_rules/preprocessor.rules,
      src/preprocessors/HttpInspect/client/hi_client.c:
      Add preprocessor alert when snort sees unescaped space within the URI
      Log IPs followed by portnum from the XFF header

    * src/preprocessors/Stream5/snort_stream5_tcp.c:
      Remove unnecessary check for NULL on array type. 

    * src/preprocessors/spp_frag3.c:
      Remove unnecessary check for NULL on array type. 

    * src/snort.c:
      Remove unnecessary check for NULL on array type. 

    * tools/u2boat/u2boat.c:
      Make sure ConvertRecord func pointer is valid before called. 

    * src/detection-plugins/sp_byte_extract.c:
      Fix value check for byte extract "multiplier" arg. 

    * src/: util.c, util.h:
      Remove dead functions from util.c

    * tools/u2spewfoo/u2spewfoo.c:
      Check for error and prevent leaks with realloc in u2spewfoo.
      Thanks to William Parker for reporting it.

    * src/: parser.c, dynamic-plugins/sf_dynamic_plugins.c,
      dynamic-preprocessors/dcerpc2/dce2_config.c,
      dynamic-preprocessors/dns/spp_dns.c:
      Fix dead code paths

    * src/preprocessors/Stream5/snort_stream5_tcp.c:
      Reset overlap count when 129:7 is triggered to avoid repeated false
      positives

    * src/dynamic-preprocessors/smtp/: snort_smtp.c, snort_smtp.h:
      Handle 535 response codes - authentication failed. 

    * doc/README.SMTP, doc/snort_manual.tex,
      src/dynamic-preprocessors/smtp/smtp_config.c,
      src/dynamic-preprocessors/smtp/smtp_config.h,
      src/dynamic-preprocessors/smtp/snort_smtp.c,
      src/dynamic-preprocessors/smtp/snort_smtp.h:
      Added new configuration options "data_cmds", "binary_data_cmds" and
      "auth_cmds" to the smtp preprocessor.

    * doc/README.reload, doc/snort_manual.tex, src/snort.c,
      src/preprocessors/perf-base.c, src/preprocessors/perf-base.h,
      src/preprocessors/perf-flow.c, src/preprocessors/perf-flow.h,
      src/preprocessors/perf.c, src/preprocessors/perf.h,
      src/preprocessors/spp_perfmonitor.c,
      src/preprocessors/Stream5/snort_stream5_tcp.c:
      Added "flow-file" configuration option and optional arguments
      to "atexitonly" for perfmonitor preprocessor.
 
    * src/: detection-plugins/sp_pattern_match.c,
      dynamic-plugins/sf_engine/sf_snort_plugin_content.c,
      Adjust detection option pointer and distance for content matches
      with negative distances that put pointer before start of buffer. 

    * src/preprocessors/HttpInspect/session_inspection/hi_si.c:
      Ensure all request and response fields are reset
 
    * src/generators.h, preproc_rules/preprocessor.rules,
      src/preprocessors/spp_frag3.c:
      Remove dead preprocessor alerts from Frag3, GIDs 123:9, 123:10
      that are covered by 116:458. 

    * src/: dynamic-preprocessors/ftptelnet/ftpp_si.c,
      dynamic-preprocessors/ftptelnet/ftpp_si.h,
      dynamic-preprocessors/ftptelnet/pp_ftp.c,
      dynamic-preprocessors/ftptelnet/snort_ftptelnet.c,
      dynamic-preprocessors/ftptelnet/snort_ftptelnet.h,
      dynamic-preprocessors/ftptelnet/spp_ftptelnet.c,
      preprocessors/stream_api.h,
      preprocessors/Stream5/snort_stream5_tcp.c:
      Set reassembly on ftp-data for file processing and file_data ptr
      for ftp-data channel.

    * src/: decode.c, decode.h, encode.c, sf_protocols.h, snort.c:
      Whitelist encrypted ESP tunnels if decoding ESP traffic. 

    * src/detection-plugins/sp_react.c:
      Fix issue where react action was lost when Snort reloads. 

    * src/dynamic-preprocessors/: imap/snort_imap.c, imap/spp_imap.c,
      smtp/snort_smtp.c, smtp/spp_smtp.c, pop/snort_pop.c,
      pop/spp_pop.c:
      Enforce target based config setting for file processing.

    * src/file-process/file_mime_process.c:
      Make sure signature context is created at any file position. 

    * src/dynamic-preprocessors/: pop/snort_pop.c, pop/snort_pop.h,
      smtp/snort_smtp.c, smtp/snort_smtp.h:
      Using boundary to check end of file

    * src/: decode.h, dynamic-plugins/sf_engine/sf_snort_packet.h,
      output-plugins/spo_unified2.c, preprocessors/spp_sfportscan.c:
      Update portscan unified2 events to log type of portscan in
      protocol field instead of 0xFF.
 
    * doc/: README.asn1, snort_manual.pdf, snort_manual.tex:
      Update asn1 rule option documentation to remove reference to
      byte_test updating relative pointer.  Thanks to Brandon Castel
      for bringing this to our attention. 

    * src/: file-process/file_mime_process.c,
      file-process/file_mime_process.h,
      preprocessors/HttpInspect/client/hi_client.c,
      file-process/Makefile.am, file-process/file_api.h,
      file-process/file_mime_config.c, file-process/file_mime_config.h,
      file-process/file_resume_block.c,
      file-process/file_resume_block.h, file-process/file_service.c,
      file-process/file_service.h, file-process/file_service_config.c,
      preprocessors/snort_httpinspect.c,
      preprocessors/snort_httpinspect.h,
      preprocessors/spp_httpinspect.c,
      preprocessors/HttpInspect/include/hi_client.h,
      preprocessors/HttpInspect/include/hi_ui_config.h,
      dynamic-preprocessors/imap/spp_imap.c,
      file-process/libs/file_config.c, file-process/libs/file_config.h,
      sfutil/sf_email_attach_decode.c, snort.c:
      Add support for http file upload. 

    * doc/: PROBLEMS, README.WIN32, README.daq, faq.tex,
      snort_manual.tex:
      Update READMEs and FAQ and Snort Manual to standardize the format of
      references to libpcap.  Also update location of winpcap.  Thanks to
      Joshua Kinard and Bryan Jones for pointing out the discrepancies. 

    * src/preprocessors/spp_sfportscan.c:
      Fix portscan to only prep a pseudo-packet if actually generating an alert

    * src/file-process/: file_api.h, file_service.c:
      Add packet to file api calls to determine if the session is inline. 

    * src/dynamic-preprocessors/sip/sip_config.c:
      Fatal error during SIP preprocessor configuration
      if a standard or user defined method cannot be allocated. 

    * src/: file-process/file_resume_block.c,
      file-process/file_service.c, file-process/file_service.h,
      snort.c:
      Move file resume cache clean to restart or snort exit

    * src/file-process/: file_api.h, file_resume_block.c:
      File API change to support logging file resume blocking.

    * src/: preprocessors/Stream5/snort_stream5_tcp.c,
      file-process/Makefile.am, file-process/file_api.h,
      file-process/file_mime_process.c,
      file-process/file_mime_process.h,
      file-process/file_resume_block.c,
      file-process/file_resume_block.h, file-process/file_service.c,
      file-process/file_service_config.c,
      dynamic-preprocessors/pop/pop_config.c,
      dynamic-preprocessors/pop/pop_config.h,
      dynamic-preprocessors/pop/snort_pop.c,
      dynamic-preprocessors/pop/snort_pop.h,
      dynamic-preprocessors/pop/spp_pop.c,
      dynamic-preprocessors/smtp/smtp_config.c,
      dynamic-preprocessors/smtp/smtp_config.h,
      dynamic-preprocessors/smtp/smtp_util.c,
      dynamic-preprocessors/smtp/smtp_util.h,
      dynamic-preprocessors/smtp/snort_smtp.c,
      dynamic-preprocessors/smtp/snort_smtp.h,
      dynamic-preprocessors/smtp/spp_smtp.c,
      dynamic-preprocessors/imap/imap_config.c,
      dynamic-preprocessors/imap/imap_config.h,
      dynamic-preprocessors/imap/snort_imap.c,
      dynamic-preprocessors/imap/snort_imap.h,
      dynamic-preprocessors/imap/spp_imap.c, util.c, util.h,
      file-process/libs/file_config.c, file-process/libs/file_config.h,
      file-process/libs/file_lib.h,
      dynamic-plugins/sf_dynamic_plugins.c,
      dynamic-plugins/sf_dynamic_preprocessor.h:
      File blocking, http resume blocking, file statistics, and file name
      support for pop, imap. 

    * src/output-plugins/spo_alert_unixsock.c:
      Update to use memset and memmove instead of bzero/bcopy.    Thanks to
      Bill Parker for the suggestion. 

    * doc/: README.dcerpc2, snort_manual.pdf, snort_manual.tex:
      Update dcerpc2 preprocessor documentation to remove -1 as a default
      and valid value to max_frag_len. 

    * src/preprocessors/spp_perfmonitor.c:
      Make sure perfmonitor evaluation function is added to each policy's
      preprocessor evaluation list. 

    * configure.in, doc/INSTALL, doc/README.reputation,
      doc/snort_manual.pdf, doc/snort_manual.tex, src/fpcreate.c,
      src/fpcreate.h, src/parser.c, src/parser.h,
      src/rule_option_types.h, src/snort.c, src/snort.h,
      src/detection-plugins/detection_options.c,
      src/dynamic-examples/Makefile.am, src/dynamic-output/Makefile.am,
      src/dynamic-output/libs/Makefile.am,
      src/dynamic-plugins/sf_convert_dynamic.c,
      src/dynamic-plugins/sf_dynamic_plugins.c,
      src/dynamic-plugins/sp_dynamic.c,
      src/dynamic-plugins/sp_preprocopt.c,
      src/dynamic-preprocessors/Makefile.am,
      src/dynamic-preprocessors/dcerpc2/sf_dce2.dsp,
      src/dynamic-preprocessors/dnp3/sf_dnp3.dsp,
      src/dynamic-preprocessors/dns/sf_dns.dsp,
      src/dynamic-preprocessors/ftptelnet/sf_ftptelnet.dsp,
      src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.c,
      src/dynamic-preprocessors/gtp/sf_gtp.dsp,
      src/dynamic-preprocessors/imap/sf_imap.dsp,
      src/dynamic-preprocessors/isakmp/sf_isakmp.dsp,
      src/dynamic-preprocessors/libs/Makefile.am,
      src/dynamic-preprocessors/libs/sfdynamic_preproc_libs.dsp,
      src/dynamic-preprocessors/modbus/sf_modbus.dsp,
      src/dynamic-preprocessors/pop/sf_pop.dsp,
      src/dynamic-preprocessors/reputation/sf_reputation.dsp,
      src/dynamic-preprocessors/sdf/sf_sdf.dsp,
      src/dynamic-preprocessors/sip/sf_sip.dsp,
      src/dynamic-preprocessors/smtp/sf_smtp.dsp,
      src/dynamic-preprocessors/ssh/sf_ssh.dsp,
      src/dynamic-preprocessors/ssl/sf_ssl.dsp,
      src/preprocessors/spp_httpinspect.c,
      src/preprocessors/Stream5/snort_stream5_tcp.c,
      src/preprocessors/Stream5/stream5_common.c,
      src/win32/WIN32-Prj/sf_engine.dsp,
      src/win32/WIN32-Prj/sf_testdetect.dsp,
      src/win32/WIN32-Prj/snort.dsp:
      Removed --disable-dynamicplugin configure option and hardened
      dynamic plugin code. 

    * src/: dynamic-plugins/sf_engine/sf_snort_packet.h,
      dynamic-preprocessors/ftptelnet/ftpp_si.c,
      dynamic-preprocessors/ftptelnet/ftpp_si.h,
      dynamic-preprocessors/ftptelnet/ftpp_ui_config.h,
      dynamic-preprocessors/ftptelnet/pp_ftp.c,
      dynamic-preprocessors/ftptelnet/snort_ftptelnet.c,
      preprocessors/spp_stream5.c, preprocessors/stream_api.h,
      preprocessors/Stream5/snort_stream5_tcp.c:
      File processing for ftp-data channel.

    * src/dynamic-preprocessors/dcerpc2/: dce2_smb.c, dce2_smb.h:
      Remove NetBIOS session state. 

    * src/: plugbase.c, output-plugins/Makefile.am,
      output-plugins/spo_unified.c, output-plugins/spo_unified.h:
      Remove deprecated unified support.  Same functionality is
      supported with unified2. 

    * src/dynamic-preprocessors/dcerpc2/dce2_smb.c:
      Correct setting FID in reassembled packets on big endian systems. 

    * doc/INSTALL, doc/snort_manual.pdf, doc/snort_manual.tex,
      src/output-plugins/spo_alert_unixsock.c:
      Update alert_unixsock output plugin and documentation for use on FreeBSD.

    * src/: decode.c, decode.h:
      Add RFC 5925 (The TCP Authentication Option) option as a valid TCP
      option and tag RFC 2385 (Protection of BGP Sessions via the TCP MD5
      Signature Option) option as obsolete. 

    * rpm/snort.spec, doc/snort_manual.tex,
      src/win32/WIN32-Prj/snort_installer.nsi,
      src/win32/WIN32-Includes/config.h:
      Set version to 2.9.5

2013-04-18 Steven Sturges <ssturges@sourcefire.com>
Snort 2.9.4.6
    * src/build.h:
      updating build number to 73

    * doc/README.counts, doc/snort_manual.pdf, doc/snort_manual.tex,
      src/decode.c, src/parser.c, src/snort.h:
      Added config tunnel_verdicts and tunnel bypass for whitelist and
      blacklist verdicts for 6in4 or 4in6 encapsulated traffic.

    * src/preprocessors/spp_frag3.c:
      Don't update IP options length and count in frag3 after allocating
      option buffer when receiving duplicate 0 offset fragments with IP
      options.

2013-03-20 Steven Sturges <ssturges@sourcefire.com>
Snort 2.9.4.5
    * src/build.h:
      updating build number to 71

    * src/preprocessors/Stream5/snort_stream5_tcp.c:
      prevent pruning when dup'ing a seglist node to avoid broken
      flushed packets

    * src/detection-plugins/detection_options.c:
      recursively search patterns within the HTTP uri
      buffers until the buffer ends.

    * src/preprocessors/HttpInspect/: client/hi_client.c,
      client/hi_client_norm.c, include/hi_client.h:
      Remove proxy information from the normalized URI buffer.  Thanks
      to L0rd Ch0de1m0rt for reporting the issue.

    * src/: control/sfcontrol.c, preprocessors/Stream5/snort_stream5_tcp.c:
      fix logging of unified2 packet data when alerting on a packet containing
      multiple HTTP PDUs

2013-02-19 Bhagyashree Bantwal <bbantwal@sourcefire.com>
Snort 2.9.4.1
    * src/build.h: updating build number to 69

    * src/preprocessors/Stream5/snort_stream5_tcp.c:
      Only check for TCP Window Slam on client packets.

    * src/: control/sfcontrol.c, control/sfcontrol.h,
      preprocessors/spp_stream5.c, preprocessors/stream_api.h,
      preprocessors/Stream5/snort_stream5_session.c,
      preprocessors/Stream5/stream5_common.h
      Add a stream API function to return a session key given a session.
      Expose the session key

    * src/target-based/sftarget_reader.c:
      Change routing table layout for ip6 attribute lookups to
      be more space efficient

    * src/preprocessors/spp_frag3.c:
      Forcibly drop excessive overlaps

    * src/preprocessors/spp_frag3.c:
      Propagate address_space_id from raw packet to frag3
          rebuilt packet DAQ header

    * src/: encode.c, encode.h,
      preprocessors/Stream5/snort_stream5_tcp.c:
      Update packet encoding to propagate the address_space_id in DAQ header

    * configure.in, src/decode.c:
      Define NO_NON_ETHER_DECODER by default in Snort builds. Add
      --enable-non-ether-decoders as a configure flag.

    * src/dynamic-preprocessors/: pop/snort_pop.c, pop/snort_pop.h,
      smtp/snort_smtp.c, smtp/snort_smtp.h:
      Use MIME boundary for end of file indication even for the last file

    * src/dynamic-preprocessors/reputation/spp_reputation.c:
      only inspect ingress zone for passive interface.

    * doc/README.reputation:
    * src/dynamic-preprocessors/reputation/shmem/shmem_mgmt.c:
      When a writer is in read mode, the size should be the shared
          memory segment size.

    * src/: control/sfcontrol.c, control/sfcontrol.h,
      dynamic-preprocessors/reputation/spp_reputation.c:
      Only decode outer header in main control section. Payload is handled by the handler.

    * src/dynamic-preprocessors/reputation/: spp_reputation.c
      shmem/shmem_mgmt.c:
      update share memory for snort readers that are idle.

    * src/parser.c:
      make sure otn is different from original and and that option functions weren't
      already freed before freeing the dup list.

    * src/dynamic-preprocessors/: smtp/spp_smtp.c, imap/spp_imap.c,
      pop/spp_pop.c:
      Initialize file depth to all the policies, not just default
      policy

    * src/dynamic-preprocessors/: pop/spp_pop.c, smtp/snort_smtp.c,
      imap/spp_imap.c:
      check whether mime decoding is disabled before allocating memory.

    * doc/: snort_manual.pdf, snort_manual.tex:
      changed doc default to 10 max_attribute_services_per_host.

    * src/: parser.c, parser.h, snort.c, snort.h,
      preprocessors/spp_frag3.c,
      preprocessors/Stream5/snort_stream5_tcp.c,
      target-based/sftarget_hostentry.c,
      target-based/sftarget_reader.c, target-based/sftarget_reader.h:
      remove unused AttributeData and change attribute table to use uints instead of
      AttributeData to reduce host/service from 5208/5192 to 80/16
      bytes respectively.  Add config max_attribute_services_per_host
      to change from default of 10.  Unused AttributeData includes
      operating system, vendor, and version for host and application
      and version for service.  Note that the data is still parsed from
      hosts.xml but not actually stored in memory.    Also tweak some
      stream5 debug code that threw warnings.

    * src/: file-process/file_service.c,
      preprocessors/snort_httpinspect.c:
      avoid processing partial HTTP content.

    * src/: encode.c, encode.h,
      preprocessors/Stream5/snort_stream5_tcp.c:
      Make sure daq supports zones and interfaces in the daq header.

    * src/: encode.c, encode.h,
      preprocessors/Stream5/snort_stream5_tcp.c:
      Maintain ingress and egress interfaces and zones and daq flags
      in the tcp session to be used to populate reassembled packets correctly.

2012-10-30 Steven Sturges <ssturges@sourcefire.com>
Snort 2.9.4
    * src/build.h:
      updating build number to 37

    * doc/README.counts, doc/snort_manual.tex, doc/snort_manual.pdf,
      src/active.c, src/active.h, src/decode.c, src/parser.c,
      src/parser.h, src/snort.c, src/snort.h, src/util.c:
      added config tunnel_verdicts and tunnel bypass for whitelist and
      blacklist verdicts for gtp or teredo encapsulated traffic.

    * src/dynamic-preprocessors/smtp/: snort_smtp.c, snort_smtp.h:
      Handle MS Exchange X-EXPS and XEXCH50 commands in the SMTP
      preprocessor.

2012-10-16 Steven Sturges <ssturges@sourcefire.com>
Snort 2.9.4 RC
    * src/build.h:
      updating build number to 35

    * src/file-process/libs/: file_identifier.c, file_identifier.h
      Fixed one issue when inserting a file magic in between another
      file magic. In addition, avoid cloning nodes which are not used
      by other node.  This improves memory assuage (from 10M down to
      4M)

    * src/: detect.c, plugbase.c, plugbase.h, snort.c, snort.h,
      dynamic-plugins/sf_dynamic_plugins.c,
      dynamic-plugins/sf_dynamic_preprocessor.h
      Added 2 new dpd functions. One turns off detection, the other
      re-enables a given preprocessor. After the preprocessors are
      configured, the preprocessor list is filtered if detection is
      off.

    * src/active.c :
      allow TCP RST response to segments w/o data

    * src/dynamic-plugins/sf_engine/: sf_snort_detection_engine.c,
      sf_snort_plugin_api.c, sf_snort_plugin_api.h,
      sf_snort_plugin_byte.c, sf_snort_plugin_content.c,
      sf_snort_plugin_hdropts.c, sf_snort_plugin_pcre.c
      Changed logic of option evaluations for SO rules that use a custom
      evaluation function to match that of the SO rule builtin logic
      when the NOT_FLAG is used.

    * src/detection-plugins/: sp_flowbits.c, sp_flowbits.h
      Use appropriate interger types and comparisons.

    * src/preprocessors/HttpInspect/: client/hi_client.c,
      server/hi_server.c
      fix win32 warnings

    * src/: active.c, fpdetect.c, preprocessors/spp_stream5.c
      don't enable active response unless configured

    * src/: dynamic-plugins/sf_engine/sf_snort_packet.h,
      preprocessors/spp_stream5.c, file-process/file_service.c,
      decode.h
      avoid logging incorrect file name/file size when multiple files
      within one packet.

    * src/dynamic-preprocessors/dcerpc2/dce2_smb.c:
      Fix Win32 build warnings.

2012-09-20 Steven Sturges <ssturges@sourcefire.com>
Snort 2.9.4 Beta
    * configure.in, doc/snort_manual.pdf, src/parser.c, src/parser.h,
      src/sfdaq.h, src/snort.h,
      src/dynamic-preprocessors/sip/sip_dialog.c,
      src/preprocessors/spp_frag3.c, src/preprocessors/spp_stream5.c,
      src/preprocessors/stream_api.h,
      src/preprocessors/Stream5/snort_stream5_session.c,
      src/preprocessors/Stream5/snort_stream5_session.h,
      src/preprocessors/Stream5/stream5_common.h:
      Add use of address_space_id in stream & frag hash keys when DAQ
      provides it.

    * src/: dynamic-preprocessors/imap/snort_imap.c,
      dynamic-preprocessors/pop/snort_pop.c,
      dynamic-preprocessors/sf_dynamic_initialize/sf_dynamic_initialize.dsp,
      dynamic-preprocessors/smtp/snort_smtp.c,
      preprocessors/snort_httpinspect.c,
      preprocessors/Stream5/snort_stream5_tcp.c,
      sfutil/sf_email_attach_decode.h,
      win32/WIN32-Prj/sf_testdetect.dsp, win32/WIN32-Prj/snort.dsp,
      win32/WIN32-Prj/snort.dsw:
      Fix a few Win32 warnings.

    * src/preprocessors/Stream5/snort_stream5_tcp.c
      ensure that the LWS policy matches that of the server (instead of
      the dest)

    * COPYING, LICENSE, contrib/snortpp.c, doc/README, src/active.h,
      src/byte_extract.c, src/byte_extract.h, src/checksum.h,
      src/cpuclock.h, src/debug.c, src/decode.h, src/detect.c,
      src/detect.h, src/detection_filter.c, src/detection_filter.h,
      src/detection_util.c, src/detection_util.h, src/encode.c,
      src/encode.h, src/event.h, src/event_queue.c, src/event_queue.h,
      src/event_wrapper.c, src/event_wrapper.h, src/fpcreate.c,
      src/fpcreate.h, src/fpdetect.c, src/fpdetect.h, src/generators.h,
      src/idle_processing.c, src/idle_processing.h,
      src/idle_processing_funcs.h, src/ipv6_port.h, src/log.c,
      src/log.h, src/log_text.c, src/log_text.h, src/mempool.c,
      src/mempool.h, src/mstring.c, src/mstring.h, src/obfuscation.c,
      src/obfuscation.h, src/packet_time.c, src/packet_time.h,
      src/parser.c, src/parser.h, src/pcap_pkthdr32.h, src/pcrm.c,
      src/pcrm.h, src/plugbase.c, src/plugbase.h, src/plugin_enum.h,
      src/ppm.c, src/ppm.h, src/preprocids.h, src/profiler.c,
      src/profiler.h, src/rate_filter.c, src/rate_filter.h,
      src/rule_option_types.h, src/rules.h, src/sf_protocols.h,
      src/sf_sdlist.c, src/sf_sdlist.h, src/sf_sdlist_types.h,
      src/sf_types.h, src/sfdaq.c, src/sfdaq.h, src/sfthreshold.c,
      src/sfthreshold.h, src/signature.c, src/signature.h, src/snort.c,
      src/snort.h, src/snort_bounds.h, src/snort_debug.h,
      src/snprintf.c, src/snprintf.h, src/spo_plugbase.h,
      src/strlcatu.h, src/strlcpyu.h, src/tag.c, src/tag.h,
      src/treenodes.h, src/util.c, src/util.h, src/control/sfcontrol.c,
      src/control/sfcontrol.h, src/control/sfcontrol_funcs.h,
      src/detection-plugins/detection_options.h,
      src/detection-plugins/sp_asn1.c, src/detection-plugins/sp_asn1.h,
      src/detection-plugins/sp_asn1_detect.c,
      src/detection-plugins/sp_asn1_detect.h,
      src/detection-plugins/sp_base64_data.c,
      src/detection-plugins/sp_base64_data.h,
      src/detection-plugins/sp_base64_decode.c,
      src/detection-plugins/sp_base64_decode.h,
      src/detection-plugins/sp_byte_check.h,
      src/detection-plugins/sp_byte_extract.h,
      src/detection-plugins/sp_byte_jump.h,
      src/detection-plugins/sp_clientserver.c,
      src/detection-plugins/sp_clientserver.h,
      src/detection-plugins/sp_cvs.c, src/detection-plugins/sp_cvs.h,
      src/detection-plugins/sp_dsize_check.c,
      src/detection-plugins/sp_dsize_check.h,
      src/detection-plugins/sp_file_data.c,
      src/detection-plugins/sp_file_data.h,
      src/detection-plugins/sp_flowbits.c,
      src/detection-plugins/sp_flowbits.h,
      src/detection-plugins/sp_ftpbounce.c,
      src/detection-plugins/sp_ftpbounce.h,
      src/detection-plugins/sp_hdr_opt_wrap.c,
      src/detection-plugins/sp_hdr_opt_wrap.h,
      src/detection-plugins/sp_icmp_code_check.c,
      src/detection-plugins/sp_icmp_code_check.h,
      src/detection-plugins/sp_icmp_id_check.c,
      src/detection-plugins/sp_icmp_id_check.h,
      src/detection-plugins/sp_icmp_seq_check.c,
      src/detection-plugins/sp_icmp_seq_check.h,
      src/detection-plugins/sp_icmp_type_check.c,
      src/detection-plugins/sp_icmp_type_check.h,
      src/detection-plugins/sp_ip_fragbits.c,
      src/detection-plugins/sp_ip_fragbits.h,
      src/detection-plugins/sp_ip_id_check.c,
      src/detection-plugins/sp_ip_id_check.h,
      src/detection-plugins/sp_ip_proto.c,
      src/detection-plugins/sp_ip_proto.h,
      src/detection-plugins/sp_ip_same_check.c,
      src/detection-plugins/sp_ip_same_check.h,
      src/detection-plugins/sp_ip_tos_check.c,
      src/detection-plugins/sp_ip_tos_check.h,
      src/detection-plugins/sp_ipoption_check.c,
      src/detection-plugins/sp_ipoption_check.h,
      src/detection-plugins/sp_isdataat.c,
      src/detection-plugins/sp_isdataat.h,
      src/detection-plugins/sp_pattern_match.c,
      src/detection-plugins/sp_pattern_match.h,
      src/detection-plugins/sp_pcre.h,
      src/detection-plugins/sp_pkt_data.c,
      src/detection-plugins/sp_pkt_data.h,
      src/detection-plugins/sp_react.c,
      src/detection-plugins/sp_react.h,
      src/detection-plugins/sp_replace.c,
      src/detection-plugins/sp_replace.h,
      src/detection-plugins/sp_respond.h,
      src/detection-plugins/sp_respond3.c,
      src/detection-plugins/sp_rpc_check.c,
      src/detection-plugins/sp_rpc_check.h,
      src/detection-plugins/sp_session.c,
      src/detection-plugins/sp_session.h,
      src/detection-plugins/sp_tcp_ack_check.c,
      src/detection-plugins/sp_tcp_ack_check.h,
      src/detection-plugins/sp_tcp_flag_check.c,
      src/detection-plugins/sp_tcp_flag_check.h,
      src/detection-plugins/sp_tcp_seq_check.c,
      src/detection-plugins/sp_tcp_seq_check.h,
      src/detection-plugins/sp_tcp_win_check.c,
      src/detection-plugins/sp_tcp_win_check.h,
      src/detection-plugins/sp_ttl_check.c,
      src/detection-plugins/sp_ttl_check.h,
      src/detection-plugins/sp_urilen_check.c,
      src/detection-plugins/sp_urilen_check.h,
      src/dynamic-examples/dynamic-preprocessor/sf_preproc_info.h,
      src/dynamic-examples/dynamic-preprocessor/spp_example.c,
      src/dynamic-examples/dynamic-rule/detection_lib_meta.h,
      src/dynamic-examples/dynamic-rule/rules.c,
      src/dynamic-examples/dynamic-rule/sid109.c,
      src/dynamic-examples/dynamic-rule/sid637.c,
      src/dynamic-output/libs/output_lib.c,
      src/dynamic-output/plugins/output.h,
      src/dynamic-output/plugins/output_api.h,
      src/dynamic-output/plugins/output_base.c,
      src/dynamic-output/plugins/output_common.h,
      src/dynamic-output/plugins/output_lib.h,
      src/dynamic-output/plugins/output_plugin.c,
      src/dynamic-plugins/sf_convert_dynamic.h,
      src/dynamic-plugins/sf_dynamic_common.h,
      src/dynamic-plugins/sf_dynamic_define.h,
      src/dynamic-plugins/sf_dynamic_detection.h,
      src/dynamic-plugins/sf_dynamic_engine.h,
      src/dynamic-plugins/sf_dynamic_meta.h,
      src/dynamic-plugins/sp_dynamic.h,
      src/dynamic-plugins/sp_preprocopt.h,
      src/dynamic-plugins/sf_engine/bmh.c,
      src/dynamic-plugins/sf_engine/bmh.h,
      src/dynamic-plugins/sf_engine/sf_decompression.c,
      src/dynamic-plugins/sf_engine/sf_decompression.h,
      src/dynamic-plugins/sf_engine/sf_snort_detection_engine.c,
      src/dynamic-plugins/sf_engine/sf_snort_detection_engine.h,
      src/dynamic-plugins/sf_engine/sf_snort_packet.h,
      src/dynamic-plugins/sf_engine/sf_snort_plugin_api.c,
      src/dynamic-plugins/sf_engine/sf_snort_plugin_api.h,
      src/dynamic-plugins/sf_engine/sf_snort_plugin_byte.c,
      src/dynamic-plugins/sf_engine/sf_snort_plugin_content.c,
      src/dynamic-plugins/sf_engine/sf_snort_plugin_hdropts.c,
      src/dynamic-plugins/sf_engine/sf_snort_plugin_loop.c,
      src/dynamic-plugins/sf_engine/sf_snort_plugin_pcre.c,
      src/dynamic-plugins/sf_engine/sf_snort_plugin_rc4.c,
      src/dynamic-plugins/sf_engine/examples/sfsnort_dynamic_detection_lib.c,
      src/dynamic-plugins/sf_engine/examples/sfsnort_dynamic_detection_lib.h,
      src/dynamic-plugins/sf_preproc_example/sf_dynamic_preproc_lib.c,
      src/dynamic-plugins/sf_preproc_example/sf_dynamic_preproc_lib.h,
      src/dynamic-plugins/sf_preproc_example/sf_preproc_info.h,
      src/dynamic-plugins/sf_preproc_example/spp_nfs_setup.c,
      src/dynamic-plugins/sf_preproc_example/spp_nfs_setup.h,
      src/dynamic-preprocessors/dcerpc2/dce2_cl.c,
      src/dynamic-preprocessors/dcerpc2/dce2_cl.h,
      src/dynamic-preprocessors/dcerpc2/dce2_co.c,
      src/dynamic-preprocessors/dcerpc2/dce2_co.h,
      src/dynamic-preprocessors/dcerpc2/dce2_config.c,
      src/dynamic-preprocessors/dcerpc2/dce2_config.h,
      src/dynamic-preprocessors/dcerpc2/dce2_debug.c,
      src/dynamic-preprocessors/dcerpc2/dce2_debug.h,
      src/dynamic-preprocessors/dcerpc2/dce2_event.c,
      src/dynamic-preprocessors/dcerpc2/dce2_event.h,
      src/dynamic-preprocessors/dcerpc2/dce2_http.c,
      src/dynamic-preprocessors/dcerpc2/dce2_http.h,
      src/dynamic-preprocessors/dcerpc2/dce2_list.c,
      src/dynamic-preprocessors/dcerpc2/dce2_list.h,
      src/dynamic-preprocessors/dcerpc2/dce2_memory.c,
      src/dynamic-preprocessors/dcerpc2/dce2_memory.h,
      src/dynamic-preprocessors/dcerpc2/dce2_paf.c,
      src/dynamic-preprocessors/dcerpc2/dce2_paf.h,
      src/dynamic-preprocessors/dcerpc2/dce2_roptions.c,
      src/dynamic-preprocessors/dcerpc2/dce2_roptions.h,
      src/dynamic-preprocessors/dcerpc2/dce2_session.h,
      src/dynamic-preprocessors/dcerpc2/dce2_smb.h,
      src/dynamic-preprocessors/dcerpc2/dce2_stats.c,
      src/dynamic-preprocessors/dcerpc2/dce2_stats.h,
      src/dynamic-preprocessors/dcerpc2/dce2_tcp.c,
      src/dynamic-preprocessors/dcerpc2/dce2_tcp.h,
      src/dynamic-preprocessors/dcerpc2/dce2_udp.c,
      src/dynamic-preprocessors/dcerpc2/dce2_udp.h,
      src/dynamic-preprocessors/dcerpc2/dce2_utils.c,
      src/dynamic-preprocessors/dcerpc2/snort_dce2.c,
      src/dynamic-preprocessors/dcerpc2/snort_dce2.h,
      src/dynamic-preprocessors/dcerpc2/spp_dce2.c,
      src/dynamic-preprocessors/dcerpc2/spp_dce2.h,
      src/dynamic-preprocessors/dcerpc2/includes/dcerpc.h,
      src/dynamic-preprocessors/dcerpc2/includes/smb.h,
      src/dynamic-preprocessors/dnp3/dnp3_map.h,
      src/dynamic-preprocessors/dnp3/dnp3_paf.c,
      src/dynamic-preprocessors/dnp3/dnp3_paf.h,
      src/dynamic-preprocessors/dnp3/dnp3_reassembly.c,
      src/dynamic-preprocessors/dnp3/dnp3_reassembly.h,
      src/dynamic-preprocessors/dnp3/dnp3_roptions.c,
      src/dynamic-preprocessors/dnp3/dnp3_roptions.h,
      src/dynamic-preprocessors/dnp3/spp_dnp3.c,
      src/dynamic-preprocessors/dnp3/spp_dnp3.h,
      src/dynamic-preprocessors/dns/spp_dns.c,
      src/dynamic-preprocessors/dns/spp_dns.h,
      src/dynamic-preprocessors/ftptelnet/ftp_bounce_lookup.c,
      src/dynamic-preprocessors/ftptelnet/ftp_bounce_lookup.h,
      src/dynamic-preprocessors/ftptelnet/ftp_client.h,
      src/dynamic-preprocessors/ftptelnet/ftp_cmd_lookup.c,
      src/dynamic-preprocessors/ftptelnet/ftp_cmd_lookup.h,
      src/dynamic-preprocessors/ftptelnet/ftp_server.h,
      src/dynamic-preprocessors/ftptelnet/ftpp_eo.h,
      src/dynamic-preprocessors/ftptelnet/ftpp_eo_events.h,
      src/dynamic-preprocessors/ftptelnet/ftpp_eo_log.c,
      src/dynamic-preprocessors/ftptelnet/ftpp_eo_log.h,
      src/dynamic-preprocessors/ftptelnet/ftpp_include.h,
      src/dynamic-preprocessors/ftptelnet/ftpp_return_codes.h,
      src/dynamic-preprocessors/ftptelnet/ftpp_si.c,
      src/dynamic-preprocessors/ftptelnet/ftpp_si.h,
      src/dynamic-preprocessors/ftptelnet/ftpp_ui_client_lookup.c,
      src/dynamic-preprocessors/ftptelnet/ftpp_ui_client_lookup.h,
      src/dynamic-preprocessors/ftptelnet/ftpp_ui_config.c,
      src/dynamic-preprocessors/ftptelnet/ftpp_ui_config.h,
      src/dynamic-preprocessors/ftptelnet/ftpp_ui_server_lookup.c,
      src/dynamic-preprocessors/ftptelnet/ftpp_ui_server_lookup.h,
      src/dynamic-preprocessors/ftptelnet/ftpp_util_kmap.h,
      src/dynamic-preprocessors/ftptelnet/hi_util_kmap.c,
      src/dynamic-preprocessors/ftptelnet/hi_util_kmap.h,
      src/dynamic-preprocessors/ftptelnet/hi_util_xmalloc.c,
      src/dynamic-preprocessors/ftptelnet/hi_util_xmalloc.h,
      src/dynamic-preprocessors/ftptelnet/pp_ftp.c,
      src/dynamic-preprocessors/ftptelnet/pp_ftp.h,
      src/dynamic-preprocessors/ftptelnet/pp_telnet.c,
      src/dynamic-preprocessors/ftptelnet/pp_telnet.h,
      src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.c,
      src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.h,
      src/dynamic-preprocessors/ftptelnet/spp_ftptelnet.c,
      src/dynamic-preprocessors/ftptelnet/spp_ftptelnet.h,
      src/dynamic-preprocessors/gtp/gtp_config.c,
      src/dynamic-preprocessors/gtp/gtp_config.h,
      src/dynamic-preprocessors/gtp/gtp_debug.h,
      src/dynamic-preprocessors/gtp/gtp_parser.c,
      src/dynamic-preprocessors/gtp/gtp_parser.h,
      src/dynamic-preprocessors/gtp/gtp_roptions.c,
      src/dynamic-preprocessors/gtp/gtp_roptions.h,
      src/dynamic-preprocessors/gtp/spp_gtp.c,
      src/dynamic-preprocessors/gtp/spp_gtp.h,
      src/dynamic-preprocessors/imap/imap_config.c,
      src/dynamic-preprocessors/imap/imap_config.h,
      src/dynamic-preprocessors/imap/imap_log.c,
      src/dynamic-preprocessors/imap/imap_log.h,
      src/dynamic-preprocessors/imap/imap_util.c,
      src/dynamic-preprocessors/imap/imap_util.h,
      src/dynamic-preprocessors/imap/snort_imap.c,
      src/dynamic-preprocessors/imap/snort_imap.h,
      src/dynamic-preprocessors/imap/spp_imap.c,
      src/dynamic-preprocessors/imap/spp_imap.h,
      src/dynamic-preprocessors/isakmp/spp_isakmp.c,
      src/dynamic-preprocessors/isakmp/spp_isakmp.h,
      src/dynamic-preprocessors/libs/sf_preproc_info.h,
      src/dynamic-preprocessors/libs/sfcommon.h,
      src/dynamic-preprocessors/libs/sfparser.c,
      src/dynamic-preprocessors/libs/ssl.c,
      src/dynamic-preprocessors/libs/ssl.h,
      src/dynamic-preprocessors/modbus/modbus_decode.c,
      src/dynamic-preprocessors/modbus/modbus_decode.h,
      src/dynamic-preprocessors/modbus/modbus_paf.c,
      src/dynamic-preprocessors/modbus/modbus_paf.h,
      src/dynamic-preprocessors/modbus/modbus_roptions.c,
      src/dynamic-preprocessors/modbus/modbus_roptions.h,
      src/dynamic-preprocessors/modbus/spp_modbus.c,
      src/dynamic-preprocessors/modbus/spp_modbus.h,
      src/dynamic-preprocessors/pop/pop_config.c,
      src/dynamic-preprocessors/pop/pop_config.h,
      src/dynamic-preprocessors/pop/pop_log.c,
      src/dynamic-preprocessors/pop/pop_log.h,
      src/dynamic-preprocessors/pop/pop_util.c,
      src/dynamic-preprocessors/pop/pop_util.h,
      src/dynamic-preprocessors/pop/snort_pop.c,
      src/dynamic-preprocessors/pop/snort_pop.h,
      src/dynamic-preprocessors/pop/spp_pop.c,
      src/dynamic-preprocessors/pop/spp_pop.h,
      src/dynamic-preprocessors/reputation/reputation_config.h,
      src/dynamic-preprocessors/reputation/reputation_debug.h,
      src/dynamic-preprocessors/reputation/reputation_utils.c,
      src/dynamic-preprocessors/reputation/reputation_utils.h,
      src/dynamic-preprocessors/reputation/spp_reputation.c,
      src/dynamic-preprocessors/reputation/spp_reputation.h,
      src/dynamic-preprocessors/reputation/shmem/sflinux_helpers.c,
      src/dynamic-preprocessors/reputation/shmem/sflinux_helpers.h,
      src/dynamic-preprocessors/reputation/shmem/shmem_common.h,
      src/dynamic-preprocessors/reputation/shmem/shmem_config.c,
      src/dynamic-preprocessors/reputation/shmem/shmem_config.h,
      src/dynamic-preprocessors/reputation/shmem/shmem_datamgmt.c,
      src/dynamic-preprocessors/reputation/shmem/shmem_datamgmt.h,
      src/dynamic-preprocessors/reputation/shmem/shmem_lib.c,
      src/dynamic-preprocessors/reputation/shmem/shmem_lib.h,
      src/dynamic-preprocessors/reputation/shmem/shmem_mgmt.c,
      src/dynamic-preprocessors/reputation/shmem/shmem_mgmt.h,
      src/dynamic-preprocessors/rzb_saac/spp_rzb-saac.c,
      src/dynamic-preprocessors/sdf/sdf_credit_card.c,
      src/dynamic-preprocessors/sdf/sdf_credit_card.h,
      src/dynamic-preprocessors/sdf/sdf_detection_option.c,
      src/dynamic-preprocessors/sdf/sdf_detection_option.h,
      src/dynamic-preprocessors/sdf/sdf_pattern_match.c,
      src/dynamic-preprocessors/sdf/sdf_pattern_match.h,
      src/dynamic-preprocessors/sdf/sdf_us_ssn.c,
      src/dynamic-preprocessors/sdf/sdf_us_ssn.h,
      src/dynamic-preprocessors/sdf/spp_sdf.h,
      src/dynamic-preprocessors/sip/sip_config.h,
      src/dynamic-preprocessors/sip/sip_debug.h,
      src/dynamic-preprocessors/sip/sip_dialog.c,
      src/dynamic-preprocessors/sip/sip_dialog.h,
      src/dynamic-preprocessors/sip/sip_parser.c,
      src/dynamic-preprocessors/sip/sip_parser.h,
      src/dynamic-preprocessors/sip/sip_roptions.h,
      src/dynamic-preprocessors/sip/sip_utils.c,
      src/dynamic-preprocessors/sip/sip_utils.h,
      src/dynamic-preprocessors/sip/spp_sip.c,
      src/dynamic-preprocessors/sip/spp_sip.h,
      src/dynamic-preprocessors/sip/test/sip_test.c,
      src/dynamic-preprocessors/smtp/smtp_config.c,
      src/dynamic-preprocessors/smtp/smtp_config.h,
      src/dynamic-preprocessors/smtp/smtp_log.c,
      src/dynamic-preprocessors/smtp/smtp_log.h,
      src/dynamic-preprocessors/smtp/smtp_normalize.c,
      src/dynamic-preprocessors/smtp/smtp_normalize.h,
      src/dynamic-preprocessors/smtp/smtp_util.c,
      src/dynamic-preprocessors/smtp/smtp_util.h,
      src/dynamic-preprocessors/smtp/smtp_xlink2state.c,
      src/dynamic-preprocessors/smtp/smtp_xlink2state.h,
      src/dynamic-preprocessors/smtp/snort_smtp.c,
      src/dynamic-preprocessors/smtp/snort_smtp.h,
      src/dynamic-preprocessors/smtp/spp_smtp.h,
      src/dynamic-preprocessors/ssh/spp_ssh.c,
      src/dynamic-preprocessors/ssh/spp_ssh.h,
      src/dynamic-preprocessors/ssl/spp_ssl.c,
      src/dynamic-preprocessors/ssl/spp_ssl.h,
      src/output-plugins/spo_alert_fast.c,
      src/output-plugins/spo_alert_fast.h,
      src/output-plugins/spo_alert_full.c,
      src/output-plugins/spo_alert_full.h,
      src/output-plugins/spo_alert_sf_socket.c,
      src/output-plugins/spo_alert_sf_socket.h,
      src/output-plugins/spo_alert_syslog.c,
      src/output-plugins/spo_alert_syslog.h,
      src/output-plugins/spo_alert_test.c,
      src/output-plugins/spo_alert_test.h,
      src/output-plugins/spo_alert_unixsock.h,
      src/output-plugins/spo_csv.c, src/output-plugins/spo_csv.h,
      src/output-plugins/spo_log_ascii.c,
      src/output-plugins/spo_log_ascii.h,
      src/output-plugins/spo_log_null.c,
      src/output-plugins/spo_log_null.h,
      src/output-plugins/spo_log_tcpdump.c,
      src/output-plugins/spo_log_tcpdump.h,
      src/output-plugins/spo_unified.c,
      src/output-plugins/spo_unified.h,
      src/output-plugins/spo_unified2.c,
      src/output-plugins/spo_unified2.h, src/parser/IpAddrSet.c,
      src/parser/IpAddrSet.h, src/preprocessors/normalize.c,
      src/preprocessors/normalize.h, src/preprocessors/perf-base.c,
      src/preprocessors/perf-base.h, src/preprocessors/perf-event.c,
      src/preprocessors/perf-event.h, src/preprocessors/perf-flow.c,
      src/preprocessors/perf-flow.h, src/preprocessors/perf.c,
      src/preprocessors/perf.h, src/preprocessors/portscan.c,
      src/preprocessors/portscan.h, src/preprocessors/sfprocpidstats.c,
      src/preprocessors/sfprocpidstats.h,
      src/preprocessors/snort_httpinspect.c,
      src/preprocessors/snort_httpinspect.h,
      src/preprocessors/spp_arpspoof.c,
      src/preprocessors/spp_arpspoof.h, src/preprocessors/spp_bo.c,
      src/preprocessors/spp_bo.h, src/preprocessors/spp_frag3.c,
      src/preprocessors/spp_frag3.h,
      src/preprocessors/spp_httpinspect.h,
      src/preprocessors/spp_normalize.c,
      src/preprocessors/spp_normalize.h,
      src/preprocessors/spp_perfmonitor.h,
      src/preprocessors/spp_rpc_decode.c,
      src/preprocessors/spp_rpc_decode.h,
      src/preprocessors/spp_sfportscan.c,
      src/preprocessors/spp_sfportscan.h,
      src/preprocessors/spp_stream5.c, src/preprocessors/spp_stream5.h,
      src/preprocessors/str_search.c, src/preprocessors/str_search.h,
      src/preprocessors/stream_api.c, src/preprocessors/stream_api.h,
      src/preprocessors/stream_expect.c,
      src/preprocessors/stream_expect.h,
      src/preprocessors/HttpInspect/anomaly_detection/hi_ad.c,
      src/preprocessors/HttpInspect/client/hi_client_norm.c,
      src/preprocessors/HttpInspect/event_output/hi_eo_log.c,
      src/preprocessors/HttpInspect/include/hi_ad.h,
      src/preprocessors/HttpInspect/include/hi_client.h,
      src/preprocessors/HttpInspect/include/hi_client_norm.h,
      src/preprocessors/HttpInspect/include/hi_client_stateful.h,
      src/preprocessors/HttpInspect/include/hi_cmd_lookup.h,
      src/preprocessors/HttpInspect/include/hi_eo.h,
      src/preprocessors/HttpInspect/include/hi_eo_events.h,
      src/preprocessors/HttpInspect/include/hi_eo_log.h,
      src/preprocessors/HttpInspect/include/hi_include.h,
      src/preprocessors/HttpInspect/include/hi_mi.h,
      src/preprocessors/HttpInspect/include/hi_norm.h,
      src/preprocessors/HttpInspect/include/hi_paf.h,
      src/preprocessors/HttpInspect/include/hi_reqmethod_check.h,
      src/preprocessors/HttpInspect/include/hi_return_codes.h,
      src/preprocessors/HttpInspect/include/hi_server.h,
      src/preprocessors/HttpInspect/include/hi_server_norm.h,
      src/preprocessors/HttpInspect/include/hi_si.h,
      src/preprocessors/HttpInspect/include/hi_stateful_inspect.h,
      src/preprocessors/HttpInspect/include/hi_ui_config.h,
      src/preprocessors/HttpInspect/include/hi_ui_iis_unicode_map.h,
      src/preprocessors/HttpInspect/include/hi_ui_server_lookup.h,
      src/preprocessors/HttpInspect/include/hi_uri.h,
      src/preprocessors/HttpInspect/include/hi_urilen_check.h,
      src/preprocessors/HttpInspect/include/hi_util.h,
      src/preprocessors/HttpInspect/include/hi_util_hbm.h,
      src/preprocessors/HttpInspect/include/hi_util_kmap.h,
      src/preprocessors/HttpInspect/include/hi_util_xmalloc.h,
      src/preprocessors/HttpInspect/mode_inspection/hi_mi.c,
      src/preprocessors/HttpInspect/normalization/hi_norm.c,
      src/preprocessors/HttpInspect/server/hi_server_norm.c,
      src/preprocessors/HttpInspect/session_inspection/hi_si.c,
      src/preprocessors/HttpInspect/user_interface/hi_ui_config.c,
      src/preprocessors/HttpInspect/user_interface/hi_ui_iis_unicode_map.c,
      src/preprocessors/HttpInspect/user_interface/hi_ui_server_lookup.c,
      src/preprocessors/HttpInspect/utils/hi_cmd_lookup.c,
      src/preprocessors/HttpInspect/utils/hi_paf.c,
      src/preprocessors/HttpInspect/utils/hi_util_hbm.c,
      src/preprocessors/HttpInspect/utils/hi_util_kmap.c,
      src/preprocessors/HttpInspect/utils/hi_util_xmalloc.c,
      src/preprocessors/Stream5/snort_stream5_icmp.c,
      src/preprocessors/Stream5/snort_stream5_icmp.h,
      src/preprocessors/Stream5/snort_stream5_ip.c,
      src/preprocessors/Stream5/snort_stream5_ip.h,
      src/preprocessors/Stream5/snort_stream5_session.c,
      src/preprocessors/Stream5/snort_stream5_session.h,
      src/preprocessors/Stream5/snort_stream5_tcp.c,
      src/preprocessors/Stream5/snort_stream5_tcp.h,
      src/preprocessors/Stream5/snort_stream5_udp.c,
      src/preprocessors/Stream5/snort_stream5_udp.h,
      src/preprocessors/Stream5/stream5_common.c,
      src/preprocessors/Stream5/stream5_common.h,
      src/preprocessors/Stream5/stream5_paf.c,
      src/preprocessors/Stream5/stream5_paf.h,
      src/sfutil/Unified2_common.h, src/sfutil/acsmx.c,
      src/sfutil/acsmx.h, src/sfutil/acsmx2.h, src/sfutil/asn1.c,
      src/sfutil/asn1.h, src/sfutil/bitop.h, src/sfutil/bitop_funcs.h,
      src/sfutil/bnfa_search.h, src/sfutil/getopt.h,
      src/sfutil/intel-soft-cpm.c, src/sfutil/intel-soft-cpm.h,
      src/sfutil/ipobj.c, src/sfutil/ipobj.h, src/sfutil/mpse.c,
      src/sfutil/segment_mem.c, src/sfutil/segment_mem.h,
      src/sfutil/sfActionQueue.c, src/sfutil/sfActionQueue.h,
      src/sfutil/sfPolicy.c, src/sfutil/sfPolicy.h,
      src/sfutil/sfPolicyUserData.c, src/sfutil/sfPolicyUserData.h,
      src/sfutil/sf_base64decode.c, src/sfutil/sf_base64decode.h,
      src/sfutil/sf_email_attach_decode.c,
      src/sfutil/sf_email_attach_decode.h, src/sfutil/sf_ip.c,
      src/sfutil/sf_ip.h, src/sfutil/sf_iph.h, src/sfutil/sf_ipvar.c,
      src/sfutil/sf_ipvar.h, src/sfutil/sf_seqnums.h,
      src/sfutil/sf_textlog.c, src/sfutil/sf_textlog.h,
      src/sfutil/sf_vartable.c, src/sfutil/sf_vartable.h,
      src/sfutil/sfeventq.c, src/sfutil/sfeventq.h,
      src/sfutil/sfghash.c, src/sfutil/sfghash.h,
      src/sfutil/sfhashfcn.c, src/sfutil/sfhashfcn.h,
      src/sfutil/sfksearch.c, src/sfutil/sfksearch.h,
      src/sfutil/sflsq.c, src/sfutil/sflsq.h, src/sfutil/sfmemcap.c,
      src/sfutil/sfmemcap.h, src/sfutil/sfportobject.c,
      src/sfutil/sfportobject.h, src/sfutil/sfprimetable.c,
      src/sfutil/sfprimetable.h, src/sfutil/sfrf.c, src/sfutil/sfrf.h,
      src/sfutil/sfrim.c, src/sfutil/sfrt.c, src/sfutil/sfrt.h,
      src/sfutil/sfrt_dir.c, src/sfutil/sfrt_dir.h,
      src/sfutil/sfrt_flat.c, src/sfutil/sfrt_flat.h,
      src/sfutil/sfrt_flat_dir.c, src/sfutil/sfrt_flat_dir.h,
      src/sfutil/sfrt_lctrie.c, src/sfutil/sfrt_lctrie.h,
      src/sfutil/sfrt_trie.h, src/sfutil/sfsnprintfappend.c,
      src/sfutil/sfsnprintfappend.h, src/sfutil/sfthd.c,
      src/sfutil/sfthd.h, src/sfutil/sfxhash.c, src/sfutil/sfxhash.h,
      src/sfutil/strvec.c, src/sfutil/strvec.h,
      src/sfutil/util_jsnorm.c, src/sfutil/util_jsnorm.h,
      src/sfutil/util_math.c, src/sfutil/util_math.h,
      src/sfutil/util_net.c, src/sfutil/util_net.h,
      src/sfutil/util_str.c, src/sfutil/util_str.h,
      src/sfutil/util_unfold.c, src/sfutil/util_unfold.h,
      src/sfutil/util_utf.c, src/sfutil/util_utf.h,
      src/sfutil/test/sf_ip_test.c, src/sfutil/test/sfrf_test.c,
      src/sfutil/test/sfrt_test.c, src/sfutil/test/sfthd_test.c,
      src/sfutil/test/unit_hacks.c, src/sfutil/test/unit_hacks.h,
      src/target-based/sf_attribute_table.y,
      src/target-based/sftarget_hostentry.c,
      src/target-based/sftarget_hostentry.h,
      src/target-based/sftarget_protocol_reference.c,
      src/target-based/sftarget_protocol_reference.h,
      src/target-based/sftarget_reader.c,
      src/target-based/sftarget_reader.h,
      src/win32/WIN32-Code/getopt.c, src/win32/WIN32-Code/inet_aton.c,
      src/win32/WIN32-Code/misc.c, src/win32/WIN32-Code/name.h,
      src/win32/WIN32-Code/win32_service.c,
      src/win32/WIN32-Includes/config.h,
      src/win32/WIN32-Includes/getopt.h,
      src/win32/WIN32-Includes/inttypes.h,
      src/win32/WIN32-Includes/stdint.h,
      src/win32/WIN32-Includes/WinPCAP/pthread.h,
      src/win32/WIN32-Includes/WinPCAP/sched.h,
      src/win32/WIN32-Includes/WinPCAP/semaphore.h,
      tools/control/sfcontrol.c, tools/u2boat/u2boat.c,
      tools/u2boat/u2boat.h, tools/u2spewfoo/u2spewfoo.c:
      Updated the address of the Free Software Foundation.

    * src/dynamic-preprocessors/dnp3/spp_dnp3.c:
      Check default config before dereferencing memcap.

    * src/preprocessors/Stream5/snort_stream5_tcp.c:
      fix handling of gaps in PAF.

    * src/dynamic-preprocessors/smtp/: smtp_util.c, snort_smtp.c,
      snort_smtp.h:
      get individual file names for multiple file attachments within
      one smtp packet

    * src/dynamic-output/plugins/output_plugin.c:
      Don't change vlanId into network byte order in the dynamic output API.

    * src/dynamic-preprocessors/imap/: snort_imap.c, snort_imap.h:
      Add a flag to indicate end of MIME to avoid incorrect data end marker

    * src/sfutil/sf_email_attach_decode.h:
      change decode length calculation when file depth is larger than max int

    * src/: preprocessors/HttpInspect/include/hi_paf.h,
      sfutil/sf_email_attach_decode.h,
      preprocessors/HttpInspect/utils/hi_paf.c:
      auto enable http ports when file policy is enabled

    * src/sfutil/sfthd.c:
      Global thresholds can be disabled with count -1.

    * src/sfutil/sfthd.c:
      allow gen_id 0 sig_id 0 and gen_id X sig_id 0 together

    * src/: decode.h, preprocessors/snort_httpinspect.c:
      file data is only valid with PAF processing

    * src/preprocessors/Stream5/snort_stream5_tcp.c:
      don't flag missing packets when PAF flushing to allow better recovery
      from gaps

    * src/dynamic-preprocessors/: smtp/smtp_config.c,
      imap/imap_config.c, imap/spp_imap.c, pop/pop_config.c,
      pop/spp_pop.c:
      Enable file data configurations for preprocessors when file processing
      is enabled

    * src/preprocessors/Stream5/snort_stream5_tcp.c:
      fixed check for hole in seglist while PAF scanning

    * src/: snort.c, dynamic-examples/Makefile.am,
      dynamic-plugins/Makefile.am, dynamic-preprocessors/Makefile.am,
      dynamic-preprocessors/sf_dynamic_initialize/sf_dynamic_initialize.dsp,
      preprocessors/spp_stream5.c, target-based/Makefile.am,
      target-based/sftarget_reader.c, target-based/sftarget_reader.h:
      Add an API call to add a service to a host in the attribute table.
      Remove the unused live attribute table code.

    * doc/README.ppm, doc/snort_manual.tex, etc/gen-msg.map,
      preproc_rules/preprocessor.rules, src/detect.c, src/generators.h,
      src/parser.c, src/ppm.c, src/ppm.h:
      added 134:3 and IPs and ports to log messages for PPM packet events

    * src/snort.c:
      force drop TCP/UDP now gets DAQ blacklist instead of DAQ block verdict

    * doc/README.stream5, etc/gen-msg.map,
      preproc_rules/preprocessor.rules, src/generators.h,
      src/preprocessors/Stream5/snort_stream5_tcp.c:
      add 129:20 for midstream traffic we don't pick up.

    * src/preprocessors/Stream5/snort_stream5_tcp.c:
      fix normalize_tcp to not block duplicate SYNs

    * src/parser.c, src/snort.c, src/preprocessors/snort_httpinspect.c,
      src/preprocessors/snort_httpinspect.h, src/snort.h,
      src/dynamic-preprocessors/smtp/smtp_config.h,
      src/dynamic-preprocessors/smtp/snort_smtp.c,
      src/dynamic-preprocessors/imap/imap_config.h,
      src/dynamic-preprocessors/imap/snort_imap.c,
      src/dynamic-preprocessors/imap/spp_imap.c,
      src/dynamic-preprocessors/pop/pop_config.h,
      src/dynamic-preprocessors/pop/snort_pop.c,
      src/dynamic-preprocessors/pop/spp_pop.c,
      src/sfutil/sf_email_attach_decode.h,
      src/preprocessors/HttpInspect/include/hi_ui_config.h,
      configure.in, src/detection-plugins/sp_file_data.c:
      file_depth integration, openssl integration, reload configuration

    * src/dynamic-preprocessors/: libs/ssl.c, libs/ssl.h,
      ssl/spp_ssl.c:
      Add SSLv3/TLS backwards compatibiltiy with SSLv2 ClientHello in the
      ssl preprocessor.

    * src/: preprocessors/snort_httpinspect.c,
      src/dynamic-preprocessors/: imap/snort_imap.c, pop/snort_pop.c,
      smtp/snort_smtp.c:
      add file type id support for HTTP post, smtp, imap, and pop

    * src/: snort_debug.h, control/sfcontrol.c,
      preprocessors/Stream5/snort_stream5_tcp.c:
      Do not delete application session data on last ACK.

    * src/output-plugins/spo_unified.c:
      Add deprecated warning for unified output plugin.

    * src/decode.h:
      Add support for decoding PPP type 0x57 (IPv6) for PPPoE

    * src/Makefile.am, src/generators.h, src/parser.c, src/parser.h,
      src/preprocids.h, src/snort.c, src/snort_debug.h, configure.in,
      src/dynamic-preprocessors/Makefile.am,
      src/preprocessors/snort_httpinspect.c,
      src/detection-plugins/sp_file_data.c,
      src/dynamic-examples/Makefile.am:
      add file type identification and file signature sha256 calculation
      for HTTP.

    * src/: util.c, dynamic-preprocessors/dcerpc2/spp_dce2.c,
      dynamic-preprocessors/dnp3/spp_dnp3.c,
      dynamic-preprocessors/dns/spp_dns.c,
      dynamic-preprocessors/ftptelnet/spp_ftptelnet.c,
      dynamic-preprocessors/gtp/spp_gtp.c,
      dynamic-preprocessors/imap/spp_imap.c,
      dynamic-preprocessors/isakmp/spp_isakmp.c,
      dynamic-preprocessors/modbus/spp_modbus.c,
      dynamic-preprocessors/pop/spp_pop.c,
      dynamic-preprocessors/reputation/spp_reputation.c,
      dynamic-preprocessors/sip/spp_sip.c,
      dynamic-preprocessors/ssh/spp_ssh.c,
      dynamic-preprocessors/ssl/spp_ssl.c:
      Remove IPv6 tag from snort -V

    * configure.in, doc/README.ipv6, doc/README.unified2,
      doc/README.variables, doc/snort_manual.tex, src/decode.h,
      src/detect.c, src/detect.h, src/encode.c, src/fpdetect.c,
      src/ipv6_port.h, src/log.c, src/log_text.c, src/parser.c,
      src/sf_protocols.h, src/snort.c, src/snort.h, src/tag.c,
      src/util.c, src/util.h, src/detection-plugins/sp_ftpbounce.c,
      src/detection-plugins/sp_icmp_id_check.c,
      src/detection-plugins/sp_icmp_seq_check.c,
      src/detection-plugins/sp_ip_same_check.c,
      src/detection-plugins/sp_session.c,
      src/dynamic-plugins/sf_engine/sf_snort_packet.h,
      src/dynamic-preprocessors/dynamic_preprocessors.dsp,
      src/dynamic-preprocessors/dcerpc2/dce2_config.c,
      src/dynamic-preprocessors/dcerpc2/sf_dce2.dsp,
      src/dynamic-preprocessors/dcerpc2/snort_dce2.c,
      src/dynamic-preprocessors/dcerpc2/spp_dce2.c,
      src/dynamic-preprocessors/dnp3/sf_dnp3.dsp,
      src/dynamic-preprocessors/dnp3/spp_dnp3.c,
      src/dynamic-preprocessors/dns/sf_dns.dsp,
      src/dynamic-preprocessors/dns/spp_dns.c,
      src/dynamic-preprocessors/ftptelnet/ftpp_si.c,
      src/dynamic-preprocessors/ftptelnet/ftpp_ui_client_lookup.c,
      src/dynamic-preprocessors/ftptelnet/ftpp_ui_server_lookup.c,
      src/dynamic-preprocessors/ftptelnet/pp_ftp.c,
      src/dynamic-preprocessors/ftptelnet/sf_ftptelnet.dsp,
      src/dynamic-preprocessors/ftptelnet/snort_ftptelnet.c,
      src/dynamic-preprocessors/ftptelnet/spp_ftptelnet.c,
      src/dynamic-preprocessors/gtp/sf_gtp.dsp,
      src/dynamic-preprocessors/gtp/spp_gtp.c,
      src/dynamic-preprocessors/imap/sf_imap.dsp,
      src/dynamic-preprocessors/imap/spp_imap.c,
      src/dynamic-preprocessors/isakmp/spp_isakmp.c,
      src/dynamic-preprocessors/libs/sfdynamic_preproc_libs.dsp,
      src/dynamic-preprocessors/modbus/sf_modbus.dsp,
      src/dynamic-preprocessors/modbus/spp_modbus.c,
      src/dynamic-preprocessors/pop/sf_pop.dsp,
      src/dynamic-preprocessors/pop/spp_pop.c,
      src/dynamic-preprocessors/reputation/sf_reputation.dsp,
      src/dynamic-preprocessors/reputation/spp_reputation.c,
      src/dynamic-preprocessors/sdf/sf_sdf.dsp,
      src/dynamic-preprocessors/sf_dynamic_initialize/sf_dynamic_initialize.dsp,
      src/dynamic-preprocessors/sip/sf_sip.dsp,
      src/dynamic-preprocessors/sip/sip_dialog.c,
      src/dynamic-preprocessors/sip/spp_sip.c,
      src/dynamic-preprocessors/smtp/sf_smtp.dsp,
      src/dynamic-preprocessors/ssh/sf_ssh.dsp,
      src/dynamic-preprocessors/ssh/spp_ssh.c,
      src/dynamic-preprocessors/ssl/sf_ssl.dsp,
      src/dynamic-preprocessors/ssl/spp_ssl.c,
      src/output-plugins/spo_alert_sf_socket.c,
      src/output-plugins/spo_log_ascii.c,
      src/output-plugins/spo_unified2.c, src/parser/IpAddrSet.c,
      src/parser/IpAddrSet.h, src/preprocessors/normalize.c,
      src/preprocessors/perf-base.c, src/preprocessors/perf-base.h,
      src/preprocessors/perf-flow.c, src/preprocessors/portscan.c,
      src/preprocessors/snort_httpinspect.c,
      src/preprocessors/spp_arpspoof.c, src/preprocessors/spp_frag3.c,
      src/preprocessors/spp_normalize.c,
      src/preprocessors/spp_normalize.h,
      src/preprocessors/spp_sfportscan.c,
      src/preprocessors/spp_stream5.c,
      src/preprocessors/stream_expect.c,
      src/preprocessors/HttpInspect/session_inspection/hi_si.c,
      src/preprocessors/HttpInspect/user_interface/hi_ui_server_lookup.c,
      src/preprocessors/Stream5/snort_stream5_icmp.c,
      src/preprocessors/Stream5/snort_stream5_session.c,
      src/preprocessors/Stream5/snort_stream5_tcp.c,
      src/preprocessors/Stream5/snort_stream5_udp.c,
      src/preprocessors/Stream5/stream5_common.c,
      src/preprocessors/Stream5/stream5_common.h, src/sfutil/ipobj.c,
      src/sfutil/ipobj.h, src/sfutil/sfPolicy.c, src/sfutil/sf_ip.h,
      src/sfutil/sf_iph.h, src/sfutil/sf_ipvar.h, src/sfutil/sfrf.c,
      src/sfutil/sfrt.c, src/sfutil/sfrt.h, src/sfutil/sfrt_dir.c,
      src/sfutil/sfrt_flat.c, src/sfutil/sfrt_flat.h,
      src/sfutil/sfrt_flat_dir.c, src/sfutil/sfthd.c,
      src/sfutil/util_net.c, src/sfutil/util_net.h,
      src/sfutil/test/Makefile.am, src/sfutil/test/sfrf_test.c,
      src/sfutil/test/sfthd_test.c, src/sfutil/test/unit_hacks.c,
      src/sfutil/test/unit_hacks.h,
      src/target-based/sf_attribute_table.y,
      src/target-based/sftarget_reader.c,
      src/target-based/sftarget_reader.h,
      src/win32/WIN32-Prj/build_all.dsp,
      src/win32/WIN32-Prj/sf_engine.dsp,
      src/win32/WIN32-Prj/sf_engine_initialize.dsp,
      src/win32/WIN32-Prj/snort.dsp,
      src/win32/WIN32-Prj/snort_initialize.dsp,
      src/win32/WIN32-Prj/snort_installer.nsi:
      Remove IPv4 only code paths

2012-07-30 Hui Cao <hcao@sourcefire.com>
Snort 2.9.3.1
    * src/build.h:
      Updated build number to 40

    * src/sfutil/acsmx2.c:
      Release memory during return.

    * src/dynamic-preprocessors/sip/sip_config.c:
      Free method struct when method->methodName is NULL.

    * src/: detection-plugins/detection_options.c,
      detection-plugins/sp_byte_check.c,
